/* A Bison parser, made by GNU Bison 2.7.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         cf_parse
#define yylex           cf_lex
#define yyerror         cf_error
#define yylval          cf_lval
#define yychar          cf_char
#define yydebug         cf_debug
#define yynerrs         cf_nerrs

/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 1 "cf-parse.y"

/* Headers from ../../conf/confbase.Y */

#define PARSER 1

#include "nest/bird.h"
#include "conf/conf.h"
#include "lib/resource.h"
#include "lib/socket.h"
#include "lib/timer.h"
#include "lib/string.h"
#include "nest/protocol.h"
#include "nest/iface.h"
#include "nest/route.h"
#include "nest/cli.h"
#include "filter/filter.h"

/* FIXME: Turn on YYERROR_VERBOSE and work around lots of bison bugs? */

/* Defines from ../../conf/confbase.Y */

static void
check_u16(unsigned val)
{
  if (val > 0xFFFF)
    cf_error("Value %d out of range (0-65535)", val);
}

/* Headers from ../../sysdep/unix/config.Y */

#include "lib/unix.h"
#include <stdio.h>

/* Headers from ../../sysdep/unix/krt.Y */

#include "lib/krt.h"

/* Defines from ../../sysdep/unix/krt.Y */

#define THIS_KRT ((struct krt_config *) this_proto)
#define THIS_KIF ((struct kif_config *) this_proto)

/* Headers from ../../sysdep/linux/netlink.Y */

/* Headers from ../../nest/config.Y */

#include "nest/rt-dev.h"
#include "nest/password.h"
#include "nest/cmds.h"
#include "lib/lists.h"

/* Defines from ../../nest/config.Y */

static struct proto_config *this_proto;
static struct iface_patt *this_ipatt;
static struct iface_patt_node *this_ipn;
static struct roa_table_config *this_roa_table;
static list *this_p_list;
static struct password_item *this_p_item;
static int password_id;

static void
iface_patt_check(void)
{
  struct iface_patt_node *pn;

  WALK_LIST(pn, this_ipatt->ipn_list)
    if (!pn->pattern || pn->pxlen)
      cf_error("Interface name/mask expected, not IP prefix");
}


static inline void
reset_passwords(void)
{
  this_p_list = NULL;
}

static inline list *
get_passwords(void)
{
  list *rv = this_p_list;
  this_p_list = NULL;
  return rv;
}

#define DIRECT_CFG ((struct rt_dev_config *) this_proto)

/* Headers from ../../filter/config.Y */

/* Defines from ../../filter/config.Y */

#define P(a,b) ((a << 8) | b)

static inline u32 pair(u32 a, u32 b) { return (a << 16) | b; }
static inline u32 pair_a(u32 p) { return p >> 16; }
static inline u32 pair_b(u32 p) { return p & 0xFFFF; }


/*
 * Sets and their items are during parsing handled as lists, linked
 * through left ptr. The first item in a list also contains a pointer
 * to the last item in a list (right ptr). For convenience, even items
 * are handled as one-item lists. Lists are merged by f_merge_items().
 */

static inline struct f_tree *
f_new_item(struct f_val from, struct f_val to)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from = from;
  t->to = to;
  return t;
}

static inline struct f_tree *
f_merge_items(struct f_tree *a, struct f_tree *b)
{
  if (!a) return b;
  a->right->left = b;
  a->right = b->right;
  b->right = NULL;
  return a;
}

static inline struct f_tree *
f_new_pair_item(int fa, int ta, int fb, int tb)
{
  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_PAIR;
  t->from.val.i = pair(fa, fb);
  t->to.val.i = pair(ta, tb);
  return t;
}

static inline struct f_tree *
f_new_pair_set(int fa, int ta, int fb, int tb)
{
  struct f_tree *lst = NULL;
  int i;

  if ((fa == ta) || ((fb == 0) && (tb == 0xFFFF)))
    return f_new_pair_item(fa, ta, fb, tb);
  
  if ((ta < fa) || (tb < fb))
    cf_error( "From value cannot be higher that To value in pair sets");

  for (i = fa; i <= ta; i++)
    lst = f_merge_items(lst, f_new_pair_item(i, i, fb, tb));

  return lst;
}

#define EC_ALL 0xFFFFFFFF

static struct f_tree *
f_new_ec_item(u32 kind, u32 ipv4_used, u32 key, u32 vf, u32 vt)
{
  u64 fm, to;

  if (ipv4_used || (key >= 0x10000)) {
    check_u16(vf);
    if (vt == EC_ALL)
      vt = 0xFFFF;
    else
      check_u16(vt);
  }

  if (kind == EC_GENERIC) {
    fm = ec_generic(key, vf);
    to = ec_generic(key, vt);
  }
  else if (ipv4_used) {
    fm = ec_ip4(kind, key, vf);
    to = ec_ip4(kind, key, vt);
  }
  else if (key < 0x10000) {
    fm = ec_as2(kind, key, vf);
    to = ec_as2(kind, key, vt);
  }
  else {
    fm = ec_as4(kind, key, vf);
    to = ec_as4(kind, key, vt);
  }

  struct f_tree *t = f_new_tree();
  t->right = t;
  t->from.type = t->to.type = T_EC;
  t->from.val.ec = fm;
  t->to.val.ec = to;
  return t;
}

static inline struct f_inst *
f_generate_empty(struct f_inst *dyn)
{ 
  struct f_inst *e = f_new_inst();
  e->code = 'E';

  switch (dyn->aux & EAF_TYPE_MASK) {
    case EAF_TYPE_AS_PATH:
      e->aux = T_PATH;
      break;
    case EAF_TYPE_INT_SET:
      e->aux = T_CLIST;
      break;
    case EAF_TYPE_EC_SET:
      e->aux = T_ECLIST;
      break;
    default:
      cf_error("Can't empty that attribute");
  }

  dyn->code = P('e','S');
  dyn->a1.p = e;
  return dyn;
}


static inline struct f_inst *
f_generate_dpair(struct f_inst *t1, struct f_inst *t2)
{
  struct f_inst *rv;

  if ((t1->code == 'c') && (t2->code == 'c')) {
    if ((t1->aux != T_INT) || (t2->aux != T_INT))
      cf_error( "Can't operate with value of non-integer type in pair constructor");

    check_u16(t1->a2.i);
    check_u16(t2->a2.i);

    rv = f_new_inst();
    rv->code = 'c';
    rv->aux = T_PAIR;
    rv->a2.i = pair(t1->a2.i, t2->a2.i);
  }
  else {
    rv = f_new_inst();
    rv->code = P('m', 'p');
    rv->a1.p = t1;
    rv->a2.p = t2;
  }

  return rv;
}

static inline struct f_inst *
f_generate_ec(u16 kind, struct f_inst *tk, struct f_inst *tv)
{
  struct f_inst *rv;
  int c1 = 0, c2 = 0, ipv4_used = 0;
  u32 key = 0, val2 = 0;

  if (tk->code == 'c') {
    c1 = 1;

    if (tk->aux == T_INT) {
      ipv4_used = 0; key = tk->a2.i;
    }
    else if (tk->aux == T_QUAD) {
      ipv4_used = 1; key = tk->a2.i;
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }

#ifndef IPV6
  /* IP->Quad implicit conversion */
  else if (tk->code == 'C') {
    c1 = 1;
    struct f_val *val = tk->a1.p;

    if (val->type == T_INT) {
      ipv4_used = 0; key = val->val.i;
    }
    else if (val->type == T_QUAD) {
      ipv4_used = 1; key = val->val.i;
    }
    else if (val->type == T_IP) {
      ipv4_used = 1; key = ipa_to_u32(val->val.px.ip);
    }
    else
      cf_error("Can't operate with key of non-integer/IPv4 type in EC constructor");
  }
#endif

  if (tv->code == 'c') {
    if (tv->aux != T_INT)
      cf_error("Can't operate with value of non-integer type in EC constructor");
    c2 = 1;
    val2 = tv->a2.i;
  }

  if (c1 && c2) {
    u64 ec;
  
    if (kind == EC_GENERIC) {
      ec = ec_generic(key, val2);
    }
    else if (ipv4_used) {
      check_u16(val2);
      ec = ec_ip4(kind, key, val2);
    }
    else if (key < 0x10000) {
      ec = ec_as2(kind, key, val2);
    }
    else {
      check_u16(val2);
      ec = ec_as4(kind, key, val2);
    }

    NEW_F_VAL;
    rv = f_new_inst();
    rv->code = 'C';
    rv->a1.p = val;    
    val->type = T_EC;
    val->val.ec = ec;
  }
  else {
    rv = f_new_inst();
    rv->code = P('m','c');
    rv->aux = kind;
    rv->a1.p = tk;
    rv->a2.p = tv;
  }

  return rv;
}



/* Headers from ../../proto/bfd/config.Y */

#include "proto/bfd/bfd.h"

/* Defines from ../../proto/bfd/config.Y */

#define BFD_CFG ((struct bfd_config *) this_proto)
#define BFD_IFACE ((struct bfd_iface_config *) this_ipatt)
#define BFD_NEIGHBOR this_bfd_neighbor

static struct bfd_neighbor *this_bfd_neighbor;

extern struct bfd_config *bfd_cf;

/* Headers from ../../proto/bgp/config.Y */

#include "proto/bgp/bgp.h"

/* Defines from ../../proto/bgp/config.Y */

#define BGP_CFG ((struct bgp_config *) this_proto)

/* Headers from ../../proto/ospf/config.Y */

#include "proto/ospf/ospf.h"

/* Defines from ../../proto/ospf/config.Y */

#define OSPF_CFG ((struct ospf_config *) this_proto)
#define OSPF_PATT ((struct ospf_iface_patt *) this_ipatt)

static struct ospf_area_config *this_area;
static struct nbma_node *this_nbma;
static list *this_nets;
static struct area_net_config *this_pref;
static struct ospf_stubnet_config *this_stubnet; 

#ifdef OSPFv2
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  ip->passwords = get_passwords();

  if ((ip->autype == OSPF_AUTH_CRYPT) && (ip->helloint < 5))
    log(L_WARN "Hello or poll interval less that 5 makes cryptographic authenication prone to replay attacks");

  if ((ip->autype == OSPF_AUTH_NONE) && (ip->passwords != NULL))
    log(L_WARN "Password option without authentication option does not make sense");
}
#endif

#ifdef OSPFv3
static void
ospf_iface_finish(void)
{
  struct ospf_iface_patt *ip = OSPF_PATT;

  if (ip->deadint == 0)
    ip->deadint = ip->deadc * ip->helloint;

  if ((ip->autype != OSPF_AUTH_NONE) || (get_passwords() != NULL))
    cf_error("Authentication not supported in OSPFv3");
}
#endif

static void
ospf_area_finish(void)
{
  if ((this_area->areaid == 0) && (this_area->type != OPT_E))
    cf_error("Backbone area cannot be stub/NSSA");

  if (this_area->summary && (this_area->type == OPT_E))
    cf_error("Only Stub/NSSA areas can use summary propagation");

  if (this_area->default_nssa && ((this_area->type != OPT_N) || ! this_area->summary))
    cf_error("Only NSSA areas with summary propagation can use NSSA default route");

  if ((this_area->default_cost & LSA_EXT_EBIT) && ! this_area->default_nssa)
    cf_error("Only NSSA default route can use type 2 metric");
}

static void
ospf_proto_finish(void)
{
  struct ospf_config *cf = OSPF_CFG;

  if (EMPTY_LIST(cf->area_list))
    cf_error( "No configured areas in OSPF");

  int areano = 0;
  int backbone = 0;
  struct ospf_area_config *ac;
  WALK_LIST(ac, cf->area_list)
  {
    areano++;
    if (ac->areaid == 0)
     backbone = 1;
  }
  cf->abr = areano > 1;

  if (cf->abr && !backbone)
  {
    struct ospf_area_config *ac = cfg_allocz(sizeof(struct ospf_area_config));
    ac->type = OPT_E; /* Backbone is non-stub */
    add_head(&cf->area_list, NODE ac);
    init_list(&ac->patt_list);
    init_list(&ac->net_list);
    init_list(&ac->enet_list);
    init_list(&ac->stubnet_list);
  }

  if (!cf->abr && !EMPTY_LIST(cf->vlink_list))
    cf_error( "Vlinks cannot be used on single area router");
}

static inline void
check_defcost(int cost)
{
  if ((cost <= 0) || (cost >= LSINFINITY))
   cf_error("Default cost must be in range 1-%d", LSINFINITY-1);
}

static inline void
set_instance_id(unsigned id)
{
#ifdef OSPFv3
  OSPF_PATT->instance_id = id;
#else
  cf_error("Instance ID requires OSPFv3");
#endif
}

/* Headers from ../../proto/pipe/config.Y */

#include "proto/pipe/pipe.h"

/* Defines from ../../proto/pipe/config.Y */

#define PIPE_CFG ((struct pipe_config *) this_proto)

/* Headers from ../../proto/rip/config.Y */

#include "proto/rip/rip.h"
#include "nest/iface.h"

/* Defines from ../../proto/rip/config.Y */

#define RIP_CFG ((struct rip_proto_config *) this_proto)
#define RIP_IPATT ((struct rip_patt *) this_ipatt)

#ifdef IPV6
#define RIP_DEFAULT_TTL_SECURITY 2
#else
#define RIP_DEFAULT_TTL_SECURITY 0
#endif

/* Headers from ../../proto/static/config.Y */

#include "proto/static/static.h"

/* Defines from ../../proto/static/config.Y */

#define STATIC_CFG ((struct static_config *) this_proto)
static struct static_route *this_srt, *this_srt_nh, *last_srt_nh;


/* Line 371 of yacc.c  */
#line 580 "cf-parse.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "cf-parse.tab.h".  */
#ifndef YY_CF_CF_PARSE_TAB_H_INCLUDED
# define YY_CF_CF_PARSE_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int cf_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     END = 258,
     CLI_MARKER = 259,
     INVALID_TOKEN = 260,
     ELSECOL = 261,
     DDOT = 262,
     GEQ = 263,
     LEQ = 264,
     NEQ = 265,
     AND = 266,
     OR = 267,
     PO = 268,
     PC = 269,
     NUM = 270,
     ENUM = 271,
     RTRID = 272,
     IPA = 273,
     SYM = 274,
     TEXT = 275,
     PREFIX_DUMMY = 276,
     DEFINE = 277,
     ON = 278,
     OFF = 279,
     YES = 280,
     NO = 281,
     S = 282,
     MS = 283,
     US = 284,
     LOG = 285,
     SYSLOG = 286,
     ALL = 287,
     DEBUG = 288,
     TRACE = 289,
     INFO = 290,
     REMOTE = 291,
     WARNING = 292,
     ERROR = 293,
     AUTH = 294,
     FATAL = 295,
     BUG = 296,
     STDERR = 297,
     SOFT = 298,
     TIMEFORMAT = 299,
     ISO = 300,
     OLD = 301,
     SHORT = 302,
     LONG = 303,
     BASE = 304,
     NAME = 305,
     CONFIRM = 306,
     UNDO = 307,
     CHECK = 308,
     TIMEOUT = 309,
     CONFIGURE = 310,
     DOWN = 311,
     KERNEL = 312,
     PERSIST = 313,
     SCAN = 314,
     TIME = 315,
     LEARN = 316,
     DEVICE = 317,
     ROUTES = 318,
     GRACEFUL = 319,
     RESTART = 320,
     KRT_SOURCE = 321,
     KRT_METRIC = 322,
     TABLE = 323,
     KRT_PREFSRC = 324,
     KRT_REALM = 325,
     ROUTER = 326,
     ID = 327,
     PROTOCOL = 328,
     TEMPLATE = 329,
     PREFERENCE = 330,
     DISABLED = 331,
     DIRECT = 332,
     INTERFACE = 333,
     IMPORT = 334,
     EXPORT = 335,
     FILTER = 336,
     NONE = 337,
     STATES = 338,
     FILTERS = 339,
     RECEIVE = 340,
     LIMIT = 341,
     ACTION = 342,
     WARN = 343,
     BLOCK = 344,
     DISABLE = 345,
     KEEP = 346,
     FILTERED = 347,
     PASSWORD = 348,
     FROM = 349,
     PASSIVE = 350,
     TO = 351,
     EVENTS = 352,
     PACKETS = 353,
     PROTOCOLS = 354,
     INTERFACES = 355,
     PRIMARY = 356,
     STATS = 357,
     COUNT = 358,
     FOR = 359,
     COMMANDS = 360,
     PREEXPORT = 361,
     GENERATE = 362,
     ROA = 363,
     MAX = 364,
     FLUSH = 365,
     AS = 366,
     LISTEN = 367,
     BGP = 368,
     V6ONLY = 369,
     DUAL = 370,
     ADDRESS = 371,
     PORT = 372,
     PASSWORDS = 373,
     DESCRIPTION = 374,
     SORTED = 375,
     RELOAD = 376,
     IN = 377,
     OUT = 378,
     MRTDUMP = 379,
     MESSAGES = 380,
     RESTRICT = 381,
     MEMORY = 382,
     IGP_METRIC = 383,
     CLASS = 384,
     DSCP = 385,
     WAIT = 386,
     SHOW = 387,
     STATUS = 388,
     SUMMARY = 389,
     ROUTE = 390,
     SYMBOLS = 391,
     ADD = 392,
     DELETE = 393,
     DUMP = 394,
     RESOURCES = 395,
     SOCKETS = 396,
     NEIGHBORS = 397,
     ATTRIBUTES = 398,
     EVAL = 399,
     ECHO = 400,
     ENABLE = 401,
     FUNCTION = 402,
     PRINT = 403,
     PRINTN = 404,
     UNSET = 405,
     RETURN = 406,
     ACCEPT = 407,
     REJECT = 408,
     QUITBIRD = 409,
     INT = 410,
     BOOL = 411,
     IP = 412,
     PREFIX = 413,
     PAIR = 414,
     QUAD = 415,
     EC = 416,
     SET = 417,
     STRING = 418,
     BGPMASK = 419,
     BGPPATH = 420,
     CLIST = 421,
     ECLIST = 422,
     IF = 423,
     THEN = 424,
     ELSE = 425,
     CASE = 426,
     TRUE = 427,
     FALSE = 428,
     RT = 429,
     RO = 430,
     UNKNOWN = 431,
     GENERIC = 432,
     GW = 433,
     NET = 434,
     MASK = 435,
     PROTO = 436,
     SOURCE = 437,
     SCOPE = 438,
     CAST = 439,
     DEST = 440,
     IFNAME = 441,
     IFINDEX = 442,
     LEN = 443,
     DEFINED = 444,
     CONTAINS = 445,
     RESET = 446,
     PREPEND = 447,
     FIRST = 448,
     LAST = 449,
     MATCH = 450,
     ROA_CHECK = 451,
     EMPTY = 452,
     WHERE = 453,
     BFD = 454,
     MIN = 455,
     IDLE = 456,
     RX = 457,
     TX = 458,
     INTERVAL = 459,
     MULTIPLIER = 460,
     MULTIHOP = 461,
     NEIGHBOR = 462,
     DEV = 463,
     LOCAL = 464,
     SESSIONS = 465,
     HOLD = 466,
     CONNECT = 467,
     RETRY = 468,
     KEEPALIVE = 469,
     STARTUP = 470,
     VIA = 471,
     NEXT = 472,
     HOP = 473,
     SELF = 474,
     DEFAULT = 475,
     PATH = 476,
     METRIC = 477,
     START = 478,
     DELAY = 479,
     FORGET = 480,
     AFTER = 481,
     BGP_PATH = 482,
     BGP_LOCAL_PREF = 483,
     BGP_MED = 484,
     BGP_ORIGIN = 485,
     BGP_NEXT_HOP = 486,
     BGP_ATOMIC_AGGR = 487,
     BGP_AGGREGATOR = 488,
     BGP_COMMUNITY = 489,
     BGP_EXT_COMMUNITY = 490,
     RR = 491,
     RS = 492,
     CLIENT = 493,
     CLUSTER = 494,
     AS4 = 495,
     ADVERTISE = 496,
     IPV4 = 497,
     CAPABILITIES = 498,
     PREFER = 499,
     OLDER = 500,
     MISSING = 501,
     LLADDR = 502,
     DROP = 503,
     IGNORE = 504,
     REFRESH = 505,
     INTERPRET = 506,
     COMMUNITIES = 507,
     BGP_ORIGINATOR_ID = 508,
     BGP_CLUSTER_LIST = 509,
     IGP = 510,
     GATEWAY = 511,
     RECURSIVE = 512,
     MED = 513,
     TTL = 514,
     SECURITY = 515,
     DETERMINISTIC = 516,
     SECONDARY = 517,
     ALLOW = 518,
     PATHS = 519,
     AWARE = 520,
     OSPF = 521,
     AREA = 522,
     OSPF_METRIC1 = 523,
     OSPF_METRIC2 = 524,
     OSPF_TAG = 525,
     OSPF_ROUTER_ID = 526,
     RFC1583COMPAT = 527,
     STUB = 528,
     TICK = 529,
     COST = 530,
     COST2 = 531,
     RETRANSMIT = 532,
     HELLO = 533,
     TRANSMIT = 534,
     PRIORITY = 535,
     DEAD = 536,
     TYPE = 537,
     BROADCAST = 538,
     BCAST = 539,
     NONBROADCAST = 540,
     NBMA = 541,
     POINTOPOINT = 542,
     PTP = 543,
     POINTOMULTIPOINT = 544,
     PTMP = 545,
     SIMPLE = 546,
     AUTHENTICATION = 547,
     STRICT = 548,
     CRYPTOGRAPHIC = 549,
     ELIGIBLE = 550,
     POLL = 551,
     NETWORKS = 552,
     HIDDEN = 553,
     VIRTUAL = 554,
     LINK = 555,
     ONLY = 556,
     BUFFER = 557,
     LARGE = 558,
     NORMAL = 559,
     STUBNET = 560,
     TAG = 561,
     EXTERNAL = 562,
     LSADB = 563,
     ECMP = 564,
     WEIGHT = 565,
     NSSA = 566,
     TRANSLATOR = 567,
     STABILITY = 568,
     GLOBAL = 569,
     LSID = 570,
     INSTANCE = 571,
     REAL = 572,
     NETMASK = 573,
     LENGTH = 574,
     TOPOLOGY = 575,
     STATE = 576,
     PIPE = 577,
     PEER = 578,
     MODE = 579,
     OPAQUE = 580,
     TRANSPARENT = 581,
     RIP = 582,
     INFINITY = 583,
     PERIOD = 584,
     GARBAGE = 585,
     MULTICAST = 586,
     QUIET = 587,
     NOLISTEN = 588,
     VERSION1 = 589,
     PLAINTEXT = 590,
     MD5 = 591,
     HONOR = 592,
     NEVER = 593,
     ALWAYS = 594,
     RIP_METRIC = 595,
     RIP_TAG = 596,
     STATIC = 597,
     PROHIBIT = 598,
     MULTIPATH = 599,
     BLACKHOLE = 600,
     UNREACHABLE = 601
   };
#endif


#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 508 "cf-parse.y"

  int i;
  u32 i32;
  ip_addr a;
  struct symbol *s;
  char *t;
  struct rtable_config *r;
  struct f_inst *x;
  struct filter *f;
  struct f_tree *e;
  struct f_trie *trie;
  struct f_val v;
  struct f_path_mask *h;
  struct password_item *p;
  struct rt_show_data *ra;
  struct roa_show_data *ro;
  struct sym_show_data *sd;
  struct lsadb_show_data *ld;
  struct iface *iface;
  struct roa_table *rot;
  void *g;
  bird_clock_t time;
  struct prefix px;
  struct proto_spec ps;
  struct timeformat *tf;


/* Line 387 of yacc.c  */
#line 997 "cf-parse.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE cf_lval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int cf_parse (void *YYPARSE_PARAM);
#else
int cf_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int cf_parse (void);
#else
int cf_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_CF_CF_PARSE_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 1025 "cf-parse.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef __attribute__
/* This feature is available in gcc versions 2.5 and later.  */
# if (! defined __GNUC__ || __GNUC__ < 2 \
      || (__GNUC__ == 2 && __GNUC_MINOR__ < 5))
#  define __attribute__(Spec) /* empty */
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif


/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  67
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2739

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  368
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  255
/* YYNRULES -- Number of rules.  */
#define YYNRULES  830
/* YYNRULES -- Number of states.  */
#define YYNSTATES  1569

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   601

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    31,     2,     2,     2,    30,     2,     2,
     359,   360,    28,    26,   364,    27,    32,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   361,   358,
      23,    22,    24,   365,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   366,     2,   367,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   362,     2,   363,    25,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,     9,    10,    13,    19,    21,    25,
      27,    30,    33,    36,    38,    40,    42,    44,    46,    47,
      49,    51,    52,    55,    58,    60,    62,    65,    68,    70,
      72,    73,    78,    81,    82,    84,    87,    89,    91,    95,
      97,   101,   103,   105,   107,   109,   111,   113,   115,   117,
     119,   124,   128,   130,   132,   134,   136,   139,   144,   148,
     152,   156,   160,   164,   169,   175,   179,   183,   188,   191,
     192,   194,   195,   197,   200,   203,   206,   210,   213,   217,
     221,   224,   228,   232,   236,   241,   247,   249,   251,   253,
     258,   259,   262,   265,   268,   270,   272,   278,   279,   281,
     285,   289,   290,   299,   301,   306,   308,   310,   311,   313,
     317,   318,   321,   324,   327,   330,   333,   336,   340,   344,
     348,   353,   356,   360,   363,   366,   368,   370,   372,   373,
     376,   379,   382,   385,   388,   390,   392,   396,   400,   401,
     403,   405,   408,   409,   411,   415,   417,   421,   423,   424,
     427,   430,   433,   436,   440,   444,   448,   449,   453,   455,
     457,   461,   463,   467,   469,   471,   473,   475,   477,   479,
     481,   483,   487,   489,   493,   495,   497,   502,   504,   505,
     509,   514,   516,   519,   520,   526,   532,   538,   544,   549,
     553,   557,   562,   568,   570,   571,   575,   580,   585,   586,
     589,   593,   597,   601,   604,   607,   610,   613,   617,   621,
     624,   627,   629,   631,   636,   637,   641,   645,   649,   650,
     652,   654,   659,   660,   663,   666,   669,   672,   675,   678,
     681,   682,   685,   695,   705,   710,   714,   718,   722,   726,
     730,   734,   738,   742,   747,   749,   751,   755,   756,   758,
     762,   766,   770,   774,   779,   784,   789,   794,   797,   799,
     801,   803,   805,   806,   808,   809,   814,   817,   819,   821,
     823,   825,   827,   829,   831,   833,   835,   837,   839,   841,
     844,   847,   848,   852,   854,   858,   860,   862,   864,   867,
     871,   874,   879,   880,   886,   887,   889,   891,   894,   896,
     900,   902,   904,   906,   908,   910,   912,   916,   918,   920,
     922,   924,   926,   930,   932,   938,   950,   952,   954,   956,
     959,   961,   969,   979,   987,   989,   991,   993,   997,   999,
    1001,  1003,  1007,  1009,  1013,  1015,  1019,  1023,  1025,  1028,
    1031,  1038,  1040,  1044,  1045,  1050,  1054,  1056,  1060,  1064,
    1068,  1071,  1074,  1077,  1080,  1081,  1084,  1087,  1088,  1090,
    1092,  1094,  1096,  1098,  1100,  1102,  1106,  1110,  1112,  1114,
    1120,  1128,  1129,  1134,  1136,  1138,  1140,  1142,  1144,  1146,
    1148,  1150,  1152,  1154,  1156,  1160,  1164,  1168,  1172,  1176,
    1180,  1184,  1188,  1192,  1196,  1200,  1204,  1208,  1212,  1215,
    1220,  1222,  1224,  1226,  1228,  1231,  1234,  1238,  1242,  1249,
    1253,  1257,  1261,  1265,  1271,  1278,  1285,  1292,  1299,  1304,
    1313,  1318,  1320,  1322,  1324,  1326,  1328,  1330,  1332,  1333,
    1335,  1339,  1341,  1345,  1346,  1348,  1353,  1360,  1365,  1369,
    1375,  1381,  1386,  1393,  1397,  1400,  1406,  1412,  1421,  1430,
    1439,  1448,  1451,  1453,  1456,  1459,  1462,  1463,  1467,  1473,
    1474,  1477,  1482,  1487,  1492,  1495,  1498,  1499,  1503,  1504,
    1508,  1512,  1515,  1516,  1519,  1522,  1523,  1526,  1527,  1530,
    1535,  1541,  1544,  1548,  1552,  1558,  1565,  1573,  1580,  1585,
    1590,  1596,  1603,  1610,  1616,  1620,  1624,  1629,  1635,  1641,
    1647,  1653,  1659,  1664,  1669,  1675,  1681,  1687,  1693,  1699,
    1705,  1711,  1717,  1724,  1731,  1740,  1747,  1754,  1760,  1765,
    1771,  1776,  1782,  1787,  1793,  1798,  1804,  1810,  1816,  1822,
    1829,  1835,  1841,  1848,  1854,  1860,  1865,  1868,  1872,  1876,
    1878,  1881,  1885,  1888,  1893,  1896,  1898,  1901,  1906,  1907,
    1911,  1914,  1916,  1919,  1923,  1927,  1931,  1935,  1938,  1942,
    1943,  1949,  1950,  1956,  1959,  1962,  1964,  1969,  1971,  1973,
    1974,  1978,  1981,  1984,  1987,  1993,  1996,  1997,  2001,  2002,
    2005,  2008,  2012,  2015,  2018,  2022,  2025,  2028,  2031,  2033,
    2037,  2040,  2043,  2046,  2049,  2052,  2055,  2059,  2062,  2065,
    2068,  2071,  2074,  2077,  2080,  2083,  2087,  2091,  2095,  2098,
    2102,  2105,  2109,  2113,  2118,  2121,  2124,  2127,  2131,  2135,
    2139,  2142,  2146,  2150,  2154,  2159,  2162,  2165,  2167,  2168,
    2171,  2175,  2177,  2178,  2180,  2183,  2184,  2187,  2188,  2190,
    2194,  2195,  2196,  2199,  2200,  2204,  2205,  2209,  2210,  2214,
    2218,  2220,  2221,  2226,  2233,  2240,  2247,  2255,  2262,  2270,
    2276,  2277,  2280,  2284,  2287,  2291,  2295,  2298,  2302,  2305,
    2308,  2312,  2316,  2322,  2327,  2332,  2335,  2339,  2343,  2348,
    2353,  2358,  2364,  2370,  2375,  2379,  2384,  2389,  2394,  2399,
    2401,  2403,  2405,  2407,  2409,  2411,  2413,  2415,  2416,  2419,
    2422,  2425,  2429,  2433,  2438,  2439,  2443,  2444,  2448,  2449,
    2453,  2456,  2460,  2464,  2470,  2476,  2480,  2483,  2487,  2491,
    2493,  2496,  2501,  2505,  2509,  2513,  2516,  2519,  2522,  2525,
    2528,  2533,  2535,  2537,  2539,  2541,  2543,  2545,  2547,  2549,
    2551,  2553,  2555,  2557,  2559,  2561,  2563,  2565,  2567,  2569,
    2571,  2573,  2575,  2577,  2579,  2581,  2583,  2585,  2587,  2589,
    2591,  2593,  2595,  2597,  2599,  2601,  2603,  2605,  2607,  2609,
    2611,  2613,  2615,  2617,  2619,  2621,  2623,  2625,  2627,  2629,
    2631,  2633,  2635,  2637,  2639,  2641,  2643,  2645,  2647,  2649,
    2651,  2653,  2655,  2658,  2661,  2664,  2666,  2669,  2672,  2675,
    2678,  2681,  2685,  2689,  2693,  2697,  2701,  2705,  2709,  2711,
    2713,  2715,  2717,  2719,  2721,  2723,  2725,  2727,  2729,  2731,
    2733,  2735,  2737,  2739,  2741,  2743,  2745,  2747,  2749,  2751,
    2753
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     369,     0,    -1,   370,     3,    -1,     4,   618,    -1,    -1,
     370,   617,    -1,    33,    19,    22,   533,   358,    -1,    15,
      -1,   359,   533,   360,    -1,    19,    -1,   372,    38,    -1,
     372,    39,    -1,   372,    40,    -1,   372,    -1,    34,    -1,
      36,    -1,    35,    -1,    37,    -1,    -1,    18,    -1,    19,
      -1,    -1,    30,    19,    -1,   375,   379,    -1,   377,    -1,
     375,    -1,    29,   372,    -1,   361,   375,    -1,    20,    -1,
      20,    -1,    -1,    41,   384,   385,   358,    -1,    61,    20,
      -1,    -1,    20,    -1,    42,   383,    -1,    53,    -1,    43,
      -1,   362,   386,   363,    -1,   387,    -1,   386,   364,   387,
      -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,    48,
      -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,   135,
     110,   440,   358,    -1,   135,    20,   358,    -1,   146,    -1,
      84,    -1,    60,    -1,    41,    -1,   389,    20,    -1,   389,
      20,   372,    20,    -1,   389,    56,    58,    -1,   389,    56,
      59,    -1,   389,    57,    58,    -1,   389,    57,    59,    -1,
      55,   390,   358,    -1,    66,   398,   399,     3,    -1,    66,
      54,   398,   399,     3,    -1,    66,    62,     3,    -1,    66,
      63,     3,    -1,    66,    64,   398,     3,    -1,    67,     3,
      -1,    -1,    20,    -1,    -1,    65,    -1,    65,   372,    -1,
     416,    68,    -1,    69,   374,    -1,    70,    71,   372,    -1,
      72,   374,    -1,    73,    74,   374,    -1,    75,    76,   374,
      -1,   416,    73,    -1,    70,    71,   372,    -1,   112,   381,
     378,    -1,    68,    79,   372,    -1,    82,    83,   406,   358,
      -1,    82,    83,   105,   431,   358,    -1,    15,    -1,    17,
      -1,    18,    -1,   123,   124,   408,   358,    -1,    -1,   408,
     409,    -1,   127,   375,    -1,   128,   372,    -1,   125,    -1,
     126,    -1,    75,    76,   142,   372,   358,    -1,    -1,   131,
      -1,    79,    19,   411,    -1,   119,    79,    19,    -1,    -1,
     414,   119,   377,   120,    15,   122,    15,   358,    -1,   413,
      -1,   413,   362,   414,   363,    -1,    84,    -1,    85,    -1,
      -1,    19,    -1,    19,   105,    19,    -1,    -1,    86,   372,
      -1,    87,   374,    -1,    44,   437,    -1,   135,   440,    -1,
      90,   419,    -1,    91,   419,    -1,    96,    97,   421,    -1,
      90,    97,   421,    -1,    91,    97,   421,    -1,    90,   102,
     103,   374,    -1,    79,   422,    -1,    82,    83,   406,    -1,
     130,    20,    -1,    92,   497,    -1,   498,    -1,    43,    -1,
      93,    -1,    -1,    98,    99,    -1,    98,   100,    -1,    98,
      76,    -1,    98,   101,    -1,   372,   420,    -1,    35,    -1,
      19,    -1,    44,   110,   437,    -1,    44,   116,   372,    -1,
      -1,    20,    -1,   378,    -1,    20,   378,    -1,    -1,    27,
      -1,   424,   426,   425,    -1,   427,    -1,   428,   364,   427,
      -1,   428,    -1,    -1,   430,   428,    -1,   140,   372,    -1,
     141,   372,    -1,   416,    88,    -1,   433,   417,   362,    -1,
     434,   418,   358,    -1,   434,   436,   358,    -1,    -1,    89,
     435,   428,    -1,    43,    -1,    35,    -1,   362,   438,   363,
      -1,   439,    -1,   438,   364,   439,    -1,    94,    -1,    74,
      -1,    95,    -1,   111,    -1,   108,    -1,   109,    -1,    43,
      -1,    35,    -1,   362,   441,   363,    -1,   442,    -1,   441,
     364,   442,    -1,    94,    -1,   136,    -1,   129,   362,   444,
     363,    -1,   445,    -1,    -1,   445,   358,   444,    -1,   446,
     362,   447,   363,    -1,   446,    -1,   104,    20,    -1,    -1,
     118,   105,   380,   358,   447,    -1,   118,   107,   380,   358,
     447,    -1,   163,   105,   380,   358,   447,    -1,   163,   107,
     380,   358,   447,    -1,    83,   372,   358,   447,    -1,   143,
     144,     3,    -1,   143,   138,     3,    -1,   143,   110,   488,
       3,    -1,   143,   110,    43,   488,     3,    -1,    19,    -1,
      -1,   143,   111,     3,    -1,   143,   111,   145,     3,    -1,
     143,   146,   456,     3,    -1,    -1,   456,   377,    -1,   456,
     115,   378,    -1,   456,    79,    19,    -1,   456,    92,   497,
      -1,   456,   498,    -1,   456,    43,    -1,   456,   112,    -1,
     456,   103,    -1,   456,   457,    19,    -1,   456,    84,    19,
      -1,   456,   113,    -1,   456,   114,    -1,   117,    -1,    91,
      -1,   143,   119,   459,     3,    -1,    -1,   459,   460,   377,
      -1,   459,   122,    15,    -1,   459,    79,    19,    -1,    -1,
     133,    -1,   115,    -1,   143,   147,   462,     3,    -1,    -1,
     462,    79,    -1,   462,   158,    -1,   462,    92,    -1,   462,
      84,    -1,   462,    85,    -1,   462,   119,    -1,   462,    19,
      -1,    -1,    79,    19,    -1,   148,   119,   377,   120,    15,
     122,    15,   463,     3,    -1,   149,   119,   377,   120,    15,
     122,    15,   463,     3,    -1,   121,   119,   463,     3,    -1,
     150,   151,     3,    -1,   150,   152,     3,    -1,   150,   111,
       3,    -1,   150,   153,     3,    -1,   150,   154,     3,    -1,
     150,    74,     3,    -1,   150,   110,     3,    -1,   155,   533,
       3,    -1,   156,   476,   477,     3,    -1,    43,    -1,    35,
      -1,   362,   386,   363,    -1,    -1,    15,    -1,   101,   487,
       3,    -1,   157,   487,     3,    -1,    76,   487,     3,    -1,
     132,   487,     3,    -1,   132,   133,   487,     3,    -1,   132,
     134,   487,     3,    -1,    44,   487,   437,     3,    -1,   135,
     487,   440,     3,    -1,   137,     3,    -1,    19,    -1,    43,
      -1,    20,    -1,    19,    -1,    -1,    20,    -1,    -1,    92,
      19,   490,   496,    -1,   155,   533,    -1,   166,    -1,   167,
      -1,   168,    -1,   169,    -1,   170,    -1,   171,    -1,   172,
      -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,   178,
      -1,   492,   173,    -1,   492,    19,    -1,    -1,   493,   358,
     494,    -1,   493,    -1,   493,   358,   495,    -1,   500,    -1,
      19,    -1,   496,    -1,   209,   533,    -1,   359,   495,   360,
      -1,   359,   360,    -1,   494,   362,   503,   363,    -1,    -1,
     158,    19,   502,   499,   500,    -1,    -1,   504,    -1,   539,
      -1,   504,   539,    -1,   539,    -1,   362,   503,   363,    -1,
      18,    -1,   372,    -1,    17,    -1,   506,    -1,    16,    -1,
      15,    -1,   359,   533,   360,    -1,    17,    -1,   506,    -1,
      16,    -1,   533,    -1,   509,    -1,   509,     7,   509,    -1,
      28,    -1,   359,   510,   364,   510,   360,    -1,   359,   510,
     364,   510,   360,     7,   359,   509,   364,   509,   360,    -1,
     533,    -1,   185,    -1,   186,    -1,   187,    15,    -1,   188,
      -1,   359,   513,   364,   512,   364,   512,   360,    -1,   359,
     513,   364,   512,   364,   512,     7,   512,   360,    -1,   359,
     513,   364,   512,   364,    28,   360,    -1,   511,    -1,   514,
      -1,   507,    -1,   507,     7,   507,    -1,   511,    -1,   514,
      -1,   508,    -1,   508,     7,   508,    -1,   515,    -1,   517,
     364,   515,    -1,   516,    -1,   518,   364,   516,    -1,    18,
      29,    15,    -1,   519,    -1,   519,    26,    -1,   519,    27,
      -1,   519,   362,    15,   364,    15,   363,    -1,   520,    -1,
     521,   364,   520,    -1,    -1,   522,   518,   361,   503,    -1,
     522,     6,   503,    -1,   531,    -1,   359,   533,   360,    -1,
      13,   525,    14,    -1,    29,   526,    29,    -1,    15,   525,
      -1,    28,   525,    -1,   365,   525,    -1,   523,   525,    -1,
      -1,    15,   526,    -1,   365,   526,    -1,    -1,    15,    -1,
     183,    -1,   184,    -1,    20,    -1,   506,    -1,   519,    -1,
      17,    -1,   366,   517,   367,    -1,   366,   521,   367,    -1,
      16,    -1,   524,    -1,   359,   533,   364,   533,   360,    -1,
     359,   513,   364,   533,   364,   533,   360,    -1,    -1,    19,
     359,   538,   360,    -1,    19,    -1,   105,    -1,   189,    -1,
     190,    -1,   192,    -1,   193,    -1,   194,    -1,   195,    -1,
     196,    -1,   197,    -1,   198,    -1,   359,   533,   360,    -1,
     533,    26,   533,    -1,   533,    27,   533,    -1,   533,    28,
     533,    -1,   533,    29,   533,    -1,   533,    11,   533,    -1,
     533,    12,   533,    -1,   533,    22,   533,    -1,   533,    10,
     533,    -1,   533,    23,   533,    -1,   533,     9,   533,    -1,
     533,    24,   533,    -1,   533,     8,   533,    -1,   533,    25,
     533,    -1,    31,   533,    -1,   200,   359,   533,   360,    -1,
     531,    -1,   527,    -1,   528,    -1,    86,    -1,   529,   532,
      -1,   529,   622,    -1,   533,    32,   168,    -1,   533,    32,
     199,    -1,   533,    32,   191,   359,   533,   360,    -1,   533,
      32,   204,    -1,   533,    32,   205,    -1,    26,   208,    26,
      -1,    27,   208,    27,    -1,    27,    27,   208,    27,    27,
      -1,   203,   359,   533,   364,   533,   360,    -1,   148,   359,
     533,   364,   533,   360,    -1,   149,   359,   533,   364,   533,
     360,    -1,    92,   359,   533,   364,   533,   360,    -1,   207,
     359,    19,   360,    -1,   207,   359,    19,   364,   533,   364,
     533,   360,    -1,    19,   359,   538,   360,    -1,   165,    -1,
     163,    -1,   164,    -1,    49,    -1,   159,    -1,   160,    -1,
     533,    -1,    -1,   535,    -1,   535,   364,   536,    -1,   533,
      -1,   533,   364,   537,    -1,    -1,   537,    -1,   179,   533,
     180,   505,    -1,   179,   533,   180,   505,   181,   505,    -1,
      19,    22,   533,   358,    -1,   162,   533,   358,    -1,   529,
     622,    22,   533,   358,    -1,   529,   532,    22,   533,   358,
      -1,    86,    22,   533,   358,    -1,   161,   359,   529,   622,
     360,   358,    -1,   534,   536,   358,    -1,   530,   358,    -1,
     182,   533,   362,   522,   363,    -1,   529,   622,    32,   208,
     358,    -1,   529,   622,    32,   203,   359,   533,   360,   358,
      -1,   529,   622,    32,   148,   359,   533,   360,   358,    -1,
     529,   622,    32,   149,   359,   533,   360,   358,    -1,   529,
     622,    32,    92,   359,   533,   360,   358,    -1,   416,   210,
      -1,   418,    -1,    89,   548,    -1,   217,   549,    -1,   218,
     553,    -1,    -1,   542,   541,   358,    -1,   540,   417,   362,
     542,   363,    -1,    -1,   215,   373,    -1,   211,   213,   215,
     373,    -1,   211,   214,   215,   373,    -1,   212,   214,   215,
     373,    -1,   216,   372,    -1,   106,   374,    -1,    -1,   546,
     545,   358,    -1,    -1,   362,   546,   363,    -1,   544,   429,
     547,    -1,   544,   547,    -1,    -1,    30,    19,    -1,   219,
      20,    -1,    -1,   220,   375,    -1,    -1,   217,   374,    -1,
     375,   550,   551,   552,    -1,   143,   210,   221,   452,     3,
      -1,   416,   124,    -1,   555,   417,   362,    -1,   556,   418,
     358,    -1,   556,   220,   122,   372,   358,    -1,   556,   220,
     375,   122,   372,   358,    -1,   556,   218,   375,   376,   122,
     372,   358,    -1,   556,   247,   250,    83,   406,   358,    -1,
     556,   247,   249,   358,    -1,   556,   248,   249,   358,    -1,
     556,   222,    71,   372,   358,    -1,   556,   226,   222,    71,
     372,   358,    -1,   556,   223,   224,    71,   372,   358,    -1,
     556,   225,    71,   372,   358,    -1,   556,    88,   358,    -1,
     556,   217,   358,    -1,   556,   217,   372,   358,    -1,   556,
     228,   229,   230,   358,    -1,   556,   228,   229,   102,   358,
      -1,   556,   257,   258,   230,   358,    -1,   556,   257,   258,
     259,   358,    -1,   556,   257,   258,   260,   358,    -1,   556,
     267,    88,   358,    -1,   556,   267,   268,   358,    -1,   556,
     232,   233,   374,   358,    -1,   556,   269,   233,   374,   358,
      -1,   556,   266,   233,   374,   358,    -1,   556,   255,   256,
     374,   358,    -1,   556,   272,   269,   374,   358,    -1,   556,
     231,   240,   372,   358,    -1,   556,   231,   239,   372,   358,
      -1,   556,   193,   127,   375,   358,    -1,   556,   234,   235,
      71,   372,   358,    -1,   556,    49,   236,    71,   372,   358,
      -1,   556,    49,   142,    71,   372,   364,   372,   358,    -1,
     556,   101,   237,    49,   374,   358,    -1,   556,   157,   146,
     261,   374,   358,    -1,   556,   157,   251,   374,   358,    -1,
     556,   254,   374,   358,    -1,   556,   252,   253,   374,   358,
      -1,   556,   104,    20,   358,    -1,   556,   146,    97,   372,
     358,    -1,   556,   106,   374,   358,    -1,   556,   262,   263,
     374,   358,    -1,   556,   273,   374,   358,    -1,   556,   148,
     275,   213,   358,    -1,   556,   148,   275,   214,   358,    -1,
     556,   148,   275,   374,   358,    -1,   556,   274,   220,   122,
     358,    -1,   556,   274,   220,   122,   372,   358,    -1,   556,
      75,    76,   374,   358,    -1,   556,    75,    76,   276,   358,
      -1,   556,    75,    76,    71,   372,   358,    -1,   556,   266,
      79,   422,   358,    -1,   556,   270,   271,   374,   358,    -1,
     556,   210,   374,   358,    -1,   416,   277,    -1,   557,   417,
     362,    -1,   558,   559,   358,    -1,   418,    -1,   283,   374,
      -1,   284,    82,   374,    -1,   320,   374,    -1,   320,   374,
      97,   372,    -1,   285,   372,    -1,   561,    -1,   278,   406,
      -1,   560,   362,   562,   363,    -1,    -1,   562,   563,   358,
      -1,   284,   374,    -1,   322,    -1,   145,   374,    -1,   231,
     322,   374,    -1,   231,   286,   372,    -1,   231,   287,   372,
      -1,   284,   286,   372,    -1,   323,   374,    -1,   323,   324,
     372,    -1,    -1,   308,   564,   362,   575,   363,    -1,    -1,
     318,   565,   362,   575,   363,    -1,   316,   566,    -1,    89,
     588,    -1,   570,    -1,   567,   362,   568,   363,    -1,   567,
      -1,   377,    -1,    -1,   568,   569,   358,    -1,   309,   374,
      -1,   145,   374,    -1,   286,   372,    -1,   573,   583,   362,
     571,   363,    -1,   573,   583,    -1,    -1,   571,   572,   358,
      -1,    -1,   289,   372,    -1,   288,   372,    -1,   290,   235,
     372,    -1,   142,   372,    -1,   292,   372,    -1,   292,   114,
     372,    -1,   303,    93,    -1,   303,   302,    -1,   303,   305,
      -1,   443,    -1,   310,   311,   406,    -1,   286,   372,    -1,
     289,   372,    -1,   307,   372,    -1,   288,   372,    -1,   142,
     372,    -1,   292,   372,    -1,   292,   114,   372,    -1,   293,
     294,    -1,   293,   295,    -1,   293,   296,    -1,   293,   297,
      -1,   293,   298,    -1,   293,   299,    -1,   293,   300,    -1,
     293,   301,    -1,   328,   294,   374,    -1,   299,   329,   374,
      -1,   290,   235,   372,    -1,   291,   372,    -1,   304,   296,
     374,    -1,   284,   374,    -1,    64,   311,   374,    -1,   320,
     321,   372,    -1,   153,   362,   579,   363,    -1,   303,    93,
      -1,   303,   302,    -1,   303,   305,    -1,   213,   313,   315,
      -1,   213,   313,   314,    -1,   213,   313,   372,    -1,   214,
     432,    -1,   214,   291,   372,    -1,   214,   330,   372,    -1,
     270,   271,   374,    -1,   270,   271,   214,   312,    -1,   210,
     374,    -1,   273,   374,    -1,   443,    -1,    -1,   575,   576,
      -1,   577,   578,   358,    -1,   377,    -1,    -1,   309,    -1,
     317,   372,    -1,    -1,   579,   581,    -1,    -1,   306,    -1,
      18,   580,   358,    -1,    -1,    -1,   327,   372,    -1,    -1,
     428,   585,   583,    -1,    -1,   586,   574,   358,    -1,    -1,
     362,   586,   363,    -1,   582,   584,   587,    -1,    20,    -1,
      -1,   143,   277,   452,     3,    -1,   143,   277,   153,   452,
     589,     3,    -1,   143,   277,    89,   452,   589,     3,    -1,
     143,   277,   331,   452,   589,     3,    -1,   143,   277,   331,
      43,   452,   589,     3,    -1,   143,   277,   332,   452,   589,
       3,    -1,   143,   277,   332,    43,   452,   589,     3,    -1,
     143,   277,   319,   598,     3,    -1,    -1,   598,   325,    -1,
     598,   278,   406,    -1,   598,   311,    -1,   598,   293,    15,
      -1,   598,   326,   406,    -1,   598,   230,    -1,   598,    82,
     406,    -1,   598,    19,    -1,   416,   333,    -1,   599,   417,
     362,    -1,   600,   418,   358,    -1,   600,   334,    79,    19,
     358,    -1,   600,   335,   336,   358,    -1,   600,   335,   337,
     358,    -1,   416,   338,    -1,   601,   417,   362,    -1,   602,
     418,   358,    -1,   602,   339,   372,   358,    -1,   602,   128,
     372,   358,    -1,   602,   340,   372,   358,    -1,   602,   341,
      71,   372,   358,    -1,   602,    65,    71,   372,   358,    -1,
     602,   303,   603,   358,    -1,   602,   443,   358,    -1,   602,
     348,   350,   358,    -1,   602,   348,   218,   358,    -1,   602,
     348,   349,   358,    -1,   602,    89,   609,   358,    -1,   346,
      -1,   347,    -1,    93,    -1,   294,    -1,   342,    -1,   343,
      -1,   344,    -1,   345,    -1,    -1,   233,   372,    -1,   335,
     604,    -1,   214,   432,    -1,   214,   291,   372,    -1,   270,
     271,   374,    -1,   270,   271,   214,   312,    -1,    -1,   606,
     605,   358,    -1,    -1,   362,   606,   363,    -1,    -1,   608,
     428,   607,    -1,   416,   353,    -1,   610,   417,   362,    -1,
     611,   418,   358,    -1,   611,    64,   311,   374,   358,    -1,
     611,   266,    79,   422,   358,    -1,   611,   615,   358,    -1,
     146,   377,    -1,   227,   375,   376,    -1,   613,   321,   372,
      -1,   613,    -1,   614,   613,    -1,   612,   227,   375,   376,
      -1,   612,   227,    20,    -1,   612,   355,   614,    -1,   612,
     268,   375,    -1,   612,   259,    -1,   612,   164,    -1,   612,
     356,    -1,   612,   357,    -1,   612,   354,    -1,   143,   353,
     452,     3,    -1,   358,    -1,   371,    -1,   382,    -1,   388,
      -1,   391,    -1,   405,    -1,   407,    -1,   410,    -1,   412,
      -1,   415,    -1,   619,    -1,   423,    -1,   489,    -1,   491,
      -1,   501,    -1,   392,    -1,   393,    -1,   394,    -1,   395,
      -1,   396,    -1,   397,    -1,   448,    -1,   449,    -1,   450,
      -1,   451,    -1,   453,    -1,   454,    -1,   455,    -1,   458,
      -1,   461,    -1,   464,    -1,   465,    -1,   466,    -1,   467,
      -1,   468,    -1,   469,    -1,   470,    -1,   471,    -1,   472,
      -1,   473,    -1,   474,    -1,   475,    -1,   478,    -1,   479,
      -1,   480,    -1,   481,    -1,   482,    -1,   483,    -1,   484,
      -1,   485,    -1,   486,    -1,   554,    -1,   590,    -1,   591,
      -1,   592,    -1,   593,    -1,   594,    -1,   595,    -1,   596,
      -1,   597,    -1,   616,    -1,   620,   363,    -1,   621,   363,
      -1,   434,   363,    -1,   543,    -1,   556,   363,    -1,   558,
     363,    -1,   600,   363,    -1,   602,   363,    -1,   611,   363,
      -1,   400,   417,   362,    -1,   620,   418,   358,    -1,   620,
     401,   358,    -1,   620,   404,   358,    -1,   402,   417,   362,
      -1,   621,   418,   358,    -1,   621,   403,   358,    -1,    77,
      -1,    78,    -1,    80,    -1,    81,    -1,   139,    -1,     5,
      -1,   241,    -1,   238,    -1,   242,    -1,   240,    -1,   239,
      -1,   243,    -1,   244,    -1,   245,    -1,   264,    -1,   265,
      -1,   246,    -1,   279,    -1,   280,    -1,   281,    -1,   282,
      -1,   351,    -1,   352,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   695,   695,   696,   699,   701,   709,   718,   719,   720,
     727,   728,   729,   737,   738,   739,   740,   741,   742,   748,
     749,   756,   757,   761,   768,   769,   773,   777,   784,   792,
     793,   799,   808,   809,   813,   818,   819,   823,   824,   828,
     829,   833,   834,   835,   836,   837,   838,   839,   840,   841,
     847,   848,   857,   858,   859,   860,   863,   864,   865,   866,
     867,   868,   872,   879,   882,   889,   892,   895,   898,   902,
     903,   907,   908,   909,   917,   922,   923,   927,   934,   935,
     941,   946,   950,   964,   978,   979,   983,   984,   985,   996,
     998,  1000,  1004,  1005,  1006,  1007,  1012,  1018,  1019,  1023,
    1031,  1035,  1037,  1043,  1044,  1051,  1052,  1056,  1062,  1066,
    1076,  1078,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1097,  1098,  1099,  1100,  1104,  1105,
    1106,  1107,  1108,  1112,  1118,  1122,  1130,  1131,  1139,  1147,
    1148,  1149,  1153,  1154,  1158,  1163,  1164,  1168,  1170,  1178,
    1182,  1183,  1189,  1196,  1197,  1198,  1202,  1210,  1216,  1217,
    1218,  1222,  1223,  1227,  1228,  1229,  1230,  1231,  1232,  1238,
    1239,  1240,  1244,  1245,  1249,  1250,  1256,  1257,  1260,  1262,
    1266,  1267,  1271,  1289,  1290,  1291,  1292,  1293,  1294,  1302,
    1305,  1308,  1311,  1315,  1316,  1319,  1322,  1326,  1330,  1335,
    1341,  1348,  1353,  1358,  1363,  1367,  1371,  1375,  1385,  1393,
    1397,  1404,  1405,  1410,  1414,  1421,  1428,  1432,  1440,  1441,
    1442,  1447,  1451,  1454,  1455,  1456,  1457,  1458,  1459,  1460,
    1465,  1470,  1478,  1485,  1492,  1500,  1502,  1504,  1506,  1508,
    1510,  1512,  1515,  1519,  1525,  1526,  1527,  1531,  1532,  1538,
    1540,  1542,  1544,  1546,  1548,  1552,  1556,  1559,  1563,  1564,
    1565,  1569,  1570,  1571,  1579,  1579,  1589,  1593,  1594,  1595,
    1596,  1597,  1598,  1599,  1600,  1601,  1602,  1603,  1604,  1605,
    1626,  1637,  1638,  1645,  1646,  1653,  1662,  1666,  1670,  1694,
    1695,  1699,  1712,  1712,  1728,  1729,  1732,  1733,  1737,  1740,
    1749,  1762,  1763,  1764,  1765,  1769,  1770,  1771,  1772,  1773,
    1777,  1780,  1781,  1782,  1786,  1789,  1798,  1801,  1802,  1803,
    1804,  1808,  1809,  1810,  1814,  1815,  1816,  1817,  1821,  1822,
    1823,  1824,  1828,  1829,  1833,  1834,  1838,  1845,  1846,  1847,
    1848,  1855,  1856,  1859,  1860,  1867,  1879,  1880,  1884,  1885,
    1889,  1890,  1891,  1892,  1893,  1897,  1898,  1899,  1903,  1904,
    1905,  1906,  1907,  1908,  1909,  1910,  1911,  1912,  1913,  1917,
    1918,  1928,  1932,  1955,  1969,  1970,  1971,  1972,  1973,  1974,
    1975,  1976,  1977,  1978,  1982,  1983,  1984,  1985,  1986,  1987,
    1988,  1989,  1990,  1991,  1992,  1993,  1994,  1995,  1996,  1997,
    1999,  2000,  2001,  2003,  2005,  2007,  2009,  2010,  2011,  2012,
    2013,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2031,  2032,
    2037,  2060,  2061,  2062,  2063,  2064,  2065,  2069,  2072,  2073,
    2074,  2082,  2089,  2098,  2099,  2103,  2109,  2119,  2128,  2134,
    2139,  2146,  2151,  2157,  2158,  2159,  2167,  2168,  2169,  2170,
    2171,  2177,  2189,  2190,  2191,  2192,  2195,  2197,  2201,  2205,
    2216,  2217,  2218,  2219,  2220,  2221,  2224,  2226,  2229,  2231,
    2234,  2237,  2242,  2243,  2244,  2248,  2249,  2253,  2254,  2257,
    2276,  2282,  2306,  2307,  2308,  2309,  2310,  2320,  2321,  2322,
    2323,  2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,
    2333,  2334,  2335,  2336,  2337,  2338,  2339,  2340,  2341,  2342,
    2343,  2344,  2345,  2346,  2347,  2348,  2349,  2350,  2351,  2352,
    2353,  2354,  2359,  2360,  2361,  2362,  2363,  2364,  2365,  2366,
    2367,  2368,  2369,  2370,  2371,  2372,  2383,  2393,  2394,  2398,
    2399,  2400,  2401,  2402,  2403,  2404,  2407,  2422,  2425,  2427,
    2431,  2432,  2433,  2434,  2435,  2436,  2437,  2438,  2439,  2440,
    2440,  2441,  2441,  2442,  2443,  2444,  2448,  2449,  2453,  2461,
    2463,  2467,  2468,  2469,  2473,  2474,  2477,  2479,  2482,  2483,
    2484,  2485,  2486,  2487,  2488,  2489,  2490,  2491,  2492,  2495,
    2517,  2518,  2519,  2520,  2521,  2522,  2523,  2524,  2525,  2526,
    2527,  2528,  2529,  2530,  2531,  2532,  2533,  2534,  2535,  2536,
    2537,  2538,  2539,  2540,  2541,  2542,  2543,  2544,  2545,  2546,
    2547,  2548,  2549,  2550,  2551,  2552,  2553,  2554,  2557,  2559,
    2562,  2564,  2573,  2575,  2576,  2579,  2581,  2585,  2586,  2589,
    2599,  2622,  2624,  2628,  2628,  2631,  2633,  2636,  2638,  2642,
    2646,  2647,  2652,  2655,  2658,  2663,  2666,  2671,  2674,  2678,
    2682,  2685,  2686,  2687,  2688,  2689,  2690,  2691,  2692,  2698,
    2705,  2706,  2707,  2712,  2713,  2719,  2726,  2727,  2728,  2729,
    2730,  2731,  2732,  2733,  2734,  2735,  2736,  2737,  2738,  2742,
    2743,  2744,  2749,  2750,  2751,  2752,  2753,  2756,  2757,  2758,
    2759,  2760,  2761,  2762,  2765,  2767,  2770,  2772,  2776,  2788,
    2795,  2802,  2803,  2804,  2805,  2806,  2809,  2818,  2826,  2833,
    2834,  2838,  2843,  2849,  2852,  2857,  2858,  2859,  2860,  2861,
    2864,  2871,  2871,  2871,  2871,  2871,  2871,  2871,  2871,  2871,
    2871,  2871,  2871,  2871,  2871,  2871,  2872,  2872,  2872,  2872,
    2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,
    2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,
    2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,
    2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,  2872,
    2872,  2872,  2873,  2873,  2873,  2873,  2873,  2873,  2873,  2873,
    2873,  2874,  2874,  2874,  2874,  2875,  2875,  2875,  2876,  2876,
    2876,  2876,  2876,  2877,  2877,  2878,  2879,  2880,  2881,  2882,
    2883,  2884,  2885,  2886,  2887,  2888,  2888,  2888,  2888,  2888,
    2888
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "END", "CLI_MARKER", "INVALID_TOKEN",
  "ELSECOL", "DDOT", "GEQ", "LEQ", "NEQ", "AND", "OR", "PO", "PC", "NUM",
  "ENUM", "RTRID", "IPA", "SYM", "TEXT", "PREFIX_DUMMY", "'='", "'<'",
  "'>'", "'~'", "'+'", "'-'", "'*'", "'/'", "'%'", "'!'", "'.'", "DEFINE",
  "ON", "OFF", "YES", "NO", "S", "MS", "US", "LOG", "SYSLOG", "ALL",
  "DEBUG", "TRACE", "INFO", "REMOTE", "WARNING", "ERROR", "AUTH", "FATAL",
  "BUG", "STDERR", "SOFT", "TIMEFORMAT", "ISO", "OLD", "SHORT", "LONG",
  "BASE", "NAME", "CONFIRM", "UNDO", "CHECK", "TIMEOUT", "CONFIGURE",
  "DOWN", "KERNEL", "PERSIST", "SCAN", "TIME", "LEARN", "DEVICE", "ROUTES",
  "GRACEFUL", "RESTART", "KRT_SOURCE", "KRT_METRIC", "TABLE",
  "KRT_PREFSRC", "KRT_REALM", "ROUTER", "ID", "PROTOCOL", "TEMPLATE",
  "PREFERENCE", "DISABLED", "DIRECT", "INTERFACE", "IMPORT", "EXPORT",
  "FILTER", "NONE", "STATES", "FILTERS", "RECEIVE", "LIMIT", "ACTION",
  "WARN", "BLOCK", "DISABLE", "KEEP", "FILTERED", "PASSWORD", "FROM",
  "PASSIVE", "TO", "EVENTS", "PACKETS", "PROTOCOLS", "INTERFACES",
  "PRIMARY", "STATS", "COUNT", "FOR", "COMMANDS", "PREEXPORT", "GENERATE",
  "ROA", "MAX", "FLUSH", "AS", "LISTEN", "BGP", "V6ONLY", "DUAL",
  "ADDRESS", "PORT", "PASSWORDS", "DESCRIPTION", "SORTED", "RELOAD", "IN",
  "OUT", "MRTDUMP", "MESSAGES", "RESTRICT", "MEMORY", "IGP_METRIC",
  "CLASS", "DSCP", "WAIT", "SHOW", "STATUS", "SUMMARY", "ROUTE", "SYMBOLS",
  "ADD", "DELETE", "DUMP", "RESOURCES", "SOCKETS", "NEIGHBORS",
  "ATTRIBUTES", "EVAL", "ECHO", "ENABLE", "FUNCTION", "PRINT", "PRINTN",
  "UNSET", "RETURN", "ACCEPT", "REJECT", "QUITBIRD", "INT", "BOOL", "IP",
  "PREFIX", "PAIR", "QUAD", "EC", "SET", "STRING", "BGPMASK", "BGPPATH",
  "CLIST", "ECLIST", "IF", "THEN", "ELSE", "CASE", "TRUE", "FALSE", "RT",
  "RO", "UNKNOWN", "GENERIC", "GW", "NET", "MASK", "PROTO", "SOURCE",
  "SCOPE", "CAST", "DEST", "IFNAME", "IFINDEX", "LEN", "DEFINED",
  "CONTAINS", "RESET", "PREPEND", "FIRST", "LAST", "MATCH", "ROA_CHECK",
  "EMPTY", "WHERE", "BFD", "MIN", "IDLE", "RX", "TX", "INTERVAL",
  "MULTIPLIER", "MULTIHOP", "NEIGHBOR", "DEV", "LOCAL", "SESSIONS", "HOLD",
  "CONNECT", "RETRY", "KEEPALIVE", "STARTUP", "VIA", "NEXT", "HOP", "SELF",
  "DEFAULT", "PATH", "METRIC", "START", "DELAY", "FORGET", "AFTER",
  "BGP_PATH", "BGP_LOCAL_PREF", "BGP_MED", "BGP_ORIGIN", "BGP_NEXT_HOP",
  "BGP_ATOMIC_AGGR", "BGP_AGGREGATOR", "BGP_COMMUNITY",
  "BGP_EXT_COMMUNITY", "RR", "RS", "CLIENT", "CLUSTER", "AS4", "ADVERTISE",
  "IPV4", "CAPABILITIES", "PREFER", "OLDER", "MISSING", "LLADDR", "DROP",
  "IGNORE", "REFRESH", "INTERPRET", "COMMUNITIES", "BGP_ORIGINATOR_ID",
  "BGP_CLUSTER_LIST", "IGP", "GATEWAY", "RECURSIVE", "MED", "TTL",
  "SECURITY", "DETERMINISTIC", "SECONDARY", "ALLOW", "PATHS", "AWARE",
  "OSPF", "AREA", "OSPF_METRIC1", "OSPF_METRIC2", "OSPF_TAG",
  "OSPF_ROUTER_ID", "RFC1583COMPAT", "STUB", "TICK", "COST", "COST2",
  "RETRANSMIT", "HELLO", "TRANSMIT", "PRIORITY", "DEAD", "TYPE",
  "BROADCAST", "BCAST", "NONBROADCAST", "NBMA", "POINTOPOINT", "PTP",
  "POINTOMULTIPOINT", "PTMP", "SIMPLE", "AUTHENTICATION", "STRICT",
  "CRYPTOGRAPHIC", "ELIGIBLE", "POLL", "NETWORKS", "HIDDEN", "VIRTUAL",
  "LINK", "ONLY", "BUFFER", "LARGE", "NORMAL", "STUBNET", "TAG",
  "EXTERNAL", "LSADB", "ECMP", "WEIGHT", "NSSA", "TRANSLATOR", "STABILITY",
  "GLOBAL", "LSID", "INSTANCE", "REAL", "NETMASK", "LENGTH", "TOPOLOGY",
  "STATE", "PIPE", "PEER", "MODE", "OPAQUE", "TRANSPARENT", "RIP",
  "INFINITY", "PERIOD", "GARBAGE", "MULTICAST", "QUIET", "NOLISTEN",
  "VERSION1", "PLAINTEXT", "MD5", "HONOR", "NEVER", "ALWAYS", "RIP_METRIC",
  "RIP_TAG", "STATIC", "PROHIBIT", "MULTIPATH", "BLACKHOLE", "UNREACHABLE",
  "';'", "'('", "')'", "':'", "'{'", "'}'", "','", "'?'", "'['", "']'",
  "$accept", "config", "conf_entries", "definition", "expr", "expr_us",
  "bool", "ipa", "ipa_scope", "prefix", "prefix_or_ipa", "pxlen",
  "datetime", "text_or_none", "log_config", "syslog_name", "log_file",
  "log_mask", "log_mask_list", "log_cat", "mrtdump_base",
  "timeformat_which", "timeformat_spec", "timeformat_base",
  "cmd_CONFIGURE", "cmd_CONFIGURE_SOFT", "cmd_CONFIGURE_CONFIRM",
  "cmd_CONFIGURE_UNDO", "cmd_CONFIGURE_CHECK", "cmd_DOWN", "cfg_name",
  "cfg_timeout", "kern_proto_start", "kern_item", "kif_proto_start",
  "kif_item", "kern_sys_item", "rtrid", "idval", "listen", "listen_opts",
  "listen_opt", "gr_opts", "tab_sorted", "newtab", "roa_table_start",
  "roa_table_opts", "roa_table", "proto_start", "proto_name", "proto_item",
  "imexport", "limit_action", "limit_spec", "rtable", "debug_default",
  "iface_patt_node_init", "iface_patt_node_body", "iface_negate",
  "iface_patt_node", "iface_patt_list", "iface_patt_list_nopx",
  "iface_patt_init", "iface_patt", "tos", "dev_proto_start", "dev_proto",
  "dev_iface_init", "dev_iface_patt", "debug_mask", "debug_list",
  "debug_flag", "mrtdump_mask", "mrtdump_list", "mrtdump_flag",
  "password_list", "password_items", "password_item",
  "password_item_begin", "password_item_params", "cmd_SHOW_STATUS",
  "cmd_SHOW_MEMORY", "cmd_SHOW_PROTOCOLS", "cmd_SHOW_PROTOCOLS_ALL",
  "optsym", "cmd_SHOW_INTERFACES", "cmd_SHOW_INTERFACES_SUMMARY",
  "cmd_SHOW_ROUTE", "r_args", "export_or_preexport", "cmd_SHOW_ROA",
  "roa_args", "roa_mode", "cmd_SHOW_SYMBOLS", "sym_args", "roa_table_arg",
  "cmd_ADD_ROA", "cmd_DELETE_ROA", "cmd_FLUSH_ROA", "cmd_DUMP_RESOURCES",
  "cmd_DUMP_SOCKETS", "cmd_DUMP_INTERFACES", "cmd_DUMP_NEIGHBORS",
  "cmd_DUMP_ATTRIBUTES", "cmd_DUMP_ROUTES", "cmd_DUMP_PROTOCOLS",
  "cmd_EVAL", "cmd_ECHO", "echo_mask", "echo_size", "cmd_DISABLE",
  "cmd_ENABLE", "cmd_RESTART", "cmd_RELOAD", "cmd_RELOAD_IN",
  "cmd_RELOAD_OUT", "cmd_DEBUG", "cmd_MRTDUMP", "cmd_RESTRICT",
  "proto_patt", "proto_patt2", "filter_def", "$@1", "filter_eval", "type",
  "one_decl", "decls", "declsn", "filter_body", "filter", "where_filter",
  "function_params", "function_body", "function_def", "$@2", "cmds",
  "cmds_int", "block", "fipa", "set_atom", "switch_atom", "pair_expr",
  "pair_atom", "pair_item", "ec_expr", "ec_kind", "ec_item", "set_item",
  "switch_item", "set_items", "switch_items", "fprefix_s", "fprefix",
  "fprefix_set", "switch_body", "bgp_path_expr", "bgp_path",
  "bgp_path_tail1", "bgp_path_tail2", "constant", "constructor", "rtadot",
  "function_call", "symbol", "static_attr", "term", "break_command",
  "print_one", "print_list", "var_listn", "var_list", "cmd",
  "bfd_proto_start", "bfd_proto_item", "bfd_proto_opts", "bfd_proto",
  "bfd_iface_start", "bfd_iface_item", "bfd_iface_opts",
  "bfd_iface_opt_list", "bfd_iface", "bfd_multihop", "bfd_neigh_iface",
  "bfd_neigh_local", "bfd_neigh_multihop", "bfd_neighbor",
  "cmd_SHOW_BFD_SESSIONS", "bgp_proto_start", "bgp_proto",
  "ospf_proto_start", "ospf_proto", "ospf_proto_item", "ospf_area_start",
  "ospf_area", "ospf_area_opts", "ospf_area_item", "$@3", "$@4",
  "ospf_stubnet", "ospf_stubnet_start", "ospf_stubnet_opts",
  "ospf_stubnet_item", "ospf_vlink", "ospf_vlink_opts", "ospf_vlink_item",
  "ospf_vlink_start", "ospf_iface_item", "pref_list", "pref_item",
  "pref_base", "pref_opt", "nbma_list", "nbma_eligible", "nbma_item",
  "ospf_iface_start", "ospf_instance_id", "ospf_iface_patt_list", "$@5",
  "ospf_iface_opts", "ospf_iface_opt_list", "ospf_iface", "opttext",
  "cmd_SHOW_OSPF", "cmd_SHOW_OSPF_NEIGHBORS", "cmd_SHOW_OSPF_INTERFACE",
  "cmd_SHOW_OSPF_TOPOLOGY", "cmd_SHOW_OSPF_TOPOLOGY_ALL",
  "cmd_SHOW_OSPF_STATE", "cmd_SHOW_OSPF_STATE_ALL", "cmd_SHOW_OSPF_LSADB",
  "lsadb_args", "pipe_proto_start", "pipe_proto", "rip_cfg_start",
  "rip_cfg", "rip_auth", "rip_mode", "rip_iface_item", "rip_iface_opts",
  "rip_iface_opt_list", "rip_iface_init", "rip_iface",
  "static_proto_start", "static_proto", "stat_route0", "stat_multipath1",
  "stat_multipath", "stat_route", "cmd_SHOW_STATIC", "conf", "cli_cmd",
  "proto", "kern_proto", "kif_proto", "dynamic_attr", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,    61,    60,    62,   126,    43,    45,    42,    47,
      37,    33,    46,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   443,
     444,   445,   446,   447,   448,   449,   450,   451,   452,   453,
     454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
     464,   465,   466,   467,   468,   469,   470,   471,   472,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   489,   490,   491,   492,   493,
     494,   495,   496,   497,   498,   499,   500,   501,   502,   503,
     504,   505,   506,   507,   508,   509,   510,   511,   512,   513,
     514,   515,   516,   517,   518,   519,   520,   521,   522,   523,
     524,   525,   526,   527,   528,   529,   530,   531,   532,   533,
     534,   535,   536,   537,   538,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,   568,   569,   570,   571,   572,   573,
     574,   575,   576,   577,   578,   579,   580,   581,   582,   583,
     584,   585,   586,   587,   588,   589,   590,   591,   592,   593,
     594,   595,   596,   597,   598,   599,   600,   601,    59,    40,
      41,    58,   123,   125,    44,    63,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   368,   369,   369,   370,   370,   371,   372,   372,   372,
     373,   373,   373,   374,   374,   374,   374,   374,   374,   375,
     375,   376,   376,   377,   378,   378,   379,   379,   380,   381,
     381,   382,   383,   383,   384,   384,   384,   385,   385,   386,
     386,   387,   387,   387,   387,   387,   387,   387,   387,   387,
     388,   388,   389,   389,   389,   389,   390,   390,   390,   390,
     390,   390,   391,   392,   393,   394,   395,   396,   397,   398,
     398,   399,   399,   399,   400,   401,   401,   401,   401,   401,
     402,   403,   403,   404,   405,   405,   406,   406,   406,   407,
     408,   408,   409,   409,   409,   409,   410,   411,   411,   412,
     413,   414,   414,   415,   415,   416,   416,   417,   417,   417,
     418,   418,   418,   418,   418,   418,   418,   418,   418,   418,
     418,   418,   418,   418,   419,   419,   419,   419,   420,   420,
     420,   420,   420,   421,   421,   422,   423,   423,   424,   425,
     425,   425,   426,   426,   427,   428,   428,   429,   430,   431,
     432,   432,   433,   434,   434,   434,   435,   436,   437,   437,
     437,   438,   438,   439,   439,   439,   439,   439,   439,   440,
     440,   440,   441,   441,   442,   442,   443,   443,   444,   444,
     445,   445,   446,   447,   447,   447,   447,   447,   447,   448,
     449,   450,   451,   452,   452,   453,   454,   455,   456,   456,
     456,   456,   456,   456,   456,   456,   456,   456,   456,   456,
     456,   457,   457,   458,   459,   459,   459,   459,   460,   460,
     460,   461,   462,   462,   462,   462,   462,   462,   462,   462,
     463,   463,   464,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   476,   476,   477,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   486,   487,   487,
     487,   488,   488,   488,   490,   489,   491,   492,   492,   492,
     492,   492,   492,   492,   492,   492,   492,   492,   492,   492,
     493,   494,   494,   495,   495,   496,   497,   497,   498,   499,
     499,   500,   502,   501,   503,   503,   504,   504,   505,   505,
     506,   507,   507,   507,   507,   508,   508,   508,   508,   508,
     509,   510,   510,   510,   511,   511,   512,   513,   513,   513,
     513,   514,   514,   514,   515,   515,   515,   515,   516,   516,
     516,   516,   517,   517,   518,   518,   519,   520,   520,   520,
     520,   521,   521,   522,   522,   522,   523,   523,   524,   524,
     525,   525,   525,   525,   525,   526,   526,   526,   527,   527,
     527,   527,   527,   527,   527,   527,   527,   527,   527,   528,
     528,   529,   530,   531,   532,   532,   532,   532,   532,   532,
     532,   532,   532,   532,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   533,   533,
     533,   534,   534,   534,   534,   534,   534,   535,   536,   536,
     536,   537,   537,   538,   538,   539,   539,   539,   539,   539,
     539,   539,   539,   539,   539,   539,   539,   539,   539,   539,
     539,   540,   541,   541,   541,   541,   542,   542,   543,   544,
     545,   545,   545,   545,   545,   545,   546,   546,   547,   547,
     548,   549,   550,   550,   550,   551,   551,   552,   552,   553,
     554,   555,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   556,   556,   556,   556,
     556,   556,   556,   556,   556,   556,   557,   558,   558,   559,
     559,   559,   559,   559,   559,   559,   560,   561,   562,   562,
     563,   563,   563,   563,   563,   563,   563,   563,   563,   564,
     563,   565,   563,   563,   563,   563,   566,   566,   567,   568,
     568,   569,   569,   569,   570,   570,   571,   571,   572,   572,
     572,   572,   572,   572,   572,   572,   572,   572,   572,   573,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   574,   574,
     574,   574,   574,   574,   574,   574,   574,   574,   575,   575,
     576,   577,   578,   578,   578,   579,   579,   580,   580,   581,
     582,   583,   583,   585,   584,   586,   586,   587,   587,   588,
     589,   589,   590,   591,   592,   593,   594,   595,   596,   597,
     598,   598,   598,   598,   598,   598,   598,   598,   598,   599,
     600,   600,   600,   600,   600,   601,   602,   602,   602,   602,
     602,   602,   602,   602,   602,   602,   602,   602,   602,   603,
     603,   603,   604,   604,   604,   604,   604,   605,   605,   605,
     605,   605,   605,   605,   606,   606,   607,   607,   608,   609,
     610,   611,   611,   611,   611,   611,   612,   613,   613,   614,
     614,   615,   615,   615,   615,   615,   615,   615,   615,   615,
     616,   617,   617,   617,   617,   617,   617,   617,   617,   617,
     617,   617,   617,   617,   617,   617,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   618,   618,   618,   618,   618,   618,   618,   618,
     618,   618,   619,   619,   619,   619,   619,   619,   619,   619,
     619,   620,   620,   620,   620,   621,   621,   621,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622,   622,   622,   622,   622,   622,   622,   622,   622,   622,
     622
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     0,     2,     5,     1,     3,     1,
       2,     2,     2,     1,     1,     1,     1,     1,     0,     1,
       1,     0,     2,     2,     1,     1,     2,     2,     1,     1,
       0,     4,     2,     0,     1,     2,     1,     1,     3,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     1,     1,     1,     1,     2,     4,     3,     3,
       3,     3,     3,     4,     5,     3,     3,     4,     2,     0,
       1,     0,     1,     2,     2,     2,     3,     2,     3,     3,
       2,     3,     3,     3,     4,     5,     1,     1,     1,     4,
       0,     2,     2,     2,     1,     1,     5,     0,     1,     3,
       3,     0,     8,     1,     4,     1,     1,     0,     1,     3,
       0,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       4,     2,     3,     2,     2,     1,     1,     1,     0,     2,
       2,     2,     2,     2,     1,     1,     3,     3,     0,     1,
       1,     2,     0,     1,     3,     1,     3,     1,     0,     2,
       2,     2,     2,     3,     3,     3,     0,     3,     1,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     4,     1,     0,     3,
       4,     1,     2,     0,     5,     5,     5,     5,     4,     3,
       3,     4,     5,     1,     0,     3,     4,     4,     0,     2,
       3,     3,     3,     2,     2,     2,     2,     3,     3,     2,
       2,     1,     1,     4,     0,     3,     3,     3,     0,     1,
       1,     4,     0,     2,     2,     2,     2,     2,     2,     2,
       0,     2,     9,     9,     4,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     1,     1,     3,     0,     1,     3,
       3,     3,     3,     4,     4,     4,     4,     2,     1,     1,
       1,     1,     0,     1,     0,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     0,     3,     1,     3,     1,     1,     1,     2,     3,
       2,     4,     0,     5,     0,     1,     1,     2,     1,     3,
       1,     1,     1,     1,     1,     1,     3,     1,     1,     1,
       1,     1,     3,     1,     5,    11,     1,     1,     1,     2,
       1,     7,     9,     7,     1,     1,     1,     3,     1,     1,
       1,     3,     1,     3,     1,     3,     3,     1,     2,     2,
       6,     1,     3,     0,     4,     3,     1,     3,     3,     3,
       2,     2,     2,     2,     0,     2,     2,     0,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     1,     1,     5,
       7,     0,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     4,
       1,     1,     1,     1,     2,     2,     3,     3,     6,     3,
       3,     3,     3,     5,     6,     6,     6,     6,     4,     8,
       4,     1,     1,     1,     1,     1,     1,     1,     0,     1,
       3,     1,     3,     0,     1,     4,     6,     4,     3,     5,
       5,     4,     6,     3,     2,     5,     5,     8,     8,     8,
       8,     2,     1,     2,     2,     2,     0,     3,     5,     0,
       2,     4,     4,     4,     2,     2,     0,     3,     0,     3,
       3,     2,     0,     2,     2,     0,     2,     0,     2,     4,
       5,     2,     3,     3,     5,     6,     7,     6,     4,     4,
       5,     6,     6,     5,     3,     3,     4,     5,     5,     5,
       5,     5,     4,     4,     5,     5,     5,     5,     5,     5,
       5,     5,     6,     6,     8,     6,     6,     5,     4,     5,
       4,     5,     4,     5,     4,     5,     5,     5,     5,     6,
       5,     5,     6,     5,     5,     4,     2,     3,     3,     1,
       2,     3,     2,     4,     2,     1,     2,     4,     0,     3,
       2,     1,     2,     3,     3,     3,     3,     2,     3,     0,
       5,     0,     5,     2,     2,     1,     4,     1,     1,     0,
       3,     2,     2,     2,     5,     2,     0,     3,     0,     2,
       2,     3,     2,     2,     3,     2,     2,     2,     1,     3,
       2,     2,     2,     2,     2,     2,     3,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     2,     3,
       2,     3,     3,     4,     2,     2,     2,     3,     3,     3,
       2,     3,     3,     3,     4,     2,     2,     1,     0,     2,
       3,     1,     0,     1,     2,     0,     2,     0,     1,     3,
       0,     0,     2,     0,     3,     0,     3,     0,     3,     3,
       1,     0,     4,     6,     6,     6,     7,     6,     7,     5,
       0,     2,     3,     2,     3,     3,     2,     3,     2,     2,
       3,     3,     5,     4,     4,     2,     3,     3,     4,     4,
       4,     5,     5,     4,     3,     4,     4,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     2,
       2,     3,     3,     4,     0,     3,     0,     3,     0,     3,
       2,     3,     3,     5,     5,     3,     2,     3,     3,     1,
       2,     4,     3,     3,     3,     2,     2,     2,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     2,     2,     2,     2,
       2,     3,     3,     3,     3,     3,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     0,     0,    69,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   371,     0,     0,
     746,   747,   748,   749,   750,   751,   752,   753,   754,   755,
     756,   757,   758,   759,   760,   761,   762,   763,   764,   765,
     766,   767,   768,   769,   770,   771,   772,   773,   774,   775,
     776,   777,   778,   779,   780,   781,   782,   783,   784,   785,
     786,   787,   788,   789,   790,   791,     3,     1,     2,     0,
       0,     0,     0,     0,     0,     0,   105,   106,     0,     0,
       0,     0,   371,     0,   731,   732,   733,   734,   735,   107,
     107,   736,   737,   738,   739,   103,   740,     0,   742,   107,
     110,   743,   744,   745,   107,   795,   107,   110,   107,   110,
     107,   110,   107,   110,   107,   110,     5,   741,   110,   110,
     258,   260,   259,     0,    70,    69,     0,     0,    69,    71,
      68,     0,     0,   230,     0,     0,     0,     0,   257,   262,
       0,   214,     0,     0,   198,   222,     0,   194,   194,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   354,   358,
     367,   364,   300,   373,   361,     0,     0,   357,   371,   403,
       0,     0,     0,   359,   360,     0,     0,     0,   371,     0,
     362,   363,   368,   401,   402,     0,   400,     0,   245,   244,
       0,   247,     0,     0,    34,    33,    36,     0,     0,     0,
      55,    54,    53,    52,     0,     0,     0,    97,     0,   264,
       0,    90,     0,     0,   266,   292,   108,     0,     0,   101,
      74,    80,   152,   481,   451,   536,   669,   675,   710,     0,
       0,     0,     0,     0,    18,   156,     0,     0,     0,     0,
       0,   794,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,    18,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,     0,     0,     0,     0,     0,     0,     0,     0,
      18,     0,   796,     0,     0,     0,    18,     0,     0,    18,
     797,   539,     0,     0,   545,     0,     0,     0,   798,     0,
       0,     0,   708,     0,     0,     0,     0,     0,     0,     0,
       0,   799,     0,     0,   177,   181,     0,     0,     0,     0,
     800,     0,     0,     0,     0,    18,     0,    18,     0,     0,
     792,     0,     0,     0,     0,    30,   793,     0,     0,   159,
     158,     0,     0,    71,    65,    66,     0,    72,     0,   251,
     249,     0,     0,     0,     0,   252,   170,   169,     0,     0,
     261,   263,   262,     0,   195,     0,   218,   190,   189,     0,
       0,   194,   193,   194,   194,   660,   194,   194,     0,     0,
      19,    20,     0,     0,     0,   240,   241,   237,   235,   236,
     238,   239,   354,   373,   354,   371,   354,   354,     0,   346,
       0,   371,     0,     0,     0,   357,   357,     0,   398,   371,
     371,   371,   371,   371,     0,   317,   318,     0,   320,     0,
       0,     7,   304,   302,     9,   371,   301,   303,   326,   324,
     325,   332,     0,   337,   341,     0,   813,   808,   809,   810,
     811,   374,   812,   375,   376,   377,   378,   379,   380,   381,
     382,   383,   815,   818,   817,   814,   816,   819,   820,   821,
     824,   822,   823,   825,   826,   827,   828,   829,   830,   404,
     405,   242,   371,   371,   371,   371,   371,   371,   371,   371,
     371,   371,   371,   371,   371,     0,    41,    42,    43,    44,
      45,    46,    47,    48,    49,     0,    39,   248,     0,   250,
     371,     0,    35,    37,     0,     0,   136,   371,   137,    56,
       0,     0,    62,     0,    98,    99,    86,    87,    88,   148,
       0,   281,   100,     0,    51,     0,     0,     0,   801,   805,
       0,   153,   113,   135,   121,     0,   111,    14,    16,    15,
      17,    13,   112,   138,   126,   281,   127,     0,     0,   371,
     115,   125,     0,   116,     0,   123,   114,   154,   155,   456,
     482,     0,     0,    18,   494,     0,     0,     0,     0,    18,
       0,    18,     0,     0,   495,     0,    21,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    18,     0,    18,     0,    18,     0,    18,     0,     0,
      18,    18,    18,     0,     0,   483,   537,   546,   540,    18,
     544,   542,   538,   548,   670,     0,     0,     0,   671,   676,
       0,   138,     0,   182,     0,   178,   691,   689,   690,     0,
       0,     0,     0,     0,     0,     0,   677,   684,   183,   711,
      18,   716,     0,   712,   726,     0,   725,     0,   729,     0,
     727,   728,   715,     0,    75,     0,    77,    18,    18,   803,
     804,   802,     0,    29,     0,   807,   806,   164,   163,   165,
     167,   168,   166,     0,   161,   255,     0,    67,    73,    63,
     231,   234,   253,   254,   174,   175,     0,   172,   256,     0,
     191,   196,   213,     0,   220,     0,   219,     0,   197,   204,
       0,     0,   212,   281,   206,   205,   209,   210,     0,   211,
     199,     0,   203,   221,   229,   223,   226,   227,   225,   228,
     224,     0,   651,   651,     0,   194,   651,   194,   651,   652,
     730,     0,     0,    23,     0,     0,   350,   351,     0,   352,
     353,   348,   336,   431,   434,     0,   411,     0,   412,   355,
     356,   349,     0,     0,     0,     0,     0,     0,   319,   371,
     384,   371,   313,   311,     0,     0,   310,     0,     0,   365,
     338,   339,     0,     0,   366,   396,   394,   392,   389,   390,
     391,   393,   395,   397,   385,   386,   387,   388,   406,     0,
     407,   409,   410,   246,     0,   243,     0,    32,     0,    31,
       0,     0,    58,    59,    60,    61,     0,   138,     0,    84,
     267,   268,   269,   270,   271,   272,   273,   274,   275,   276,
     277,   278,     0,     0,     0,   265,   285,    94,    95,     0,
       0,    89,    91,    50,     0,   281,   109,     0,   104,   122,
     142,   145,   157,   286,   287,   124,   134,   128,   118,    18,
     288,   119,   117,   110,     0,     0,     0,     0,     0,    18,
     520,   522,     0,     0,     0,     0,    18,     0,     0,   535,
     496,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   488,     0,   489,     0,   518,
       0,     0,     0,     0,     0,     0,     0,   502,   503,     0,
       0,     0,   524,     0,   541,     0,     0,     0,   673,   674,
       0,   706,   688,   679,     0,     0,   683,   678,   680,     0,
     686,   687,   685,     0,     0,     0,     0,     0,     0,   722,
      21,   724,     0,   719,   723,    83,    76,    78,    79,    81,
      25,    24,    82,   160,     0,    64,   171,     0,   192,   217,
     216,   215,   201,   208,   202,   200,   207,   480,   650,     0,
       0,   659,   668,     0,   666,     0,     0,   663,   661,     0,
     651,     0,   651,     0,    26,    27,     0,     0,   347,   371,
     420,     0,   371,   371,   371,   399,   371,   418,   371,     0,
       0,   371,   371,   371,     8,   300,   327,   333,     0,     0,
     342,   371,    40,     6,    38,    57,    96,   149,    85,   280,
     279,   281,   371,    92,    93,   290,   283,     0,   293,     0,
     143,     0,   138,     0,   133,   120,   459,   459,     0,   458,
     452,     0,     0,     0,     0,   531,   530,     0,   521,   525,
     526,   527,     0,   517,   511,    22,     0,   484,     0,   490,
       0,   493,     0,   498,   497,   510,   509,   504,     0,     0,
     519,   507,   499,   500,   501,   523,   533,   506,   505,   534,
     508,   528,     0,   543,   640,    18,     0,    18,   559,     0,
       0,   561,   551,    18,   547,     0,   565,   641,   672,   682,
     704,   709,   176,   178,   681,     0,     0,     0,     0,     0,
     180,   713,   714,   721,    21,     0,   720,   162,   173,   654,
     653,   667,   662,   664,   665,     0,   655,     0,   657,     0,
       0,   432,   413,     0,     0,     0,     0,     0,   371,   369,
     312,   310,     0,     0,   316,     0,     0,   282,     0,   424,
       0,   425,   426,     0,   371,   422,   423,   421,   371,   371,
       0,   371,     0,     0,   371,   296,     0,   289,     0,   139,
     140,   144,   146,   131,   129,   130,   132,   138,   453,   468,
     454,   472,   455,   457,     0,   513,   532,   515,   516,     0,
     485,   492,   491,   512,   487,   529,   138,   564,   552,     0,
       0,    18,     0,   550,     0,     0,   568,   563,   567,     0,
       0,   557,   549,     0,   575,   697,   179,   183,    28,     0,
       0,     0,     0,   717,   718,   656,   658,   230,   230,   417,
     415,   416,   414,   371,     0,   314,   371,     0,   408,   371,
     371,   371,   371,     0,     0,     0,   291,   297,     0,     0,
     444,   427,   429,     0,   284,     0,   141,   147,   468,   466,
     471,     0,     0,   475,     0,   486,   643,   647,   554,   555,
     553,   556,   628,   589,   569,   628,   558,   642,   576,     0,
       0,     0,     0,   707,     0,   188,   183,   183,   183,   183,
       0,     0,     0,   370,     0,     0,     0,   340,     0,     0,
       0,     0,   438,   371,   343,   371,   371,     0,   371,   443,
       0,   470,     0,   473,   474,     0,   477,   514,   641,   645,
     649,     0,     0,     0,   578,     0,     0,     0,   700,   698,
      18,   692,   693,   694,   695,   696,   699,   705,   184,   185,
     186,   187,   232,   233,   419,   371,   323,   371,   321,   437,
     372,   441,     0,   371,   435,   298,     0,     0,     0,     0,
       0,     0,     0,     0,   430,     0,    18,     0,     0,     0,
       0,   469,     0,   476,    18,   479,   644,     0,   560,   631,
     629,   632,    18,     0,    18,   566,     0,   562,     0,     0,
       0,     0,     0,     0,   574,   588,     0,   150,   151,   701,
       0,   702,     0,     0,     0,     0,   371,   371,   305,   309,
     307,   371,   445,   308,   330,   328,   329,   334,     0,   440,
     439,   371,   371,   371,   371,   446,   102,   465,     0,     0,
       0,     0,   460,   464,   467,   478,     0,     0,     0,    18,
       0,     0,     0,    18,    18,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   648,   627,
       0,   633,     0,     0,   572,   573,   571,   570,   582,   580,
     579,     0,     0,   583,   585,   586,   587,   577,   703,   371,
     322,   442,   299,   436,   345,   310,     0,   371,     0,     0,
       0,     0,     0,     0,     0,     0,    10,    11,    12,    18,
     594,   635,   625,     0,     0,     0,   620,    18,   626,   610,
     590,   593,   591,     0,   608,     0,   595,   597,   598,   599,
     600,   601,   602,   603,   604,    18,   614,   615,   616,    18,
     592,     0,    18,   646,   634,   630,   581,   584,     0,   306,
     371,   331,   344,   335,     0,     0,     0,     0,   461,   462,
     463,   611,     0,   618,   617,   619,   621,   622,     0,   623,
     607,   596,   606,   609,   612,   605,   315,     0,   450,   448,
     449,   447,   637,   613,   636,   624,   638,     0,   639
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,    85,   541,  1422,   542,   382,   872,   941,
     942,   733,  1209,   664,    86,   502,   197,   505,   495,   496,
      87,   204,   205,    88,    20,    21,    22,    23,    24,    25,
     129,   348,    89,   331,    90,   337,   332,    91,   520,    92,
     523,   832,    93,   515,    94,    95,   530,    96,    97,   217,
     242,   550,  1024,   848,   534,    98,   840,  1161,  1021,   841,
     842,  1248,   807,   808,  1318,    99,   100,   543,   243,   342,
     673,   674,   359,   686,   687,   313,   914,   314,   315,   926,
      26,    27,    28,    29,   378,    30,    31,    32,   369,   711,
      33,   366,   697,    34,   370,   352,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,   191,   498,
      47,    48,    49,    50,    51,    52,    53,    54,    55,   123,
     363,   101,   521,   102,   822,   823,   824,  1017,   844,   845,
     551,   835,   826,   103,   526,  1150,  1151,  1344,   180,   428,
    1404,   763,   764,   429,  1133,   765,   430,   431,  1407,   432,
    1408,   181,   434,   435,  1346,   397,   182,   398,   407,   183,
     184,   185,  1153,   186,   469,  1131,  1154,  1242,  1243,   744,
     745,  1155,   104,  1031,   853,   105,  1167,  1362,  1302,  1250,
    1168,  1170,  1253,  1306,  1365,  1172,    56,   106,   107,   108,
     109,   292,   293,   294,   906,  1085,  1194,  1199,  1197,  1198,
    1312,  1376,  1086,  1314,  1386,  1087,  1450,  1311,  1370,  1371,
    1453,  1542,  1567,  1564,  1186,  1204,  1257,  1308,  1367,  1310,
    1187,   959,    57,    58,    59,    60,    61,    62,    63,    64,
     724,   110,   111,   112,   113,   629,  1326,  1274,  1205,  1091,
     621,   622,   114,   115,   322,   933,   934,   323,    65,   116,
      66,   117,   118,   119,   470
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -1248
static const yytype_int16 yypact[] =
{
      44,  2402,    66,   656,   649,   754,   103,   649,   649,    47,
     499,   649,   278,  1481,   253,   257,   911,  1423,    18,   649,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,   314,
     653,   158,   568,   306,   367,   322, -1248, -1248,   372,   337,
     357,   287,  1423,   480, -1248, -1248, -1248, -1248, -1248,   487,
     487, -1248, -1248, -1248, -1248,   153, -1248,   900, -1248,   487,
    1205, -1248, -1248, -1248,   487, -1248,   487,  2225,   487,  2155,
     487,  2293,   487,  1979,   487,  2261, -1248, -1248,  2089,  1016,
   -1248, -1248, -1248,   122, -1248,   514,   535,   550,   514,   478,
   -1248,   558,   570,   501,   649,   649,   582,   208, -1248,   655,
     107, -1248,   589,   598, -1248, -1248,   386,   284,   593,   625,
     625,   616,   623,   648,   683,   688,   704,   710,    12, -1248,
   -1248, -1248,   629,   378, -1248,   564,    49,    -5,  1423, -1248,
     418,   425,   442, -1248, -1248,   444,   446,   450,   806,   178,
   -1248, -1248, -1248, -1248, -1248,  1951, -1248,  2094, -1248, -1248,
    1504,   800,   817,   805, -1248,   769, -1248,     6,   122,    70,
   -1248, -1248, -1248, -1248,   540,   507,   706,   741,   283, -1248,
     862, -1248,   527,   208,  2552, -1248,   798,   551,   557, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,   562,
     122,   916,   853,    70,   192, -1248,   377,   490,   844,   926,
     208, -1248,   590,   592,   585,   591,    68,   875,   601,   719,
     943,   192,   864,   695,   -16,   847,   192,   143,   625,   469,
     907,   755,   909,   760,   757,   432,   750,   752,   500,   746,
     743,   192,   748,   739,   740,   -27,   -37,   765,   734,   738,
     192,   788, -1248,   657,   654,   709,   192,   936,    70,   192,
   -1248, -1248,   661,   658, -1248,   668,   953,   427, -1248,   675,
     674,   977, -1248,  1027,    70,   690,   -34,    70,    70,   982,
     -84, -1248,   698,   699, -1248,   697,   705,   771,   625,   987,
   -1248,   703,   519,   725,   989,   192,  1019,   192,  1014,  1015,
   -1248,   751,   756,   761,  1022,  1079, -1248,   762,   763, -1248,
   -1248,   976,  1101,   478, -1248, -1248,  1102,    70,  1110, -1248,
   -1248,  1103,  1120,  1121,  1127, -1248, -1248, -1248,   214,  1131,
   -1248, -1248,   747,  1133, -1248,  1140,   673, -1248, -1248,  2530,
    1178,   593, -1248,   593,   593, -1248,   332,   347,  1141,  1142,
   -1248, -1248,    -4,  1028,  1029, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248,    12, -1248,    12,  1423,    12,    12,  1136, -1248,
    1132,   851,  1134,   955,  1146,    -5,    -5,  1138,  1129,  1423,
    1423,  1423,  1423,  1423,  1150, -1248, -1248,  1155, -1248,   810,
      46, -1248, -1248, -1248, -1248,   742, -1248, -1248,  1168, -1248,
   -1248, -1248,   211,    19, -1248,   244, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248,  1423,  1423,  1423,  1423,  1423,  1423,  1423,  1423,
    1423,  1423,  1423,  1423,  1423,   608, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,   426, -1248, -1248,  1173, -1248,
    1423,  1158, -1248, -1248,  1504,   821, -1248,  1423, -1248,    70,
     735,   803, -1248,    70, -1248, -1248, -1248, -1248, -1248, -1248,
     822,  2338, -1248,   189, -1248,   824,   830,  1174, -1248, -1248,
     -57, -1248, -1248, -1248, -1248,   709, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,  1910, -1248,   154,  1089,  1423,
   -1248, -1248,   154, -1248,   154, -1248, -1248, -1248, -1248, -1248,
   -1248,  1144,  1145,   141, -1248,  1171,   849,   865,    70,   109,
     961,   192,   625,   866, -1248,   869,  1201,    70,  1114,    70,
    1166,    70,  1169,   -39,    70,    70,   192,  1175,   881,  1161,
     887,   192,   893,   192,   262,   192,   916,   192,   896,   898,
     192,   192,   192,   901,  1125, -1248, -1248, -1248, -1248,   192,
   -1248,  1163, -1248, -1248, -1248,  1242,   906,   910, -1248, -1248,
      70, -1248,   913, -1248,   914,  1185, -1248, -1248, -1248,   917,
     924,   932,    70,   935,   944,   945, -1248, -1248,     1, -1248,
     192, -1248,   916, -1248, -1248,   778, -1248,   625, -1248,  1038,
   -1248, -1248, -1248,    70, -1248,    70, -1248,   192,   192, -1248,
   -1248, -1248,    70, -1248,   625, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248,   525, -1248, -1248,  1270, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248,   530, -1248, -1248,  1304,
   -1248, -1248, -1248,  1290, -1248,  1296, -1248,   625, -1248, -1248,
    1299,  1300, -1248,  1910, -1248, -1248, -1248, -1248,   625, -1248,
   -1248,  1302, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248,  1319,  1305,  1305,   941,   593,  1305,   593,  1305, -1248,
   -1248,    70,   625, -1248,  1312,  1314, -1248, -1248,   831, -1248,
   -1248, -1248, -1248,    89, -1248,   978, -1248,  1310, -1248, -1248,
   -1248, -1248,   176,   267,   317,  1017,   422,     5, -1248,  1423,
   -1248,  1423, -1248,  1332,   979,   988,  1130,   200,   245, -1248,
   -1248, -1248,  1326,  1324, -1248,  2377,  2377,  2377,  2626,  2626,
    2377,  2377,  2377,  2377,   488,   488,  1129,  1129, -1248,   996,
   -1248, -1248, -1248, -1248,  1504, -1248,  1844, -1248,   533, -1248,
    1130,  1338, -1248, -1248, -1248, -1248,  1001, -1248,  1002, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248,    72,  1006,  1005, -1248, -1248, -1248, -1248,   625,
      70, -1248, -1248, -1248,  1317,  2338, -1248,   625, -1248, -1248,
    1341, -1248,  1008, -1248, -1248, -1248, -1248,  1271, -1248,   192,
    2552, -1248, -1248,  1139,    70,    70,    70,  1012,  1018,   192,
   -1248, -1248,  1023,  1024,  1032,  1033,   192,  1034,  1035, -1248,
   -1248,  1354,  1253,  1040,    70,  1042,    70,  1049,    70,  1050,
    1058,  1060,  1064,  1065,    70, -1248,   709, -1248,  1066, -1248,
    1067,  1068,  1070,  1072,  1074,  1075,  1076, -1248, -1248,  1077,
    1086,  1090, -1248,   205, -1248,    70,  1143,  1098, -1248, -1248,
    1099,   -92, -1248, -1248,  1095,  1104, -1248, -1248, -1248,  1105,
   -1248, -1248, -1248,    70,   293,   390,  1097,  1109,  1112, -1248,
    1201, -1248,   625,  1059,  1038, -1248, -1248, -1248, -1248, -1248,
      -4, -1248, -1248, -1248,   976, -1248, -1248,   214, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,  1382,
    1383, -1248, -1248,   709, -1248,   709,  1422, -1248, -1248,   709,
    1305,  1465,  1305,  1471, -1248, -1248,  1360,  1374, -1248,  1423,
   -1248,  1449,  1423,  1423,  1423, -1248,  1423, -1248,  1423,   613,
    1176,  1423,   889,  1423, -1248, -1248, -1248, -1248,  1135,   629,
   -1248,  1423, -1248, -1248, -1248, -1248, -1248,  1008, -1248, -1248,
   -1248,  2338,   366, -1248, -1248, -1248,  1147,  1148, -1248,  1378,
   -1248,   827, -1248,   468, -1248, -1248, -1248, -1248,   625, -1248,
   -1248,  1149,  1137,  1152,  1153, -1248, -1248,  1154, -1248, -1248,
   -1248, -1248,  1156, -1248, -1248, -1248,    70, -1248,  1159, -1248,
    1160, -1248,  1162, -1248, -1248, -1248, -1248, -1248,  1164,  1170,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248,  1172, -1248, -1248,   192,   308,    45, -1248,  1192,
     625, -1248, -1248,   118, -1248,  1187, -1248,  1189, -1248, -1248,
   -1248, -1248, -1248,  1185, -1248,  1188,  1499,  1499,  1499,  1499,
   -1248, -1248, -1248, -1248,  1201,    70,  1059, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,  1518, -1248,  1526, -1248,  1516,
    1517, -1248, -1248,  1322,  1515,  1551,  1586,   638,  1423, -1248,
   -1248,  2552,  1197,  1194,  2552,  1549,  1625, -1248,    -6, -1248,
    1511, -1248, -1248,  1206,  1423, -1248, -1248, -1248,  1423,  1423,
    1203,    77,  1951,  1209,  1297, -1248,  2338, -1248,  1566,   625,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,  1220,
   -1248,     4, -1248, -1248,    70, -1248, -1248, -1248, -1248,  1226,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,    70,
      70,   192,    70, -1248,  1223,   709, -1248, -1248,  1225,  1228,
      70, -1248, -1248,    70,  1237,   271, -1248,     1, -1248,  1230,
    1243,  1244,  1245, -1248, -1248, -1248, -1248,   501,   501, -1248,
   -1248, -1248, -1248,  1423,  1661,  1597,  1386,  1254, -1248,  1423,
     851,  1423, -1248,  1869,  2025,   693, -1248, -1248,  1583,    55,
   -1248,  2552,  1252,  1262, -1248,  1500, -1248,  1008,  1220, -1248,
   -1248,  1602,  1604,  1409,  1273, -1248,  1008,  1284, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,   -38,
      70,  1361,   335, -1248,  1301, -1248,     1,     1,     1,     1,
    1655,  1657,  1686, -1248,  1303,  1306,     7, -1248,  1894,  1307,
    1925,  2015, -1248,   915, -1248,  1423,  1423,   809,  1297, -1248,
    1646, -1248,   402, -1248, -1248,   625,  1447, -1248,  1189, -1248,
   -1248,    11,   203,    24,   420,    70,    70,    70, -1248, -1248,
     388, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,  1423, -1248,  1423, -1248, -1248,
   -1248, -1248,  1308,   366,  1484, -1248,    20,  1950,  1978,  1315,
    1316,  1320,  1321,  1318, -1248,  1323,   192,   686,  1464,    70,
      70, -1248,  1334, -1248,   192, -1248, -1248,  2312, -1248, -1248,
   -1248,     2,   192,    70,   192, -1248,  1342, -1248,    70,    70,
      70,  1466,   155,    16, -1248, -1248,  1345, -1248, -1248, -1248,
    1387, -1248,  1340,  1346,  1347,  1339,   915,   123, -1248, -1248,
   -1248,   742, -1248, -1248,  1700, -1248, -1248, -1248,   375, -1248,
   -1248,  1423,  1423,  1423,  1423, -1248, -1248, -1248,  1501,  1502,
    1509,   812, -1248, -1248, -1248, -1248,  1414,    70,  1364,   192,
    1415,   -33,  1456,   192,   192,    70,    70,    70,  1494,    70,
     206,  1344,  1401,    97,  1435,    70,  1411,  1448, -1248, -1248,
    1393, -1248,    70,  1395, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248,    70,    70, -1248, -1248, -1248, -1248, -1248, -1248,  1423,
   -1248, -1248, -1248, -1248, -1248,  1711,   132,   123,   164,  1738,
    1768,  1793,  1818,    70,    70,    70, -1248, -1248, -1248,   192,
   -1248, -1248, -1248,   112,    70,    70, -1248,   520, -1248, -1248,
   -1248, -1248, -1248,    70, -1248,    70, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,   192, -1248, -1248, -1248,   192,
   -1248,    70,   192, -1248, -1248, -1248, -1248, -1248,  1381, -1248,
    1423, -1248, -1248, -1248,  1396,  1397,  1398,  1399, -1248, -1248,
   -1248, -1248,    26, -1248, -1248, -1248, -1248, -1248,  1432, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248,  1711, -1248, -1248,
   -1248, -1248,  1453, -1248, -1248, -1248, -1248,  1410, -1248
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1248, -1248, -1248, -1248,   -74,  -573,  -239,  -236,  -891,  -147,
    -684, -1248,  -159, -1248, -1248, -1248, -1248, -1248,  1265,   980,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
     626,  1428, -1248, -1248, -1248, -1248, -1248, -1248,  -281, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,  1365,
    -100,  1535, -1248,   191,  -474, -1248, -1248, -1248, -1248,   753,
    -615, -1248, -1248, -1248,   342, -1248, -1248, -1248, -1248,   -94,
   -1248,   837,   296, -1248,   836, -1247,   691,  -617, -1248,  -623,
   -1248, -1248, -1248, -1248,  -127, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,  -296, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,   876,
    1424, -1248, -1248, -1248, -1248,  -801,   774,   631,  1267,  1096,
    1429, -1248,   971, -1248, -1248, -1063, -1248,   411,  -178,  1041,
     333,  -971,   818, -1223,  -916,  1633, -1211,  1044,   345, -1248,
   -1248,  -174,  1051, -1248, -1248, -1248, -1248,   336,   526, -1248,
   -1248,  -984, -1248,   180,   662,   -17, -1248, -1248,   515,   852,
     602, -1061, -1248, -1248, -1248, -1248,   808, -1248, -1248,   588,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248,   572, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,   531, -1248, -1248, -1248, -1248,
   -1248,  -285, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1248,   899, -1248, -1248, -1248, -1248,
   -1248, -1248, -1248, -1248, -1020
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -434
static const yytype_int16 yytable[] =
{
     187,   427,   383,   384,   607,   433,   911,   283,   915,   291,
     405,   299,   567,   312,  1337,   321,  1229,   573,   333,   338,
    1130,   379,   576,   578,   955,   731,  1397,   392,  1152,   380,
     381,   393,   592,  1016,  1251,  1398,  1399,  1400,   995,  1103,
     394,   603,   380,   381,  1562,   770,   771,   608,     1,   503,
     611,   598,   596,   188,   472,   473,   474,   475,   476,   626,
     421,   189,   837,   879,   424,   214,    67,  1385,   477,   478,
     479,   480,   481,   482,   483,   484,   403,  1296,   485,   537,
     538,   539,   540,  -295,   923,   421,   654,  1297,   656,   424,
    1237,  1009,  -295,  -295,  -295,  -295,  1138,   472,   473,   474,
     475,   476,  1315,  1316,   506,   426,   130,  1315,  1316,  1464,
     364,   477,   478,   479,   480,   481,   482,   483,   484,   924,
    1449,   485,   895,  1405,   421,   508,  1139,   421,   424,  -294,
     570,   424,  1239,   421,   633,  1406,   532,   424,  -294,  -294,
    -294,  -294,  1138,   537,   538,   539,   540,  1398,  1399,  1400,
     995,   408,   537,   538,   539,   540,   421,   339,   421,   536,
     424,   420,   424,  1140,   925,   340,   133,  1152,   928,   421,
     421,   641,  1139,   424,   424,   537,   538,   539,   540,  1398,
    1399,  1400,   995,   575,   472,   473,   474,   475,   476,   846,
    1516,   880,  1007,   421,   422,   423,   162,   424,   477,   478,
     479,   480,   481,   482,   483,   484,   597,   421,   485,  1140,
     561,   424,   856,  1213,   610,   421,   422,   423,   995,   424,
     421,   421,   710,  1252,   424,   424,   537,   538,   539,   540,
     624,   599,  1345,   630,   631,   571,  1141,  1142,  1143,  1144,
    1145,  1146,  1147,   356,   721,  1010,   722,   723,  1291,   726,
     728,   357,   365,  1317,   839,  1405,  1148,   404,  1494,  1149,
     421,   422,   423,   995,   424,   634,   635,  1406,   198,  1462,
    1090,  1342,  1022,   678,   199,   472,   473,   474,   475,   476,
    1395,   138,  1141,  1142,  1143,  1144,  1145,  1146,  1147,   477,
     478,   479,   480,   481,   482,   483,   484,  1495,   516,   485,
     517,   518,  1148,   372,   562,  1149,   838,   212,   684,  1152,
    1286,  1451,   627,   628,   827,   828,   829,   830,  1465,  1452,
    1505,  1466,   863,   864,   858,   472,   473,   474,   475,   476,
     865,  1192,   867,   193,  1474,  1345,   868,  1160,   399,   477,
     478,   479,   480,   481,   482,   483,   484,   883,  1372,   485,
     685,   372,   888,  1230,   890,  1016,   894,   732,   896,  1152,
     406,   899,   900,   901,  1392,   987,   372,  1338,   504,   988,
     904,   395,   149,   373,  1368,   725,   150,   396,   738,  1401,
     190,   772,   206,  1402,   743,  1138,   207,  1377,   519,  1563,
     727,   209,   752,   753,   754,   755,   756,   213,  1096,  1517,
    1097,   927,  1518,   421,   507,   208,   760,   424,   766,   930,
     761,   931,  1152,  1152,  1532,  1139,   210,   857,   937,   938,
     544,  1393,   537,   538,   539,   540,  1543,  1544,   940,   507,
     472,   473,   474,   475,   476,   801,  -295,   374,   960,   806,
    -295,   971,  1200,   973,   477,   478,   479,   480,   481,   482,
     483,   484,  1140,   979,   485,   775,   776,   777,   778,   779,
     780,   781,   782,   783,   784,   785,   786,   787,   507,   545,
     546,   507,   940,   847,   547,  1246,   915,   507,   847,   548,
     847,   211,  -294,   796,   341,  1269,  -294,   380,   381,  1373,
     800,  1530,   891,  1152,   862,  1098,   975,  1099,  1528,   215,
     507,   574,   507,   873,  1270,   875,   216,   877,  1356,   525,
     881,   882,  1374,   507,   507,   219,   483,   484,   120,   121,
     485,   892,   893,  1401,   303,  1141,  1142,  1143,  1144,  1145,
    1146,  1147,   850,   544,   124,   421,   556,   425,   344,   424,
     982,  1271,   122,   347,  1163,  1148,   910,   831,  1149,   305,
     951,   507,  1247,   345,   537,   538,   539,   540,   919,   507,
     509,   349,  1378,  1071,   507,   507,  1375,  1164,  1165,  1166,
     358,  1256,   399,   350,   399,   768,   399,   399,   769,   935,
     351,   936,   545,   546,  1275,   355,   549,   552,   939,   427,
     427,   577,   367,  1013,  1189,  1190,   510,   511,   970,   433,
     972,   368,  1390,   375,   425,  1059,  1272,   371,   773,   200,
    1025,   774,   372,  1357,  1358,   376,   377,  1359,  1360,   385,
    1037,   472,   473,   474,   475,   476,   386,  1042,   201,  1321,
    1191,   983,   134,   135,  1273,   477,   478,   479,   480,   481,
     482,   483,   484,   380,   381,   485,   472,   473,   474,   475,
     476,   387,   202,  1328,  1329,  1330,  1331,   974,   400,    68,
     477,   478,   479,   480,   481,   482,   483,   484,   120,   121,
     485,   584,   585,   194,   360,   361,   692,  1322,  1323,  1324,
    1325,   984,  1111,   644,  1112,  1115,   388,  1117,  1114,    69,
    1019,   389,   122,   426,   426,   195,  1104,    70,   362,   549,
      71,   472,   473,   474,   475,   476,   196,   390,  1379,  1380,
    1381,    72,  1382,   391,   203,   477,   478,   479,   480,   481,
     482,   483,   484,  1383,   516,   485,   517,   518,   736,  -294,
     737,    73,   739,   740,  1548,    74,  1477,   401,    75,  1478,
      76,    77,   989,   851,   990,   852,   645,   507,    78,   588,
     589,   343,   693,  1030,   346,   158,  1014,   159,   160,   161,
     162,   163,   164,   616,   617,  1361,   360,   361,   165,   166,
     762,   167,   402,   168,   124,    79,   788,   409,   646,    80,
    1032,  1033,  1034,  1384,   410,   940,   986,   647,   694,   793,
     794,    81,  1171,   802,   803,   695,   380,   381,   929,   789,
    1048,   411,  1050,   412,  1052,   413,   696,   790,   125,   414,
    1058,    82,   791,   792,    83,   497,   126,   127,   128,   158,
     499,   159,   160,   161,   162,   163,   164,   500,   169,  1072,
     501,  1073,   165,   166,   170,   167,  1188,   168,  1193,   472,
     473,   474,   475,   476,  1201,   380,   381,  1159,   513,  1095,
    1486,  1487,  1488,   477,   478,   479,   480,   481,   482,   483,
     484,   804,   805,   485,   158,   512,   159,   160,   161,   162,
     163,   164,   514,   648,   649,   650,   651,   165,   166,   507,
     167,   522,   168,   131,   132,   524,   136,   137,   943,   944,
     171,   172,   169,   946,   947,   192,  1004,   794,   170,  1418,
    1419,  1349,   158,   527,   159,   160,   161,   162,   163,   164,
    1538,  1539,  1540,   528,  1263,   165,   166,   762,   167,   529,
     168,  1280,  1281,   940,   531,   173,   174,   415,   416,   417,
     418,   749,   750,  1196,  1138,   533,   535,   169,  1210,  1211,
    1212,   554,   175,   170,   961,   176,   555,   559,   557,   177,
     558,   563,  1260,   560,   171,   172,   565,  1350,  1351,   564,
     962,   568,   743,   566,  1139,  1123,  1124,  1125,   220,  1126,
     569,  1127,  1179,   221,   572,   169,  1134,  1128,   579,   580,
     581,   170,   582,   586,  1136,   151,   583,   587,   222,   173,
     174,   415,   416,   417,   418,   590,   591,   594,   600,   171,
     172,  1140,  1223,   595,   593,   601,   175,   602,   604,   176,
     353,   354,  1352,   177,    84,   605,   606,  1353,   609,   612,
     613,   152,   153,   963,   223,   472,   473,   474,   475,   476,
     614,  1214,   615,   618,   173,   174,   619,   171,   172,   477,
     478,   479,   480,   481,   482,   483,   484,   623,   620,   485,
     667,   175,   625,   632,   176,  1294,   636,   637,   177,   638,
     230,   643,   154,   155,   156,   157,   642,   639,   653,  1363,
     668,   669,   173,   174,  1141,  1142,  1143,  1144,  1145,  1146,
    1147,  1391,   640,   652,   670,   671,   334,   672,   657,   175,
     655,   658,   176,   662,  1148,   231,   177,  1149,   232,   663,
    1254,   178,   233,   234,   675,   677,   236,   237,   179,   659,
     224,  1224,   238,   679,   660,  1258,  1259,  1417,  1261,   661,
     665,   666,   680,   681,   682,  1425,  1266,  1233,   335,  1267,
     683,  1234,  1235,  1454,   688,  1456,   690,  1241,   472,   473,
     474,   475,   476,   691,   729,   730,   239,   742,   734,   735,
     741,   240,   477,   478,   479,   480,   481,   482,   483,   484,
     746,   485,   485,   747,  1369,   178,  1369,   751,  1403,   757,
     758,   964,   179,   748,   759,   767,   795,   225,   797,   799,
     809,   713,   833,   230,   472,   473,   474,   475,   476,   834,
    1492,   978,   849,   836,  1498,  1499,  1319,   714,   477,   478,
     479,   480,   481,   482,   483,   484,  1282,   860,   485,  1134,
     178,  -433,  1288,   743,  1290,   854,   855,   179,   231,   965,
     859,   232,   866,   861,   869,   233,   234,   870,  1026,   236,
     237,   871,  1074,   226,   966,   238,   874,   876,   227,   885,
     878,  1387,  1388,  1389,   886,   887,   884,   903,   178,   230,
    1541,   889,   967,   228,   897,   179,   898,   715,  1549,   902,
     905,   907,   716,   717,   908,   932,   968,   969,   909,   239,
     718,   912,   913,   945,   240,   916,  1552,  1343,  1347,  1348,
    1553,  1241,   917,  1555,   231,  1421,  1423,   232,  1075,   303,
     918,   233,   234,   920,   235,   236,   237,   719,  1403,  1455,
    1403,   238,   921,   922,  1458,  1459,  1460,   948,  1463,   949,
     158,   950,   159,   160,   161,   162,   163,   164,   952,   953,
    1134,   956,   957,   165,   166,   958,   167,   976,   168,   977,
     472,   473,   474,   475,   476,   239,   720,   981,   980,   991,
     240,   998,   999,   992,   477,   478,   479,   480,   481,   482,
     483,   484,   993,  1490,   485,  1001,  1027,  1028,  1005,  1006,
    1008,  1500,  1501,  1502,  1011,  1504,  1506,  1012,  1020,  1023,
    1035,  1520,  1022,  1045,  1076,  1046,  1036,   985,  1524,   336,
    1105,  1038,  1039,   169,  1475,  1109,  1110,  1526,  1527,   170,
    1040,  1041,  1043,  1044,  1479,  1480,  1481,  1482,  1047,   158,
    1049,   159,   160,   161,   162,   163,   164,  1051,  1053,  1421,
    1421,  1421,   165,   166,  1285,   167,  1054,   168,  1055,  1545,
    1546,  1547,  1056,  1057,  1060,  1061,  1062,  1077,  1063,  1550,
    1064,  1551,  1065,  1066,  1067,  1068,   158,  1113,   159,   160,
     161,   162,   163,   164,  1069,   171,   172,  1554,  1070,   165,
     166,  1078,   167,  1079,   168,   218,  1088,  1089,  1092,  1080,
    1100,  1081,  1093,  1094,   229,  1082,  1083,  1101,  1116,   244,
    1102,   245,   169,   284,  1118,   295,  1122,   300,   170,   316,
     173,   174,  1119,   810,   811,   812,   813,   814,   815,   816,
     994,   817,   818,   819,   820,   821,  1120,   175,  1158,  1135,
     176,  1174,  1029,  1195,   177,  1156,  1084,  1173,  1157,   169,
    1175,  1176,  1177,  1557,  1178,   170,  1203,  1180,  1181,  1208,
    1182,  1215,  1183,   472,   473,   474,   475,   476,  1184,  1216,
    1185,  1217,  1218,  1231,   171,   172,  1129,   477,   478,   479,
     480,   481,   482,   483,   484,  1202,  1207,   485,   486,   487,
     488,   489,   490,   491,   492,   493,   494,  1225,  1226,   472,
     473,   474,   475,   476,  1227,  1232,  1236,  1240,   241,   173,
     174,   171,   172,   477,   478,   479,   480,   481,   482,   483,
     484,  1245,  1249,   485,  1255,  1262,   175,  1264,  1276,   176,
    1265,   139,   140,   177,   472,   473,   474,   475,   476,  1268,
     141,  1277,  1278,  1279,  1284,  1295,   173,   174,   477,   478,
     479,   480,   481,   482,   483,   484,  1298,  1287,   485,   142,
    1299,  1303,  1300,   175,  1304,   143,   176,   144,   145,  1305,
     177,  1307,  1320,   472,   473,   474,   475,   476,  1507,  1508,
    1509,  1510,  1511,  1512,  1513,  1514,  1309,   477,   478,   479,
     480,   481,   482,   483,   484,  -428,   178,   485,  1332,  1327,
    1333,  1355,  1335,   179,  1364,  1396,  1336,  1340,  1394,   472,
     473,   474,   475,   476,  1411,  1412,  1415,  1015,  1420,  1413,
    1414,  1416,  1219,   477,   478,   479,   480,   481,   482,   483,
     484,   146,  1424,   485,   472,   473,   474,   475,   476,  1468,
    1457,  1461,  1472,  1467,  1469,  1471,  1470,  1476,   477,   478,
     479,   480,   481,   482,   483,   484,  1483,  1484,   485,   472,
     473,   474,   475,   476,  1485,  1489,  1491,  1497,  1493,  1503,
    1515,  1519,  1521,   477,   478,   479,   480,   481,   482,   483,
     484,  1556,  1522,   485,  1565,   178,   472,   473,   474,   475,
     476,  1523,   179,  1525,  1558,  1559,  1560,  1561,   147,  1566,
     477,   478,   479,   480,   481,   482,   483,   484,  1568,   798,
     485,   676,   553,  1496,  1002,  1162,   472,   473,   474,   475,
     476,  1107,   178,  1108,  1206,  1137,   689,  1244,   825,   179,
     477,   478,   479,   480,   481,   482,   483,   484,   712,   954,
     485,   472,   473,   474,   475,   476,  1018,  1473,   996,  1531,
    1132,   419,   997,  1354,  1238,   477,   478,   479,   480,   481,
     482,   483,   484,  1533,  1000,   485,   472,   473,   474,   475,
     476,  1121,  1289,  1106,   148,  1169,  1301,  1313,     0,  1366,
     477,   478,   479,   480,   481,   482,   483,   484,     0,     0,
     485,     0,   472,   473,   474,   475,   476,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   477,   478,   479,   480,
     481,   482,   483,   484,     0,  1220,   485,   472,   473,   474,
     475,   476,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   477,   478,   479,   480,   481,   482,   483,   484,     0,
       0,   485,   472,   473,   474,   475,   476,     0,     0,     0,
       0,  1221,     0,     0,     0,     0,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   485,     0,     0,   843,
       0,     0,     0,   472,   473,   474,   475,   476,     0,     0,
       0,     0,     0,     0,     0,     0,  1222,   477,   478,   479,
     480,   481,   482,   483,   484,     0,   436,   485,   472,   473,
     474,   475,   476,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   477,   478,   479,   480,   481,   482,   483,   484,
       0,     0,   485,     0,     0,  1228,   472,   473,   474,   475,
     476,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     477,   478,   479,   480,   481,   482,   483,   484,     0,     0,
     485,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     436,  1283,     0,   230,     0,     0,     0,     0,   437,   438,
       0,   439,   440,   472,   473,   474,   475,   476,     0,     0,
       0,     0,     0,     0,   301,     0,  1334,   477,   478,   479,
     480,   481,   482,   483,   484,     0,   441,   485,   231,     0,
       0,   232,     0,     0,     0,   233,   234,     0,   302,   236,
     237,  1529,     0,     0,     0,   238,   810,   811,   812,   813,
     814,   815,   816,   303,   817,   818,   819,   820,   821,     0,
     442,     0,   437,   438,     0,   439,   440,   471,  1534,     0,
       0,     0,   472,   473,   474,   475,   476,   304,   305,   239,
       0,     0,     0,     0,   240,     0,   477,   478,   479,   480,
     481,   482,   483,   484,     0,     0,   485,     0,  1535,     0,
       0,     0,     0,   230,     0,     0,     0,     0,     0,     0,
     443,   444,     0,   445,   446,   447,   448,   449,   450,   451,
       0,     0,     0,  1536,   442,     0,     0,   324,   325,   326,
       0,   327,   328,     0,   329,     0,     0,     0,   231,     0,
       0,   232,     0,     0,     0,   233,   234,     0,  1537,   236,
     237,     0,     0,     0,     0,   238,     0,     0,     0,   452,
     453,   454,   455,   456,   457,   458,   459,   460,     0,   230,
       0,     0,  1003,     0,     0,  1293,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   461,   462,     0,     0,   239,
       0,     0,     0,     0,   240,     0,     0,  1292,     0,     0,
     463,   464,   465,   466,   231,     0,     0,   232,     0,     0,
       0,   233,   234,     0,     0,   236,   237,     0,     0,     0,
       0,   238,  1339,   452,   453,   454,   455,   456,   457,   458,
     459,   460,     0,     0,     0,     0,     0,     0,     0,   230,
       0,     0,     0,     0,   246,     0,     0,     0,     0,   461,
     462,     0,   306,  1341,     0,   239,     0,     0,     0,     0,
     240,     0,     0,     0,   463,   464,   465,   466,     0,     0,
     247,     0,   467,   468,   231,   230,     0,   232,  1409,     0,
       0,   233,   234,   248,     0,   236,   237,     0,   307,   308,
     309,   238,     0,     0,     0,   317,   249,   310,     0,   250,
       0,   251,     0,     0,     0,     0,  1410,   230,     0,     0,
     231,     0,   311,   232,     0,     0,     0,   233,   234,     0,
       0,   236,   237,     0,     0,   239,     0,   238,     0,     0,
     240,     0,     0,     0,     0,     0,   467,   468,     0,     0,
       0,   252,   231,   253,     0,   232,  1426,     0,     0,   233,
     234,     0,   254,   236,   237,  -434,  -434,  -434,     0,   238,
       0,   239,     0,     0,     0,     0,   240,     0,     0,  -434,
    -434,  -434,  -434,   481,   482,   483,   484,   318,     0,   485,
       0,     0,     0,     0,     0,     0,   303,     0,   255,     0,
       0,     0,     0,   239,     0,     0,     0,     0,   240,     0,
       0,     0,     0,   285,     0,   256,     0,     0,   286,   287,
     288,   305,   257,   258,     0,   259,     4,   260,   261,     0,
     262,   263,   330,   264,  1427,     0,   265,   266,     0,   267,
       0,     0,     0,     0,     0,  1428,     0,     0,     5,     6,
       0,     0,   268,   269,     0,   289,     0,   270,     7,   271,
     272,     0,   273,     0,     0,     0,     0,   274,     0,     0,
       0,   275,   276,     0,   277,   278,     0,   279,   280,   281,
       0,     0,     0,     8,   810,   811,   812,   813,   814,   815,
     816,     0,   817,   818,   819,   820,   821,     0,   290,     0,
       0,     0,  1429,     9,     0,  1430,  1431,   319,     0,     0,
       0,     0,     0,   698,    10,     0,     0,    11,     0,    12,
       0,     0,     0,     0,     0,    13,     0,     0,   380,   381,
      14,    15,    16,     0,     0,     0,     0,    17,    18,    19,
     472,   473,   474,   475,   476,     0,     0,     0,     0,     0,
       0,     0,     0,   699,   477,   478,   479,   480,   481,   482,
     483,   484,  1432,     0,   485,  1433,     0,     0,   282,     0,
       0,     0,     0,     0,     0,     0,  1434,     0,  1435,     0,
    1436,  1437,  1438,  1439,  1440,  1441,     0,     0,     0,   700,
       0,  1442,     0,     0,   701,  1443,  1444,     0,     0,  1445,
       0,   702,   703,     0,   320,     0,     0,   296,   297,     0,
       0,     0,  1446,   704,   472,   473,   474,     0,     0,     0,
    1447,     0,   705,   706,   707,   708,     0,   709,   477,   478,
     479,   480,   481,   482,   483,   484,   298,     0,   485,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1448,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   549
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-1248)))

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-434)))

static const yytype_int16 yycheck[] =
{
      17,   179,   149,   150,   285,   179,   621,   107,   625,   109,
      15,   111,   251,   113,     7,   115,    22,   256,   118,   119,
     991,   148,   258,   259,   708,    29,     6,    15,  1012,    18,
      19,    19,   271,   834,    30,    15,    16,    17,    18,   930,
      28,   280,    18,    19,    18,    26,    27,   286,     4,    43,
     289,    88,    79,    35,     8,     9,    10,    11,    12,    93,
      15,    43,   119,   102,    19,    82,     0,  1314,    22,    23,
      24,    25,    26,    27,    28,    29,    27,    22,    32,    34,
      35,    36,    37,     6,    83,    15,   325,    32,   327,    19,
    1151,    19,    15,    16,    17,    18,    19,     8,     9,    10,
      11,    12,   140,   141,   198,   179,     3,   140,   141,    93,
       3,    22,    23,    24,    25,    26,    27,    28,    29,   118,
    1367,    32,   596,  1346,    15,   199,    49,    15,    19,     6,
     146,    19,  1152,    15,   218,  1346,   230,    19,    15,    16,
      17,    18,    19,    34,    35,    36,    37,    15,    16,    17,
      18,   168,    34,    35,    36,    37,    15,    35,    15,   233,
      19,   178,    19,    86,   163,    43,   119,  1151,   642,    15,
      15,   318,    49,    19,    19,    34,    35,    36,    37,    15,
      16,    17,    18,   257,     8,     9,    10,    11,    12,    35,
      93,   230,   807,    15,    16,    17,    18,    19,    22,    23,
      24,    25,    26,    27,    28,    29,   233,    15,    32,    86,
     142,    19,    71,  1104,   288,    15,    16,    17,    18,    19,
      15,    15,   369,   219,    19,    19,    34,    35,    36,    37,
     304,   268,  1293,   307,   308,   251,   159,   160,   161,   162,
     163,   164,   165,    35,   371,   173,   373,   374,  1232,   376,
     377,    43,   145,   291,   535,  1478,   179,   208,   291,   182,
      15,    16,    17,    18,    19,   349,   350,  1478,   110,   114,
     362,  1291,   364,   347,   116,     8,     9,    10,    11,    12,
    1343,     3,   159,   160,   161,   162,   163,   164,   165,    22,
      23,    24,    25,    26,    27,    28,    29,   330,    15,    32,
      17,    18,   179,    19,   236,   182,   363,    20,    94,  1293,
    1226,   309,   346,   347,   125,   126,   127,   128,   302,   317,
     114,   305,   213,   214,   563,     8,     9,    10,    11,    12,
     569,   286,   571,    19,  1397,  1396,   572,  1021,   158,    22,
      23,    24,    25,    26,    27,    28,    29,   586,   145,    32,
     136,    19,   591,   359,   593,  1156,   595,   361,   597,  1343,
     365,   600,   601,   602,  1335,   360,    19,   360,   362,   364,
     609,   359,   119,    89,   363,    43,   119,   365,   395,   359,
     362,   362,    76,   363,   401,    19,    19,   363,   105,   363,
      43,    19,   409,   410,   411,   412,   413,   110,   105,   302,
     107,   640,   305,    15,   359,    83,   360,    19,   425,   645,
     364,   647,  1396,  1397,  1477,    49,    79,   276,   657,   658,
      43,  1337,    34,    35,    36,    37,   314,   315,   664,   359,
       8,     9,    10,    11,    12,   509,   359,   153,   723,   513,
     363,   726,   324,   728,    22,    23,    24,    25,    26,    27,
      28,    29,    86,   364,    32,   472,   473,   474,   475,   476,
     477,   478,   479,   480,   481,   482,   483,   484,   359,    92,
      93,   359,   708,   547,    97,  1159,  1093,   359,   552,   102,
     554,   124,   359,   500,   362,   214,   363,    18,    19,   286,
     507,   359,   230,  1477,   568,   105,   732,   107,  1469,    19,
     359,   358,   359,   577,   233,   579,    19,   581,   106,   213,
     584,   585,   309,   359,   359,   362,    28,    29,    19,    20,
      32,   259,   260,   359,   104,   159,   160,   161,   162,   163,
     164,   165,   549,    43,    20,    15,   240,   359,     3,    19,
     364,   270,    43,    65,    76,   179,   620,   358,   182,   129,
     697,   359,  1167,     3,    34,    35,    36,    37,   632,   359,
      20,     3,   142,   358,   359,   359,   363,    99,   100,   101,
     362,  1186,   392,     3,   394,   364,   396,   397,   367,   653,
      79,   655,    92,    93,  1207,     3,   209,    97,   662,   767,
     768,   122,     3,   829,   286,   287,    56,    57,   725,   773,
     727,     3,   214,   319,   359,   886,   335,   221,   364,    41,
     849,   367,    19,   211,   212,   331,   332,   215,   216,     3,
     859,     8,     9,    10,    11,    12,     3,   866,    60,   294,
     322,   364,   133,   134,   363,    22,    23,    24,    25,    26,
      27,    28,    29,    18,    19,    32,     8,     9,    10,    11,
      12,     3,    84,  1276,  1277,  1278,  1279,   731,    29,     3,
      22,    23,    24,    25,    26,    27,    28,    29,    19,    20,
      32,   239,   240,    20,    19,    20,     3,   342,   343,   344,
     345,   364,   963,   164,   965,   970,     3,   972,   969,    33,
     837,     3,    43,   767,   768,    42,   932,    41,    43,   209,
      44,     8,     9,    10,    11,    12,    53,     3,   288,   289,
     290,    55,   292,     3,   146,    22,    23,    24,    25,    26,
      27,    28,    29,   303,    15,    32,    17,    18,   392,   363,
     394,    75,   396,   397,   214,    79,   361,   359,    82,   364,
      84,    85,   759,   552,   761,   554,   227,   359,    92,   249,
     250,   125,    79,   853,   128,    13,   830,    15,    16,    17,
      18,    19,    20,   336,   337,   363,    19,    20,    26,    27,
      28,    29,   208,    31,    20,   119,   168,   359,   259,   123,
     854,   855,   856,   363,   359,  1021,   364,   268,   115,   363,
     364,   135,  1028,    58,    59,   122,    18,    19,    20,   191,
     874,   359,   876,   359,   878,   359,   133,   199,    54,   359,
     884,   155,   204,   205,   158,    15,    62,    63,    64,    13,
       3,    15,    16,    17,    18,    19,    20,    22,    86,   903,
      61,   905,    26,    27,    92,    29,  1075,    31,  1077,     8,
       9,    10,    11,    12,  1083,    18,    19,    20,   142,   923,
      38,    39,    40,    22,    23,    24,    25,    26,    27,    28,
      29,    58,    59,    32,    13,   358,    15,    16,    17,    18,
      19,    20,   131,   354,   355,   356,   357,    26,    27,   359,
      29,    19,    31,     7,     8,   358,    10,    11,   363,   364,
     148,   149,    86,   363,   364,    19,   363,   364,    92,   213,
     214,    92,    13,   105,    15,    16,    17,    18,    19,    20,
    1483,  1484,  1485,   362,  1195,    26,    27,    28,    29,   362,
      31,  1217,  1218,  1159,   362,   183,   184,   185,   186,   187,
     188,   405,   406,  1080,    19,    19,    83,    86,  1097,  1098,
    1099,    97,   200,    92,     3,   203,    20,   362,   358,   207,
     358,    76,  1191,   362,   148,   149,   237,   148,   149,   358,
      19,    97,   979,    20,    49,   982,   983,   984,    68,   986,
     275,   988,  1046,    73,   127,    86,   993,   364,    71,   224,
      71,    92,   222,   233,  1001,    74,   229,   235,    88,   183,
     184,   185,   186,   187,   188,   249,   253,   258,   233,   148,
     149,    86,   364,   263,   256,   271,   200,   269,   220,   203,
     134,   135,   203,   207,   358,   358,   362,   208,    82,   358,
     362,   110,   111,    82,   124,     8,     9,    10,    11,    12,
     362,  1105,    79,   358,   183,   184,   362,   148,   149,    22,
      23,    24,    25,    26,    27,    28,    29,    20,    71,    32,
      74,   200,   362,    71,   203,   362,   358,   358,   207,   362,
      44,   358,   151,   152,   153,   154,    79,   362,    79,  1305,
      94,    95,   183,   184,   159,   160,   161,   162,   163,   164,
     165,  1320,   311,   358,   108,   109,    70,   111,    74,   200,
      71,    76,   203,    71,   179,    79,   207,   182,    82,    20,
    1174,   359,    86,    87,     3,     3,    90,    91,   366,   358,
     210,  1128,    96,     3,   358,  1189,  1190,  1356,  1192,   358,
     358,   358,    19,     3,     3,  1364,  1200,  1144,   112,  1203,
       3,  1148,  1149,  1372,     3,  1374,     3,  1154,     8,     9,
      10,    11,    12,     3,     3,     3,   130,    15,   120,   120,
      14,   135,    22,    23,    24,    25,    26,    27,    28,    29,
      26,    32,    32,   208,  1311,   359,  1313,    29,  1346,    19,
      15,   230,   366,    27,   364,     7,     3,   277,    20,   358,
     358,     3,   358,    44,     8,     9,    10,    11,    12,   359,
    1429,   360,   103,    19,  1433,  1434,  1270,    19,    22,    23,
      24,    25,    26,    27,    28,    29,  1223,   358,    32,  1226,
     359,   360,  1229,  1230,  1231,    71,    71,   366,    79,   278,
      49,    82,   261,   358,   358,    86,    87,   358,    89,    90,
      91,    30,    89,   333,   293,    96,   122,    71,   338,   358,
      71,  1315,  1316,  1317,    83,   358,    71,   122,   359,    44,
    1489,   358,   311,   353,   358,   366,   358,    79,  1497,   358,
      97,    19,    84,    85,   358,   227,   325,   326,   358,   130,
      92,   358,   358,     3,   135,   358,  1515,   362,  1295,  1296,
    1519,  1298,   358,  1522,    79,  1359,  1360,    82,   145,   104,
     358,    86,    87,   358,    89,    90,    91,   119,  1476,  1373,
    1478,    96,   358,   358,  1378,  1379,  1380,     3,  1382,    19,
      13,    15,    15,    16,    17,    18,    19,    20,    19,    19,
    1337,    19,     3,    26,    27,    20,    29,    15,    31,    15,
       8,     9,    10,    11,    12,   130,   158,    27,   360,     7,
     135,    15,    18,   364,    22,    23,    24,    25,    26,    27,
      28,    29,   364,  1427,    32,   359,   217,   218,    20,   358,
     358,  1435,  1436,  1437,   358,  1439,  1440,   362,    27,    98,
     358,  1445,   364,    19,   231,   122,   358,   360,  1452,   363,
     321,   358,   358,    86,  1401,     3,     3,  1461,  1462,    92,
     358,   358,   358,   358,  1411,  1412,  1413,  1414,   358,    13,
     358,    15,    16,    17,    18,    19,    20,   358,   358,  1483,
    1484,  1485,    26,    27,    28,    29,   358,    31,   358,  1493,
    1494,  1495,   358,   358,   358,   358,   358,   284,   358,  1503,
     358,  1505,   358,   358,   358,   358,    13,    15,    15,    16,
      17,    18,    19,    20,   358,   148,   149,  1521,   358,    26,
      27,   308,    29,   310,    31,    90,   358,   358,   363,   316,
     363,   318,   358,   358,    99,   322,   323,   358,     3,   104,
     358,   106,    86,   108,     3,   110,    27,   112,    92,   114,
     183,   184,   122,   166,   167,   168,   169,   170,   171,   172,
     360,   174,   175,   176,   177,   178,   122,   200,   120,   364,
     203,   364,   363,   311,   207,   358,   363,   358,   360,    86,
     358,   358,   358,  1530,   358,    92,   327,   358,   358,    20,
     358,     3,   358,     8,     9,    10,    11,    12,   358,     3,
     358,    15,    15,    22,   148,   149,   360,    22,    23,    24,
      25,    26,    27,    28,    29,   358,   358,    32,    44,    45,
      46,    47,    48,    49,    50,    51,    52,   360,   364,     8,
       9,    10,    11,    12,    15,   359,   363,   358,   363,   183,
     184,   148,   149,    22,    23,    24,    25,    26,    27,    28,
      29,    15,   362,    32,   358,   362,   200,   362,   358,   203,
     362,   110,   111,   207,     8,     9,    10,    11,    12,   362,
     119,   358,   358,   358,     7,    22,   183,   184,    22,    23,
      24,    25,    26,    27,    28,    29,   364,   363,    32,   138,
     358,    19,   122,   200,    20,   144,   203,   146,   147,   220,
     207,   358,   271,     8,     9,    10,    11,    12,   294,   295,
     296,   297,   298,   299,   300,   301,   362,    22,    23,    24,
      25,    26,    27,    28,    29,   358,   359,    32,     3,   358,
       3,    15,   359,   366,   217,   181,   360,   360,   360,     8,
       9,    10,    11,    12,   359,   359,   358,   360,   214,   359,
     359,   358,   360,    22,    23,    24,    25,    26,    27,    28,
      29,   210,   358,    32,     8,     9,    10,    11,    12,   312,
     358,   235,   363,   358,   364,   358,   360,     7,    22,    23,
      24,    25,    26,    27,    28,    29,   215,   215,    32,     8,
       9,    10,    11,    12,   215,   311,   362,   271,   313,   235,
     329,   296,   321,    22,    23,    24,    25,    26,    27,    28,
      29,   360,   294,    32,   312,   359,     8,     9,    10,    11,
      12,   358,   366,   358,   358,   358,   358,   358,   277,   306,
      22,    23,    24,    25,    26,    27,    28,    29,   358,   504,
      32,   343,   237,  1431,   794,  1022,     8,     9,    10,    11,
      12,   944,   359,   947,  1093,  1011,   362,  1156,   521,   366,
      22,    23,    24,    25,    26,    27,    28,    29,   369,   703,
      32,     8,     9,    10,    11,    12,   835,  1396,   767,  1476,
     992,   178,   768,  1298,  1152,    22,    23,    24,    25,    26,
      27,    28,    29,  1478,   773,    32,     8,     9,    10,    11,
      12,   979,  1230,   934,   353,  1027,  1248,  1265,    -1,  1308,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,   360,    32,     8,     9,    10,
      11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    24,    25,    26,    27,    28,    29,    -1,
      -1,    32,     8,     9,    10,    11,    12,    -1,    -1,    -1,
      -1,   360,    -1,    -1,    -1,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,    -1,    19,
      -1,    -1,    -1,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   360,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,     5,    32,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    24,    25,    26,    27,    28,    29,
      -1,    -1,    32,    -1,    -1,   360,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       5,   360,    -1,    44,    -1,    -1,    -1,    -1,    77,    78,
      -1,    80,    81,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    65,    -1,   360,    22,    23,    24,
      25,    26,    27,    28,    29,    -1,   105,    32,    79,    -1,
      -1,    82,    -1,    -1,    -1,    86,    87,    -1,    89,    90,
      91,   360,    -1,    -1,    -1,    96,   166,   167,   168,   169,
     170,   171,   172,   104,   174,   175,   176,   177,   178,    -1,
     139,    -1,    77,    78,    -1,    80,    81,     3,   360,    -1,
      -1,    -1,     8,     9,    10,    11,    12,   128,   129,   130,
      -1,    -1,    -1,    -1,   135,    -1,    22,    23,    24,    25,
      26,    27,    28,    29,    -1,    -1,    32,    -1,   360,    -1,
      -1,    -1,    -1,    44,    -1,    -1,    -1,    -1,    -1,    -1,
     189,   190,    -1,   192,   193,   194,   195,   196,   197,   198,
      -1,    -1,    -1,   360,   139,    -1,    -1,    68,    69,    70,
      -1,    72,    73,    -1,    75,    -1,    -1,    -1,    79,    -1,
      -1,    82,    -1,    -1,    -1,    86,    87,    -1,   360,    90,
      91,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,   238,
     239,   240,   241,   242,   243,   244,   245,   246,    -1,    44,
      -1,    -1,   358,    -1,    -1,   180,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   264,   265,    -1,    -1,   130,
      -1,    -1,    -1,    -1,   135,    -1,    -1,   358,    -1,    -1,
     279,   280,   281,   282,    79,    -1,    -1,    82,    -1,    -1,
      -1,    86,    87,    -1,    -1,    90,    91,    -1,    -1,    -1,
      -1,    96,   358,   238,   239,   240,   241,   242,   243,   244,
     245,   246,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    44,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,   264,
     265,    -1,   303,   358,    -1,   130,    -1,    -1,    -1,    -1,
     135,    -1,    -1,    -1,   279,   280,   281,   282,    -1,    -1,
      75,    -1,   351,   352,    79,    44,    -1,    82,   358,    -1,
      -1,    86,    87,    88,    -1,    90,    91,    -1,   339,   340,
     341,    96,    -1,    -1,    -1,    64,   101,   348,    -1,   104,
      -1,   106,    -1,    -1,    -1,    -1,   358,    44,    -1,    -1,
      79,    -1,   363,    82,    -1,    -1,    -1,    86,    87,    -1,
      -1,    90,    91,    -1,    -1,   130,    -1,    96,    -1,    -1,
     135,    -1,    -1,    -1,    -1,    -1,   351,   352,    -1,    -1,
      -1,   146,    79,   148,    -1,    82,    64,    -1,    -1,    86,
      87,    -1,   157,    90,    91,     8,     9,    10,    -1,    96,
      -1,   130,    -1,    -1,    -1,    -1,   135,    -1,    -1,    22,
      23,    24,    25,    26,    27,    28,    29,   146,    -1,    32,
      -1,    -1,    -1,    -1,    -1,    -1,   104,    -1,   193,    -1,
      -1,    -1,    -1,   130,    -1,    -1,    -1,    -1,   135,    -1,
      -1,    -1,    -1,   278,    -1,   210,    -1,    -1,   283,   284,
     285,   129,   217,   218,    -1,   220,    44,   222,   223,    -1,
     225,   226,   363,   228,   142,    -1,   231,   232,    -1,   234,
      -1,    -1,    -1,    -1,    -1,   153,    -1,    -1,    66,    67,
      -1,    -1,   247,   248,    -1,   320,    -1,   252,    76,   254,
     255,    -1,   257,    -1,    -1,    -1,    -1,   262,    -1,    -1,
      -1,   266,   267,    -1,   269,   270,    -1,   272,   273,   274,
      -1,    -1,    -1,   101,   166,   167,   168,   169,   170,   171,
     172,    -1,   174,   175,   176,   177,   178,    -1,   363,    -1,
      -1,    -1,   210,   121,    -1,   213,   214,   266,    -1,    -1,
      -1,    -1,    -1,     3,   132,    -1,    -1,   135,    -1,   137,
      -1,    -1,    -1,    -1,    -1,   143,    -1,    -1,    18,    19,
     148,   149,   150,    -1,    -1,    -1,    -1,   155,   156,   157,
       8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    43,    22,    23,    24,    25,    26,    27,
      28,    29,   270,    -1,    32,   273,    -1,    -1,   363,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   284,    -1,   286,    -1,
     288,   289,   290,   291,   292,   293,    -1,    -1,    -1,    79,
      -1,   299,    -1,    -1,    84,   303,   304,    -1,    -1,   307,
      -1,    91,    92,    -1,   363,    -1,    -1,   334,   335,    -1,
      -1,    -1,   320,   103,     8,     9,    10,    -1,    -1,    -1,
     328,    -1,   112,   113,   114,   115,    -1,   117,    22,    23,
      24,    25,    26,    27,    28,    29,   363,    -1,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   363,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   209
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,     4,   369,   370,    44,    66,    67,    76,   101,   121,
     132,   135,   137,   143,   148,   149,   150,   155,   156,   157,
     392,   393,   394,   395,   396,   397,   448,   449,   450,   451,
     453,   454,   455,   458,   461,   464,   465,   466,   467,   468,
     469,   470,   471,   472,   473,   474,   475,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   554,   590,   591,   592,
     593,   594,   595,   596,   597,   616,   618,     0,     3,    33,
      41,    44,    55,    75,    79,    82,    84,    85,    92,   119,
     123,   135,   155,   158,   358,   371,   382,   388,   391,   400,
     402,   405,   407,   410,   412,   413,   415,   416,   423,   433,
     434,   489,   491,   501,   540,   543,   555,   556,   557,   558,
     599,   600,   601,   602,   610,   611,   617,   619,   620,   621,
      19,    20,    43,   487,    20,    54,    62,    63,    64,   398,
       3,   487,   487,   119,   133,   134,   487,   487,     3,   110,
     111,   119,   138,   144,   146,   147,   210,   277,   353,   119,
     119,    74,   110,   111,   151,   152,   153,   154,    13,    15,
      16,    17,    18,    19,    20,    26,    27,    29,    31,    86,
      92,   148,   149,   183,   184,   200,   203,   207,   359,   366,
     506,   519,   524,   527,   528,   529,   531,   533,    35,    43,
     362,   476,   487,    19,    20,    42,    53,   384,   110,   116,
      41,    60,    84,   146,   389,   390,    76,    19,    83,    19,
      79,   124,    20,   110,   533,    19,    19,   417,   417,   362,
      68,    73,    88,   124,   210,   277,   333,   338,   353,   417,
      44,    79,    82,    86,    87,    89,    90,    91,    96,   130,
     135,   363,   418,   436,   417,   417,    49,    75,    88,   101,
     104,   106,   146,   148,   157,   193,   210,   217,   218,   220,
     222,   223,   225,   226,   228,   231,   232,   234,   247,   248,
     252,   254,   255,   257,   262,   266,   267,   269,   270,   272,
     273,   274,   363,   418,   417,   278,   283,   284,   285,   320,
     363,   418,   559,   560,   561,   417,   334,   335,   363,   418,
     417,    65,    89,   104,   128,   129,   303,   339,   340,   341,
     348,   363,   418,   443,   445,   446,   417,    64,   146,   266,
     363,   418,   612,   615,    68,    69,    70,    72,    73,    75,
     363,   401,   404,   418,    70,   112,   363,   403,   418,    35,
      43,   362,   437,   398,     3,     3,   398,    65,   399,     3,
       3,    79,   463,   487,   487,     3,    35,    43,   362,   440,
      19,    20,    43,   488,     3,   145,   459,     3,     3,   456,
     462,   221,    19,    89,   153,   319,   331,   332,   452,   452,
      18,    19,   375,   377,   377,     3,     3,     3,     3,     3,
       3,     3,    15,    19,    28,   359,   365,   523,   525,   531,
      29,   359,   208,    27,   208,    15,   365,   526,   533,   359,
     359,   359,   359,   359,   359,   185,   186,   187,   188,   513,
     533,    15,    16,    17,    19,   359,   372,   506,   507,   511,
     514,   515,   517,   519,   520,   521,     5,    77,    78,    80,
      81,   105,   139,   189,   190,   192,   193,   194,   195,   196,
     197,   198,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   264,   265,   279,   280,   281,   282,   351,   352,   532,
     622,     3,     8,     9,    10,    11,    12,    22,    23,    24,
      25,    26,    27,    28,    29,    32,    44,    45,    46,    47,
      48,    49,    50,    51,    52,   386,   387,    15,   477,     3,
      22,    61,   383,    43,   362,   385,   437,   359,   372,    20,
      56,    57,   358,   142,   131,   411,    15,    17,    18,   105,
     406,   490,    19,   408,   358,   440,   502,   105,   362,   362,
     414,   362,   437,    19,   422,    83,   372,    34,    35,    36,
      37,   372,   374,   435,    43,    92,    93,    97,   102,   209,
     419,   498,    97,   419,    97,    20,   440,   358,   358,   362,
     362,   142,   236,    76,   358,   237,    20,   374,    97,   275,
     146,   251,   127,   374,   358,   372,   375,   122,   375,    71,
     224,    71,   222,   229,   239,   240,   233,   235,   249,   250,
     249,   253,   374,   256,   258,   263,    79,   233,    88,   268,
     233,   271,   269,   374,   220,   358,   362,   406,   374,    82,
     372,   374,   358,   362,   362,    79,   336,   337,   358,   362,
      71,   608,   609,    20,   372,   362,    93,   346,   347,   603,
     372,   372,    71,   218,   349,   350,   358,   358,   362,   362,
     311,   377,    79,   358,   164,   227,   259,   268,   354,   355,
     356,   357,   358,    79,   374,    71,   374,    74,    76,   358,
     358,   358,    71,    20,   381,   358,   358,    74,    94,    95,
     108,   109,   111,   438,   439,     3,   399,     3,   372,     3,
      19,     3,     3,     3,    94,   136,   441,   442,     3,   488,
       3,     3,     3,    79,   115,   122,   133,   460,     3,    43,
      79,    84,    91,    92,   103,   112,   113,   114,   115,   117,
     377,   457,   498,     3,    19,    79,    84,    85,    92,   119,
     158,   452,   452,   452,   598,    43,   452,    43,   452,     3,
       3,    29,   361,   379,   120,   120,   525,   525,   533,   525,
     525,    14,    15,   533,   537,   538,    26,   208,    27,   526,
     526,    29,   533,   533,   533,   533,   533,    19,    15,   364,
     360,   364,    28,   509,   510,   513,   533,     7,   364,   367,
      26,    27,   362,   364,   367,   533,   533,   533,   533,   533,
     533,   533,   533,   533,   533,   533,   533,   533,   168,   191,
     199,   204,   205,   363,   364,     3,   533,    20,   386,   358,
     533,   372,    58,    59,    58,    59,   372,   430,   431,   358,
     166,   167,   168,   169,   170,   171,   172,   174,   175,   176,
     177,   178,   492,   493,   494,   496,   500,   125,   126,   127,
     128,   358,   409,   358,   359,   499,    19,   119,   363,   406,
     424,   427,   428,    19,   496,   497,    35,   372,   421,   103,
     533,   421,   421,   542,    71,    71,    71,   276,   374,    49,
     358,   358,   372,   213,   214,   374,   261,   374,   375,   358,
     358,    30,   376,   372,   122,   372,    71,   372,    71,   102,
     230,   372,   372,   374,    71,   358,    83,   358,   374,   358,
     374,   230,   259,   260,   374,   422,   374,   358,   358,   374,
     374,   374,   358,   122,   374,    97,   562,    19,   358,   358,
     372,   428,   358,   358,   444,   445,   358,   358,   358,   372,
     358,   358,   358,    83,   118,   163,   447,   374,   422,    20,
     375,   375,   227,   613,   614,   372,   372,   374,   374,   372,
     375,   377,   378,   363,   364,     3,   363,   364,     3,    19,
      15,   377,    19,    19,   497,   378,    19,     3,    20,   589,
     589,     3,    19,    82,   230,   278,   293,   311,   325,   326,
     452,   589,   452,   589,   372,   375,    15,    15,   360,   364,
     360,    27,   364,   364,   364,   360,   364,   360,   364,   533,
     533,     7,   364,   364,   360,    18,   507,   515,    15,    18,
     520,   359,   387,   358,   363,    20,   358,   428,   358,    19,
     173,   358,   362,   375,   372,   360,   493,   495,   500,   377,
      27,   426,   364,    98,   420,   374,    89,   217,   218,   363,
     418,   541,   372,   372,   372,   358,   358,   374,   358,   358,
     358,   358,   374,   358,   358,    19,   122,   358,   372,   358,
     372,   358,   372,   358,   358,   358,   358,   358,   372,   406,
     358,   358,   358,   358,   358,   358,   358,   358,   358,   358,
     358,   358,   372,   372,    89,   145,   231,   284,   308,   310,
     316,   318,   322,   323,   363,   563,   570,   573,   358,   358,
     362,   607,   363,   358,   358,   372,   105,   107,   105,   107,
     363,   358,   358,   376,   375,   321,   613,   439,   442,     3,
       3,   406,   406,    15,   406,   589,     3,   589,     3,   122,
     122,   537,    27,   533,   533,   533,   533,   533,   364,   360,
     509,   533,   510,   512,   533,   364,   533,   494,    19,    49,
      86,   159,   160,   161,   162,   163,   164,   165,   179,   182,
     503,   504,   529,   530,   534,   539,   358,   360,   120,    20,
     378,   425,   427,    76,    99,   100,   101,   544,   548,   544,
     549,   375,   553,   358,   364,   358,   358,   358,   358,   372,
     358,   358,   358,   358,   358,   358,   582,   588,   374,   286,
     287,   322,   286,   374,   564,   311,   377,   566,   567,   565,
     324,   374,   358,   327,   583,   606,   444,   358,    20,   380,
     380,   380,   380,   376,   372,     3,     3,    15,    15,   360,
     360,   360,   360,   364,   533,   360,   364,    15,   360,    22,
     359,    22,   359,   533,   533,   533,   363,   539,   532,   622,
     358,   533,   535,   536,   495,    15,   378,   428,   429,   362,
     547,    30,   219,   550,   372,   358,   428,   584,   372,   372,
     374,   372,   362,   406,   362,   362,   372,   372,   362,   214,
     233,   270,   335,   363,   605,   447,   358,   358,   358,   358,
     463,   463,   533,   360,     7,    28,   512,   363,   533,   538,
     533,   529,   358,   180,   362,    22,    22,    32,   364,   358,
     122,   547,   546,    19,    20,   220,   551,   358,   585,   362,
     587,   575,   568,   575,   571,   140,   141,   291,   432,   372,
     271,   294,   342,   343,   344,   345,   604,   358,   447,   447,
     447,   447,     3,     3,   360,   359,   360,     7,   360,   358,
     360,   358,   622,   362,   505,   539,   522,   533,   533,    92,
     148,   149,   203,   208,   536,    15,   106,   211,   212,   215,
     216,   363,   545,   375,   217,   552,   583,   586,   363,   377,
     576,   577,   145,   286,   309,   363,   569,   363,   142,   288,
     289,   290,   292,   303,   363,   443,   572,   372,   372,   372,
     214,   374,   509,   512,   360,   503,   181,     6,    15,    16,
      17,   359,   363,   506,   508,   511,   514,   516,   518,   358,
     358,   359,   359,   359,   359,   358,   358,   374,   213,   214,
     214,   372,   373,   372,   358,   374,    64,   142,   153,   210,
     213,   214,   270,   273,   284,   286,   288,   289,   290,   291,
     292,   293,   299,   303,   304,   307,   320,   328,   363,   443,
     574,   309,   317,   578,   374,   372,   374,   358,   372,   372,
     372,   235,   114,   372,    93,   302,   305,   358,   312,   364,
     360,   358,   363,   505,   503,   533,     7,   361,   364,   533,
     533,   533,   533,   215,   215,   215,    38,    39,    40,   311,
     372,   362,   374,   313,   291,   330,   432,   271,   374,   374,
     372,   372,   372,   235,   372,   114,   372,   294,   295,   296,
     297,   298,   299,   300,   301,   329,    93,   302,   305,   296,
     372,   321,   294,   358,   372,   358,   372,   372,   509,   360,
     359,   508,   503,   516,   360,   360,   360,   360,   373,   373,
     373,   374,   579,   314,   315,   372,   372,   372,   214,   374,
     372,   372,   374,   374,   372,   374,   360,   533,   358,   358,
     358,   358,    18,   363,   581,   312,   306,   580,   358
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YYUSE (yytype);
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 695 "cf-parse.y"
    { return 0; }
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 696 "cf-parse.y"
    { return 0; }
    break;

  case 6:
/* Line 1787 of yacc.c  */
#line 709 "cf-parse.y"
    {
     struct f_val *val = cfg_alloc(sizeof(struct f_val));
     *val = f_eval((yyvsp[(4) - (5)].x), cfg_mem);
     if (val->type == T_RETURN) cf_error("Runtime error");
     cf_define_symbol((yyvsp[(2) - (5)].s), SYM_CONSTANT | val->type, val);
   }
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 719 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 720 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_INT)) cf_error("Number expected");
     (yyval.i) = SYM_VAL((yyvsp[(1) - (1)].s)).i; }
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 727 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000000; }
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 728 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1000; }
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 729 "cf-parse.y"
    { (yyval.i32) = (u32) (yyvsp[(1) - (2)].i) * 1; }
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 737 "cf-parse.y"
    {(yyval.i) = !!(yyvsp[(1) - (1)].i); }
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 738 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 739 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 740 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 741 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 742 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 749 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != (SYM_CONSTANT | T_IP)) cf_error("IP address expected");
     (yyval.a) = SYM_VAL((yyvsp[(1) - (1)].s)).px.ip;
   }
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 756 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 22:
/* Line 1787 of yacc.c  */
#line 757 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 761 "cf-parse.y"
    {
     if (!ip_is_prefix((yyvsp[(1) - (2)].a), (yyvsp[(2) - (2)].i))) cf_error("Invalid prefix");
     (yyval.px).addr = (yyvsp[(1) - (2)].a); (yyval.px).len = (yyvsp[(2) - (2)].i);
   }
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 769 "cf-parse.y"
    { (yyval.px).addr = (yyvsp[(1) - (1)].a); (yyval.px).len = BITS_PER_IP_ADDRESS; }
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 773 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > BITS_PER_IP_ADDRESS) cf_error("Invalid prefix length %d", (yyvsp[(2) - (2)].i));
     (yyval.i) = (yyvsp[(2) - (2)].i);
   }
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 777 "cf-parse.y"
    {
     (yyval.i) = ipa_mklen((yyvsp[(2) - (2)].a));
     if ((yyval.i) < 0) cf_error("Invalid netmask %I", (yyvsp[(2) - (2)].a));
   }
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 784 "cf-parse.y"
    {
     (yyval.time) = tm_parse_datetime((yyvsp[(1) - (1)].t));
     if (!(yyval.time))
       cf_error("Invalid date and time");
   }
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 792 "cf-parse.y"
    { (yyval.t) = (yyvsp[(1) - (1)].t); }
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 793 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 799 "cf-parse.y"
    {
    struct log_config *c = cfg_allocz(sizeof(struct log_config));
    c->fh = (yyvsp[(2) - (4)].g);
    c->mask = (yyvsp[(3) - (4)].i);
    add_tail(&new_config->logfiles, &c->n);
  }
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 808 "cf-parse.y"
    { (yyval.t) = (yyvsp[(2) - (2)].t); }
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 809 "cf-parse.y"
    { (yyval.t) = bird_name; }
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 813 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(1) - (1)].t), "a");
     if (!f) cf_error("Unable to open log file `%s': %m", (yyvsp[(1) - (1)].t));
     (yyval.g) = f;
   }
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 818 "cf-parse.y"
    { (yyval.g) = NULL; new_config->syslog_name = (yyvsp[(2) - (2)].t); }
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 819 "cf-parse.y"
    { (yyval.g) = stderr; }
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 823 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 824 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 828 "cf-parse.y"
    { (yyval.i) = 1 << (yyvsp[(1) - (1)].i); }
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 829 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (1 << (yyvsp[(3) - (3)].i)); }
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 833 "cf-parse.y"
    { (yyval.i) = L_DEBUG[0]; }
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 834 "cf-parse.y"
    { (yyval.i) = L_TRACE[0]; }
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 835 "cf-parse.y"
    { (yyval.i) = L_INFO[0]; }
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 836 "cf-parse.y"
    { (yyval.i) = L_REMOTE[0]; }
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 837 "cf-parse.y"
    { (yyval.i) = L_WARN[0]; }
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 838 "cf-parse.y"
    { (yyval.i) = L_ERR[0]; }
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 839 "cf-parse.y"
    { (yyval.i) = L_AUTH[0]; }
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 840 "cf-parse.y"
    { (yyval.i) = L_FATAL[0]; }
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 841 "cf-parse.y"
    { (yyval.i) = L_BUG[0]; }
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 847 "cf-parse.y"
    { new_config->proto_default_mrtdump = (yyvsp[(3) - (4)].i); }
    break;

  case 51:
/* Line 1787 of yacc.c  */
#line 848 "cf-parse.y"
    {
     FILE *f = tracked_fopen(new_config->pool, (yyvsp[(2) - (3)].t), "a");
     if (!f) cf_error("Unable to open MRTDump file '%s': %m", (yyvsp[(2) - (3)].t));
     new_config->mrtdump_file = fileno(f);
   }
    break;

  case 52:
/* Line 1787 of yacc.c  */
#line 857 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_route; }
    break;

  case 53:
/* Line 1787 of yacc.c  */
#line 858 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_proto; }
    break;

  case 54:
/* Line 1787 of yacc.c  */
#line 859 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_base; }
    break;

  case 55:
/* Line 1787 of yacc.c  */
#line 860 "cf-parse.y"
    { (yyval.tf) = &new_config->tf_log; }
    break;

  case 56:
/* Line 1787 of yacc.c  */
#line 863 "cf-parse.y"
    { *(yyvsp[(1) - (2)].tf) = (struct timeformat){(yyvsp[(2) - (2)].t), NULL, 0}; }
    break;

  case 57:
/* Line 1787 of yacc.c  */
#line 864 "cf-parse.y"
    { *(yyvsp[(1) - (4)].tf) = (struct timeformat){(yyvsp[(2) - (4)].t), (yyvsp[(4) - (4)].t), (yyvsp[(3) - (4)].i)}; }
    break;

  case 58:
/* Line 1787 of yacc.c  */
#line 865 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%T", "%F", 20*3600}; }
    break;

  case 59:
/* Line 1787 of yacc.c  */
#line 866 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%F %T", NULL, 0}; }
    break;

  case 60:
/* Line 1787 of yacc.c  */
#line 867 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){NULL, NULL, 0}; }
    break;

  case 61:
/* Line 1787 of yacc.c  */
#line 868 "cf-parse.y"
    { *(yyvsp[(1) - (3)].tf) = (struct timeformat){"%d-%m-%Y %T", NULL, 0}; }
    break;

  case 63:
/* Line 1787 of yacc.c  */
#line 880 "cf-parse.y"
    { cmd_reconfig((yyvsp[(2) - (4)].t), RECONFIG_HARD, (yyvsp[(3) - (4)].i)); }
    break;

  case 64:
/* Line 1787 of yacc.c  */
#line 883 "cf-parse.y"
    { cmd_reconfig((yyvsp[(3) - (5)].t), RECONFIG_SOFT, (yyvsp[(4) - (5)].i)); }
    break;

  case 65:
/* Line 1787 of yacc.c  */
#line 890 "cf-parse.y"
    { cmd_reconfig_confirm(); }
    break;

  case 66:
/* Line 1787 of yacc.c  */
#line 893 "cf-parse.y"
    { cmd_reconfig_undo(); }
    break;

  case 67:
/* Line 1787 of yacc.c  */
#line 896 "cf-parse.y"
    { cmd_check_config((yyvsp[(3) - (4)].t)); }
    break;

  case 68:
/* Line 1787 of yacc.c  */
#line 899 "cf-parse.y"
    { cmd_shutdown(); }
    break;

  case 69:
/* Line 1787 of yacc.c  */
#line 902 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 71:
/* Line 1787 of yacc.c  */
#line 907 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 72:
/* Line 1787 of yacc.c  */
#line 908 "cf-parse.y"
    { (yyval.i) = UNIX_DEFAULT_CONFIGURE_TIMEOUT; }
    break;

  case 73:
/* Line 1787 of yacc.c  */
#line 909 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 74:
/* Line 1787 of yacc.c  */
#line 917 "cf-parse.y"
    { this_proto = krt_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 75:
/* Line 1787 of yacc.c  */
#line 922 "cf-parse.y"
    { THIS_KRT->persist = (yyvsp[(2) - (2)].i); }
    break;

  case 76:
/* Line 1787 of yacc.c  */
#line 923 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KRT->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 77:
/* Line 1787 of yacc.c  */
#line 927 "cf-parse.y"
    {
      THIS_KRT->learn = (yyvsp[(2) - (2)].i);
#ifndef KRT_ALLOW_LEARN
      if ((yyvsp[(2) - (2)].i))
	cf_error("Learning of kernel routes not supported in this configuration");
#endif
   }
    break;

  case 78:
/* Line 1787 of yacc.c  */
#line 934 "cf-parse.y"
    { THIS_KRT->devroutes = (yyvsp[(3) - (3)].i); }
    break;

  case 79:
/* Line 1787 of yacc.c  */
#line 935 "cf-parse.y"
    { THIS_KRT->graceful_restart = (yyvsp[(3) - (3)].i); }
    break;

  case 80:
/* Line 1787 of yacc.c  */
#line 941 "cf-parse.y"
    { this_proto = kif_init_config((yyvsp[(1) - (2)].i)); }
    break;

  case 81:
/* Line 1787 of yacc.c  */
#line 946 "cf-parse.y"
    {
      /* Scan time of 0 means scan on startup only */
      THIS_KIF->scan_time = (yyvsp[(3) - (3)].i);
   }
    break;

  case 82:
/* Line 1787 of yacc.c  */
#line 950 "cf-parse.y"
    {
     struct kif_primary_item *kpi = cfg_alloc(sizeof (struct kif_primary_item));
     kpi->pattern = (yyvsp[(2) - (3)].t);
     kpi->prefix = (yyvsp[(3) - (3)].px).addr;
     kpi->pxlen = (yyvsp[(3) - (3)].px).len;
     add_tail(&THIS_KIF->primary, &kpi->n);
   }
    break;

  case 83:
/* Line 1787 of yacc.c  */
#line 964 "cf-parse.y"
    {
	if ((yyvsp[(3) - (3)].i) <= 0 || (yyvsp[(3) - (3)].i) >= NL_NUM_TABLES)
	  cf_error("Kernel routing table number out of range");
	THIS_KRT->sys.table_id = (yyvsp[(3) - (3)].i);
   }
    break;

  case 84:
/* Line 1787 of yacc.c  */
#line 978 "cf-parse.y"
    { new_config->router_id = (yyvsp[(3) - (4)].i32); }
    break;

  case 85:
/* Line 1787 of yacc.c  */
#line 979 "cf-parse.y"
    { new_config->router_id_from = this_ipatt; }
    break;

  case 86:
/* Line 1787 of yacc.c  */
#line 983 "cf-parse.y"
    { (yyval.i32) = (yyvsp[(1) - (1)].i); }
    break;

  case 88:
/* Line 1787 of yacc.c  */
#line 985 "cf-parse.y"
    {
#ifndef IPV6
     (yyval.i32) = ipa_to_u32((yyvsp[(1) - (1)].a));
#else
     cf_error("Router IDs must be entered as hexadecimal numbers or IPv4 addresses in IPv6 version");
#endif
   }
    break;

  case 92:
/* Line 1787 of yacc.c  */
#line 1004 "cf-parse.y"
    { new_config->listen_bgp_addr = (yyvsp[(2) - (2)].a); }
    break;

  case 93:
/* Line 1787 of yacc.c  */
#line 1005 "cf-parse.y"
    { new_config->listen_bgp_port = (yyvsp[(2) - (2)].i); }
    break;

  case 94:
/* Line 1787 of yacc.c  */
#line 1006 "cf-parse.y"
    { new_config->listen_bgp_flags = 0; }
    break;

  case 95:
/* Line 1787 of yacc.c  */
#line 1007 "cf-parse.y"
    { new_config->listen_bgp_flags = 1; }
    break;

  case 96:
/* Line 1787 of yacc.c  */
#line 1012 "cf-parse.y"
    { new_config->gr_wait = (yyvsp[(4) - (5)].i); }
    break;

  case 97:
/* Line 1787 of yacc.c  */
#line 1018 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 98:
/* Line 1787 of yacc.c  */
#line 1019 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 99:
/* Line 1787 of yacc.c  */
#line 1023 "cf-parse.y"
    {
   struct rtable_config *cf;
   cf = rt_new_table((yyvsp[(2) - (3)].s));
   cf->sorted = (yyvsp[(3) - (3)].i);
   }
    break;

  case 100:
/* Line 1787 of yacc.c  */
#line 1031 "cf-parse.y"
    {
  this_roa_table = roa_new_table_config((yyvsp[(3) - (3)].s));
}
    break;

  case 102:
/* Line 1787 of yacc.c  */
#line 1037 "cf-parse.y"
    {
     roa_add_item_config(this_roa_table, (yyvsp[(3) - (8)].px).addr, (yyvsp[(3) - (8)].px).len, (yyvsp[(5) - (8)].i), (yyvsp[(7) - (8)].i));
   }
    break;

  case 105:
/* Line 1787 of yacc.c  */
#line 1051 "cf-parse.y"
    { (yyval.i) = SYM_PROTO; }
    break;

  case 106:
/* Line 1787 of yacc.c  */
#line 1052 "cf-parse.y"
    { (yyval.i) = SYM_TEMPLATE; }
    break;

  case 107:
/* Line 1787 of yacc.c  */
#line 1056 "cf-parse.y"
    {
     struct symbol *s = cf_default_name(this_proto->protocol->template, &this_proto->protocol->name_counter);
     s->class = this_proto->class;
     s->def = this_proto;
     this_proto->name = s->name;
     }
    break;

  case 108:
/* Line 1787 of yacc.c  */
#line 1062 "cf-parse.y"
    {
     cf_define_symbol((yyvsp[(1) - (1)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 109:
/* Line 1787 of yacc.c  */
#line 1066 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].s)->class != SYM_TEMPLATE) && ((yyvsp[(3) - (3)].s)->class != SYM_PROTO)) cf_error("Template or protocol name expected");

     cf_define_symbol((yyvsp[(1) - (3)].s), this_proto->class, this_proto);
     this_proto->name = (yyvsp[(1) - (3)].s)->name;

     proto_copy_config(this_proto, (yyvsp[(3) - (3)].s)->def);
   }
    break;

  case 111:
/* Line 1787 of yacc.c  */
#line 1078 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].i) < 0 || (yyvsp[(2) - (2)].i) > 0xFFFF) cf_error("Invalid preference");
     this_proto->preference = (yyvsp[(2) - (2)].i);
   }
    break;

  case 112:
/* Line 1787 of yacc.c  */
#line 1082 "cf-parse.y"
    { this_proto->disabled = (yyvsp[(2) - (2)].i); }
    break;

  case 113:
/* Line 1787 of yacc.c  */
#line 1083 "cf-parse.y"
    { this_proto->debug = (yyvsp[(2) - (2)].i); }
    break;

  case 114:
/* Line 1787 of yacc.c  */
#line 1084 "cf-parse.y"
    { this_proto->mrtdump = (yyvsp[(2) - (2)].i); }
    break;

  case 115:
/* Line 1787 of yacc.c  */
#line 1085 "cf-parse.y"
    { this_proto->in_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 116:
/* Line 1787 of yacc.c  */
#line 1086 "cf-parse.y"
    { this_proto->out_filter = (yyvsp[(2) - (2)].f); }
    break;

  case 117:
/* Line 1787 of yacc.c  */
#line 1087 "cf-parse.y"
    { this_proto->rx_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 118:
/* Line 1787 of yacc.c  */
#line 1088 "cf-parse.y"
    { this_proto->in_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 119:
/* Line 1787 of yacc.c  */
#line 1089 "cf-parse.y"
    { this_proto->out_limit = (yyvsp[(3) - (3)].g); }
    break;

  case 120:
/* Line 1787 of yacc.c  */
#line 1090 "cf-parse.y"
    { this_proto->in_keep_filtered = (yyvsp[(4) - (4)].i); }
    break;

  case 121:
/* Line 1787 of yacc.c  */
#line 1091 "cf-parse.y"
    { this_proto->table = (yyvsp[(2) - (2)].r); }
    break;

  case 122:
/* Line 1787 of yacc.c  */
#line 1092 "cf-parse.y"
    { this_proto->router_id = (yyvsp[(3) - (3)].i32); }
    break;

  case 123:
/* Line 1787 of yacc.c  */
#line 1093 "cf-parse.y"
    { this_proto->dsc = (yyvsp[(2) - (2)].t); }
    break;

  case 124:
/* Line 1787 of yacc.c  */
#line 1097 "cf-parse.y"
    { (yyval.f) = (yyvsp[(2) - (2)].f); }
    break;

  case 126:
/* Line 1787 of yacc.c  */
#line 1099 "cf-parse.y"
    { (yyval.f) = FILTER_ACCEPT; }
    break;

  case 127:
/* Line 1787 of yacc.c  */
#line 1100 "cf-parse.y"
    { (yyval.f) = FILTER_REJECT; }
    break;

  case 128:
/* Line 1787 of yacc.c  */
#line 1104 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 129:
/* Line 1787 of yacc.c  */
#line 1105 "cf-parse.y"
    { (yyval.i) = PLA_WARN; }
    break;

  case 130:
/* Line 1787 of yacc.c  */
#line 1106 "cf-parse.y"
    { (yyval.i) = PLA_BLOCK; }
    break;

  case 131:
/* Line 1787 of yacc.c  */
#line 1107 "cf-parse.y"
    { (yyval.i) = PLA_RESTART; }
    break;

  case 132:
/* Line 1787 of yacc.c  */
#line 1108 "cf-parse.y"
    { (yyval.i) = PLA_DISABLE; }
    break;

  case 133:
/* Line 1787 of yacc.c  */
#line 1112 "cf-parse.y"
    {
     struct proto_limit *l = cfg_allocz(sizeof(struct proto_limit));
     l->limit = (yyvsp[(1) - (2)].i);
     l->action = (yyvsp[(2) - (2)].i);
     (yyval.g) = l;
   }
    break;

  case 134:
/* Line 1787 of yacc.c  */
#line 1118 "cf-parse.y"
    { (yyval.g) = NULL; }
    break;

  case 135:
/* Line 1787 of yacc.c  */
#line 1122 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_TABLE) cf_error("Table name expected");
     (yyval.r) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 136:
/* Line 1787 of yacc.c  */
#line 1130 "cf-parse.y"
    { new_config->proto_default_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 137:
/* Line 1787 of yacc.c  */
#line 1131 "cf-parse.y"
    { new_config->cli_debug = (yyvsp[(3) - (3)].i); }
    break;

  case 138:
/* Line 1787 of yacc.c  */
#line 1139 "cf-parse.y"
    {
     struct iface_patt_node *ipn = cfg_allocz(sizeof(struct iface_patt_node));
     add_tail(&this_ipatt->ipn_list, NODE ipn);
     this_ipn = ipn;
   }
    break;

  case 139:
/* Line 1787 of yacc.c  */
#line 1147 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (1)].t); this_ipn->prefix = IPA_NONE; this_ipn->pxlen = 0; }
    break;

  case 140:
/* Line 1787 of yacc.c  */
#line 1148 "cf-parse.y"
    { this_ipn->pattern = NULL; this_ipn->prefix = (yyvsp[(1) - (1)].px).addr; this_ipn->pxlen = (yyvsp[(1) - (1)].px).len; }
    break;

  case 141:
/* Line 1787 of yacc.c  */
#line 1149 "cf-parse.y"
    { this_ipn->pattern = (yyvsp[(1) - (2)].t); this_ipn->prefix = (yyvsp[(2) - (2)].px).addr; this_ipn->pxlen = (yyvsp[(2) - (2)].px).len; }
    break;

  case 142:
/* Line 1787 of yacc.c  */
#line 1153 "cf-parse.y"
    { this_ipn->positive = 1; }
    break;

  case 143:
/* Line 1787 of yacc.c  */
#line 1154 "cf-parse.y"
    { this_ipn->positive = 0; }
    break;

  case 147:
/* Line 1787 of yacc.c  */
#line 1168 "cf-parse.y"
    { iface_patt_check(); }
    break;

  case 148:
/* Line 1787 of yacc.c  */
#line 1170 "cf-parse.y"
    {
   /* Generic this_ipatt init */
   this_ipatt = cfg_allocz(sizeof(struct iface_patt));
   init_list(&this_ipatt->ipn_list);
 }
    break;

  case 150:
/* Line 1787 of yacc.c  */
#line 1182 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i) & 0xfc;        if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 255)) cf_error("TX class must be in range 0-255"); }
    break;

  case 151:
/* Line 1787 of yacc.c  */
#line 1183 "cf-parse.y"
    { (yyval.i) = ((yyvsp[(2) - (2)].i) & 0x3f) << 2; if (((yyvsp[(2) - (2)].i) < 0) || ((yyvsp[(2) - (2)].i) > 63))  cf_error("TX DSCP must be in range 0-63"); }
    break;

  case 152:
/* Line 1787 of yacc.c  */
#line 1189 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_device, sizeof(struct rt_dev_config), (yyvsp[(1) - (2)].i));
     init_list(&DIRECT_CFG->iface_list);
   }
    break;

  case 156:
/* Line 1787 of yacc.c  */
#line 1202 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct iface_patt));
     add_tail(&DIRECT_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
   }
    break;

  case 158:
/* Line 1787 of yacc.c  */
#line 1216 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 159:
/* Line 1787 of yacc.c  */
#line 1217 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 160:
/* Line 1787 of yacc.c  */
#line 1218 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 162:
/* Line 1787 of yacc.c  */
#line 1223 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 163:
/* Line 1787 of yacc.c  */
#line 1227 "cf-parse.y"
    { (yyval.i) = D_STATES; }
    break;

  case 164:
/* Line 1787 of yacc.c  */
#line 1228 "cf-parse.y"
    { (yyval.i) = D_ROUTES; }
    break;

  case 165:
/* Line 1787 of yacc.c  */
#line 1229 "cf-parse.y"
    { (yyval.i) = D_FILTERS; }
    break;

  case 166:
/* Line 1787 of yacc.c  */
#line 1230 "cf-parse.y"
    { (yyval.i) = D_IFACES; }
    break;

  case 167:
/* Line 1787 of yacc.c  */
#line 1231 "cf-parse.y"
    { (yyval.i) = D_EVENTS; }
    break;

  case 168:
/* Line 1787 of yacc.c  */
#line 1232 "cf-parse.y"
    { (yyval.i) = D_PACKETS; }
    break;

  case 169:
/* Line 1787 of yacc.c  */
#line 1238 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 170:
/* Line 1787 of yacc.c  */
#line 1239 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 171:
/* Line 1787 of yacc.c  */
#line 1240 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 173:
/* Line 1787 of yacc.c  */
#line 1245 "cf-parse.y"
    { (yyval.i) = (yyvsp[(1) - (3)].i) | (yyvsp[(3) - (3)].i); }
    break;

  case 174:
/* Line 1787 of yacc.c  */
#line 1249 "cf-parse.y"
    { (yyval.i) = MD_STATES; }
    break;

  case 175:
/* Line 1787 of yacc.c  */
#line 1250 "cf-parse.y"
    { (yyval.i) = MD_MESSAGES; }
    break;

  case 182:
/* Line 1787 of yacc.c  */
#line 1271 "cf-parse.y"
    {
     if (!this_p_list) {
     	this_p_list = cfg_alloc(sizeof(list));
     	init_list(this_p_list);
        password_id = 1;
     }
     this_p_item = cfg_alloc(sizeof (struct password_item));
     this_p_item->password = (yyvsp[(2) - (2)].t);
     this_p_item->genfrom = 0;
     this_p_item->gento = TIME_INFINITY;
     this_p_item->accfrom = 0;
     this_p_item->accto = TIME_INFINITY;
     this_p_item->id = password_id++;
     add_tail(this_p_list, &this_p_item->n);
   }
    break;

  case 183:
/* Line 1787 of yacc.c  */
#line 1289 "cf-parse.y"
    { }
    break;

  case 184:
/* Line 1787 of yacc.c  */
#line 1290 "cf-parse.y"
    { this_p_item->genfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 185:
/* Line 1787 of yacc.c  */
#line 1291 "cf-parse.y"
    { this_p_item->gento = (yyvsp[(3) - (5)].time); }
    break;

  case 186:
/* Line 1787 of yacc.c  */
#line 1292 "cf-parse.y"
    { this_p_item->accfrom = (yyvsp[(3) - (5)].time); }
    break;

  case 187:
/* Line 1787 of yacc.c  */
#line 1293 "cf-parse.y"
    { this_p_item->accto = (yyvsp[(3) - (5)].time); }
    break;

  case 188:
/* Line 1787 of yacc.c  */
#line 1294 "cf-parse.y"
    { this_p_item->id = (yyvsp[(2) - (4)].i); if ((yyvsp[(2) - (4)].i) <= 0) cf_error("Password ID has to be greated than zero."); }
    break;

  case 189:
/* Line 1787 of yacc.c  */
#line 1303 "cf-parse.y"
    { cmd_show_status(); }
    break;

  case 190:
/* Line 1787 of yacc.c  */
#line 1306 "cf-parse.y"
    { cmd_show_memory(); }
    break;

  case 191:
/* Line 1787 of yacc.c  */
#line 1309 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_show, 0, 0); }
    break;

  case 192:
/* Line 1787 of yacc.c  */
#line 1312 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(4) - (5)].ps), proto_cmd_show, 0, 1); }
    break;

  case 194:
/* Line 1787 of yacc.c  */
#line 1316 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 195:
/* Line 1787 of yacc.c  */
#line 1320 "cf-parse.y"
    { if_show(); }
    break;

  case 196:
/* Line 1787 of yacc.c  */
#line 1323 "cf-parse.y"
    { if_show_summary(); }
    break;

  case 197:
/* Line 1787 of yacc.c  */
#line 1327 "cf-parse.y"
    { rt_show((yyvsp[(3) - (4)].ra)); }
    break;

  case 198:
/* Line 1787 of yacc.c  */
#line 1330 "cf-parse.y"
    {
     (yyval.ra) = cfg_allocz(sizeof(struct rt_show_data));
     (yyval.ra)->pxlen = 256;
     (yyval.ra)->filter = FILTER_ACCEPT;
   }
    break;

  case 199:
/* Line 1787 of yacc.c  */
#line 1335 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(2) - (2)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(2) - (2)].px).len;
   }
    break;

  case 200:
/* Line 1787 of yacc.c  */
#line 1341 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->pxlen != 256) cf_error("Only one prefix expected");
     (yyval.ra)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ra)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ra)->show_for = 1;
   }
    break;

  case 201:
/* Line 1787 of yacc.c  */
#line 1348 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyvsp[(3) - (3)].s)->class != SYM_TABLE) cf_error("%s is not a table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->table = ((struct rtable_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 202:
/* Line 1787 of yacc.c  */
#line 1353 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(3) - (3)].f);
   }
    break;

  case 203:
/* Line 1787 of yacc.c  */
#line 1358 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     if ((yyval.ra)->filter != FILTER_ACCEPT) cf_error("Filter specified twice");
     (yyval.ra)->filter = (yyvsp[(2) - (2)].f);
   }
    break;

  case 204:
/* Line 1787 of yacc.c  */
#line 1363 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->verbose = 1;
   }
    break;

  case 205:
/* Line 1787 of yacc.c  */
#line 1367 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->primary_only = 1;
   }
    break;

  case 206:
/* Line 1787 of yacc.c  */
#line 1371 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->filtered = 1;
   }
    break;

  case 207:
/* Line 1787 of yacc.c  */
#line 1375 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->export_mode) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->export_mode = (yyvsp[(2) - (3)].i);
     (yyval.ra)->primary_only = 1;
     (yyval.ra)->export_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 208:
/* Line 1787 of yacc.c  */
#line 1385 "cf-parse.y"
    {
     struct proto_config *c = (struct proto_config *) (yyvsp[(3) - (3)].s)->def;
     (yyval.ra) = (yyvsp[(1) - (3)].ra);
     if ((yyval.ra)->show_protocol) cf_error("Protocol specified twice");
     if ((yyvsp[(3) - (3)].s)->class != SYM_PROTO || !c->proto) cf_error("%s is not a protocol", (yyvsp[(3) - (3)].s)->name);
     (yyval.ra)->show_protocol = c->proto;
     (yyval.ra)->running_on_config = c->proto->cf->global;
   }
    break;

  case 209:
/* Line 1787 of yacc.c  */
#line 1393 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 1;
   }
    break;

  case 210:
/* Line 1787 of yacc.c  */
#line 1397 "cf-parse.y"
    {
     (yyval.ra) = (yyvsp[(1) - (2)].ra);
     (yyval.ra)->stats = 2;
   }
    break;

  case 211:
/* Line 1787 of yacc.c  */
#line 1404 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 212:
/* Line 1787 of yacc.c  */
#line 1405 "cf-parse.y"
    { (yyval.i) = 2; }
    break;

  case 213:
/* Line 1787 of yacc.c  */
#line 1411 "cf-parse.y"
    { roa_show((yyvsp[(3) - (4)].ro)); }
    break;

  case 214:
/* Line 1787 of yacc.c  */
#line 1414 "cf-parse.y"
    {
     (yyval.ro) = cfg_allocz(sizeof(struct roa_show_data));
     (yyval.ro)->mode = ROA_SHOW_ALL;
     (yyval.ro)->table = roa_table_default;
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
   }
    break;

  case 215:
/* Line 1787 of yacc.c  */
#line 1421 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyval.ro)->mode != ROA_SHOW_ALL) cf_error("Only one prefix expected");
     (yyval.ro)->prefix = (yyvsp[(3) - (3)].px).addr;
     (yyval.ro)->pxlen = (yyvsp[(3) - (3)].px).len;
     (yyval.ro)->mode = (yyvsp[(2) - (3)].i);
   }
    break;

  case 216:
/* Line 1787 of yacc.c  */
#line 1428 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     (yyval.ro)->asn = (yyvsp[(3) - (3)].i);
   }
    break;

  case 217:
/* Line 1787 of yacc.c  */
#line 1432 "cf-parse.y"
    {
     (yyval.ro) = (yyvsp[(1) - (3)].ro);
     if ((yyvsp[(3) - (3)].s)->class != SYM_ROA) cf_error("%s is not a ROA table", (yyvsp[(3) - (3)].s)->name);
     (yyval.ro)->table = ((struct roa_table_config *)(yyvsp[(3) - (3)].s)->def)->table;
   }
    break;

  case 218:
/* Line 1787 of yacc.c  */
#line 1440 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_PX; }
    break;

  case 219:
/* Line 1787 of yacc.c  */
#line 1441 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_IN; }
    break;

  case 220:
/* Line 1787 of yacc.c  */
#line 1442 "cf-parse.y"
    { (yyval.i) = ROA_SHOW_FOR; }
    break;

  case 221:
/* Line 1787 of yacc.c  */
#line 1448 "cf-parse.y"
    { cmd_show_symbols((yyvsp[(3) - (4)].sd)); }
    break;

  case 222:
/* Line 1787 of yacc.c  */
#line 1451 "cf-parse.y"
    {
     (yyval.sd) = cfg_allocz(sizeof(struct sym_show_data));
   }
    break;

  case 223:
/* Line 1787 of yacc.c  */
#line 1454 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TABLE; }
    break;

  case 224:
/* Line 1787 of yacc.c  */
#line 1455 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FUNCTION; }
    break;

  case 225:
/* Line 1787 of yacc.c  */
#line 1456 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_FILTER; }
    break;

  case 226:
/* Line 1787 of yacc.c  */
#line 1457 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_PROTO; }
    break;

  case 227:
/* Line 1787 of yacc.c  */
#line 1458 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_TEMPLATE; }
    break;

  case 228:
/* Line 1787 of yacc.c  */
#line 1459 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->type = SYM_ROA; }
    break;

  case 229:
/* Line 1787 of yacc.c  */
#line 1460 "cf-parse.y"
    { (yyval.sd) = (yyvsp[(1) - (2)].sd); (yyval.sd)->sym = (yyvsp[(2) - (2)].s); }
    break;

  case 230:
/* Line 1787 of yacc.c  */
#line 1465 "cf-parse.y"
    { 
     if (roa_table_default == NULL)
       cf_error("No ROA table defined");
     (yyval.rot) = roa_table_default;
   }
    break;

  case 231:
/* Line 1787 of yacc.c  */
#line 1470 "cf-parse.y"
    {
     if ((yyvsp[(2) - (2)].s)->class != SYM_ROA)
       cf_error("%s is not a ROA table", (yyvsp[(2) - (2)].s)->name);
     (yyval.rot) = ((struct roa_table_config *)(yyvsp[(2) - (2)].s)->def)->table;
   }
    break;

  case 232:
/* Line 1787 of yacc.c  */
#line 1479 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_add_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 233:
/* Line 1787 of yacc.c  */
#line 1486 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_delete_item((yyvsp[(8) - (9)].rot), (yyvsp[(3) - (9)].px).addr, (yyvsp[(3) - (9)].px).len, (yyvsp[(5) - (9)].i), (yyvsp[(7) - (9)].i), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 234:
/* Line 1787 of yacc.c  */
#line 1493 "cf-parse.y"
    {
  if (! cli_access_restricted())
    { roa_flush((yyvsp[(3) - (4)].rot), ROA_SRC_DYNAMIC); cli_msg(0, ""); }
}
    break;

  case 235:
/* Line 1787 of yacc.c  */
#line 1501 "cf-parse.y"
    { rdump(&root_pool); cli_msg(0, ""); }
    break;

  case 236:
/* Line 1787 of yacc.c  */
#line 1503 "cf-parse.y"
    { sk_dump_all(); cli_msg(0, ""); }
    break;

  case 237:
/* Line 1787 of yacc.c  */
#line 1505 "cf-parse.y"
    { if_dump_all(); cli_msg(0, ""); }
    break;

  case 238:
/* Line 1787 of yacc.c  */
#line 1507 "cf-parse.y"
    { neigh_dump_all(); cli_msg(0, ""); }
    break;

  case 239:
/* Line 1787 of yacc.c  */
#line 1509 "cf-parse.y"
    { rta_dump_all(); cli_msg(0, ""); }
    break;

  case 240:
/* Line 1787 of yacc.c  */
#line 1511 "cf-parse.y"
    { rt_dump_all(); cli_msg(0, ""); }
    break;

  case 241:
/* Line 1787 of yacc.c  */
#line 1513 "cf-parse.y"
    { protos_dump_all(); cli_msg(0, ""); }
    break;

  case 242:
/* Line 1787 of yacc.c  */
#line 1516 "cf-parse.y"
    { cmd_eval((yyvsp[(2) - (3)].x)); }
    break;

  case 243:
/* Line 1787 of yacc.c  */
#line 1519 "cf-parse.y"
    {
  cli_set_log_echo(this_cli, (yyvsp[(2) - (4)].i), (yyvsp[(3) - (4)].i));
  cli_msg(0, "");
}
    break;

  case 244:
/* Line 1787 of yacc.c  */
#line 1525 "cf-parse.y"
    { (yyval.i) = ~0; }
    break;

  case 245:
/* Line 1787 of yacc.c  */
#line 1526 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 246:
/* Line 1787 of yacc.c  */
#line 1527 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (3)].i); }
    break;

  case 247:
/* Line 1787 of yacc.c  */
#line 1531 "cf-parse.y"
    { (yyval.i) = 4096; }
    break;

  case 248:
/* Line 1787 of yacc.c  */
#line 1532 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].i) < 256 || (yyvsp[(1) - (1)].i) > 65536) cf_error("Invalid log buffer size");
     (yyval.i) = (yyvsp[(1) - (1)].i);
   }
    break;

  case 249:
/* Line 1787 of yacc.c  */
#line 1539 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_disable, 1, 0); }
    break;

  case 250:
/* Line 1787 of yacc.c  */
#line 1541 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_enable, 1, 0); }
    break;

  case 251:
/* Line 1787 of yacc.c  */
#line 1543 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_restart, 1, 0); }
    break;

  case 252:
/* Line 1787 of yacc.c  */
#line 1545 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (3)].ps), proto_cmd_reload, 1, CMD_RELOAD); }
    break;

  case 253:
/* Line 1787 of yacc.c  */
#line 1547 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_IN); }
    break;

  case 254:
/* Line 1787 of yacc.c  */
#line 1549 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(3) - (4)].ps), proto_cmd_reload, 1, CMD_RELOAD_OUT); }
    break;

  case 255:
/* Line 1787 of yacc.c  */
#line 1553 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_debug, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 256:
/* Line 1787 of yacc.c  */
#line 1557 "cf-parse.y"
    { proto_apply_cmd((yyvsp[(2) - (4)].ps), proto_cmd_mrtdump, 1, (yyvsp[(3) - (4)].i)); }
    break;

  case 257:
/* Line 1787 of yacc.c  */
#line 1560 "cf-parse.y"
    { this_cli->restricted = 1; cli_msg(16, "Access restricted"); }
    break;

  case 258:
/* Line 1787 of yacc.c  */
#line 1563 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 259:
/* Line 1787 of yacc.c  */
#line 1564 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 260:
/* Line 1787 of yacc.c  */
#line 1565 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 261:
/* Line 1787 of yacc.c  */
#line 1569 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].s); (yyval.ps).patt = 0; }
    break;

  case 262:
/* Line 1787 of yacc.c  */
#line 1570 "cf-parse.y"
    { (yyval.ps).ptr = NULL; (yyval.ps).patt = 1; }
    break;

  case 263:
/* Line 1787 of yacc.c  */
#line 1571 "cf-parse.y"
    { (yyval.ps).ptr = (yyvsp[(1) - (1)].t); (yyval.ps).patt = 1; }
    break;

  case 264:
/* Line 1787 of yacc.c  */
#line 1579 "cf-parse.y"
    { (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FILTER, NULL); cf_push_scope( (yyvsp[(2) - (2)].s) ); }
    break;

  case 265:
/* Line 1787 of yacc.c  */
#line 1580 "cf-parse.y"
    {
     (yyvsp[(2) - (4)].s)->def = (yyvsp[(4) - (4)].f);
     (yyvsp[(4) - (4)].f)->name = (yyvsp[(2) - (4)].s)->name;
     DBG( "We have new filter defined (%s)\n", (yyvsp[(2) - (4)].s)->name );
     cf_pop_scope();
   }
    break;

  case 266:
/* Line 1787 of yacc.c  */
#line 1589 "cf-parse.y"
    { f_eval_int((yyvsp[(2) - (2)].x)); }
    break;

  case 267:
/* Line 1787 of yacc.c  */
#line 1593 "cf-parse.y"
    { (yyval.i) = T_INT; }
    break;

  case 268:
/* Line 1787 of yacc.c  */
#line 1594 "cf-parse.y"
    { (yyval.i) = T_BOOL; }
    break;

  case 269:
/* Line 1787 of yacc.c  */
#line 1595 "cf-parse.y"
    { (yyval.i) = T_IP; }
    break;

  case 270:
/* Line 1787 of yacc.c  */
#line 1596 "cf-parse.y"
    { (yyval.i) = T_PREFIX; }
    break;

  case 271:
/* Line 1787 of yacc.c  */
#line 1597 "cf-parse.y"
    { (yyval.i) = T_PAIR; }
    break;

  case 272:
/* Line 1787 of yacc.c  */
#line 1598 "cf-parse.y"
    { (yyval.i) = T_QUAD; }
    break;

  case 273:
/* Line 1787 of yacc.c  */
#line 1599 "cf-parse.y"
    { (yyval.i) = T_EC; }
    break;

  case 274:
/* Line 1787 of yacc.c  */
#line 1600 "cf-parse.y"
    { (yyval.i) = T_STRING; }
    break;

  case 275:
/* Line 1787 of yacc.c  */
#line 1601 "cf-parse.y"
    { (yyval.i) = T_PATH_MASK; }
    break;

  case 276:
/* Line 1787 of yacc.c  */
#line 1602 "cf-parse.y"
    { (yyval.i) = T_PATH; }
    break;

  case 277:
/* Line 1787 of yacc.c  */
#line 1603 "cf-parse.y"
    { (yyval.i) = T_CLIST; }
    break;

  case 278:
/* Line 1787 of yacc.c  */
#line 1604 "cf-parse.y"
    { (yyval.i) = T_ECLIST; }
    break;

  case 279:
/* Line 1787 of yacc.c  */
#line 1605 "cf-parse.y"
    { 
	switch ((yyvsp[(1) - (2)].i)) {
	  case T_INT:
	  case T_PAIR:
	  case T_QUAD:
	  case T_EC:
	  case T_IP:
	       (yyval.i) = T_SET;
	       break;

	  case T_PREFIX:
	       (yyval.i) = T_PREFIX_SET;
	    break;

	  default:
		cf_error( "You can't create sets of this type." );
	}
   }
    break;

  case 280:
/* Line 1787 of yacc.c  */
#line 1626 "cf-parse.y"
    {
     struct f_val * val = cfg_alloc(sizeof(struct f_val));
     val->type = T_VOID;
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_VARIABLE | (yyvsp[(1) - (2)].i), val);
     DBG( "New variable %s type %x\n", (yyvsp[(2) - (2)].s)->name, (yyvsp[(1) - (2)].i) );
     (yyvsp[(2) - (2)].s)->aux2 = NULL;
     (yyval.s)=(yyvsp[(2) - (2)].s);
   }
    break;

  case 281:
/* Line 1787 of yacc.c  */
#line 1637 "cf-parse.y"
    { (yyval.s) = NULL; }
    break;

  case 282:
/* Line 1787 of yacc.c  */
#line 1638 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 283:
/* Line 1787 of yacc.c  */
#line 1645 "cf-parse.y"
    { (yyval.s) = (yyvsp[(1) - (1)].s); }
    break;

  case 284:
/* Line 1787 of yacc.c  */
#line 1646 "cf-parse.y"
    {
     (yyval.s) = (yyvsp[(1) - (3)].s);
     (yyval.s)->aux2 = (yyvsp[(3) - (3)].s);
   }
    break;

  case 285:
/* Line 1787 of yacc.c  */
#line 1653 "cf-parse.y"
    {
     struct filter *f = cfg_alloc(sizeof(struct filter));
     f->name = NULL;
     f->root = (yyvsp[(1) - (1)].x);
     (yyval.f) = f;
   }
    break;

  case 286:
/* Line 1787 of yacc.c  */
#line 1662 "cf-parse.y"
    {
     if ((yyvsp[(1) - (1)].s)->class != SYM_FILTER) cf_error("No such filter.");
     (yyval.f) = (yyvsp[(1) - (1)].s)->def;
   }
    break;

  case 288:
/* Line 1787 of yacc.c  */
#line 1670 "cf-parse.y"
    {
     /* Construct 'IF term THEN ACCEPT; REJECT;' */
     struct filter *f = cfg_alloc(sizeof(struct filter));
     struct f_inst *i, *acc, *rej;
     acc = f_new_inst();		/* ACCEPT */
     acc->code = P('p',',');
     acc->a1.p = NULL;
     acc->a2.i = F_ACCEPT;
     rej = f_new_inst();		/* REJECT */
     rej->code = P('p',',');
     rej->a1.p = NULL;
     rej->a2.i = F_REJECT;
     i = f_new_inst();			/* IF */
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (2)].x);
     i->a2.p = acc;
     i->next = rej;
     f->name = NULL;
     f->root = i;
     (yyval.f) = f;
  }
    break;

  case 289:
/* Line 1787 of yacc.c  */
#line 1694 "cf-parse.y"
    { DBG( "Have function parameters\n" ); (yyval.s)=(yyvsp[(2) - (3)].s); }
    break;

  case 290:
/* Line 1787 of yacc.c  */
#line 1695 "cf-parse.y"
    { (yyval.s)=NULL; }
    break;

  case 291:
/* Line 1787 of yacc.c  */
#line 1699 "cf-parse.y"
    {
     if ((yyvsp[(1) - (4)].s)) {
       /* Prepend instruction to clear local variables */
       (yyval.x) = f_new_inst();
       (yyval.x)->code = P('c','v');
       (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
       (yyval.x)->next = (yyvsp[(3) - (4)].x);
     } else
       (yyval.x) = (yyvsp[(3) - (4)].x);
   }
    break;

  case 292:
/* Line 1787 of yacc.c  */
#line 1712 "cf-parse.y"
    { DBG( "Beginning of function %s\n", (yyvsp[(2) - (2)].s)->name );
     (yyvsp[(2) - (2)].s) = cf_define_symbol((yyvsp[(2) - (2)].s), SYM_FUNCTION, NULL);
     cf_push_scope((yyvsp[(2) - (2)].s));
   }
    break;

  case 293:
/* Line 1787 of yacc.c  */
#line 1715 "cf-parse.y"
    {
     (yyvsp[(2) - (5)].s)->def = (yyvsp[(5) - (5)].x);
     (yyvsp[(2) - (5)].s)->aux2 = (yyvsp[(4) - (5)].s);
     DBG("Hmm, we've got one function here - %s\n", (yyvsp[(2) - (5)].s)->name); 
     cf_pop_scope();
   }
    break;

  case 294:
/* Line 1787 of yacc.c  */
#line 1728 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 295:
/* Line 1787 of yacc.c  */
#line 1729 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x)->next; (yyvsp[(1) - (1)].x)->next = NULL; }
    break;

  case 296:
/* Line 1787 of yacc.c  */
#line 1732 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); (yyvsp[(1) - (1)].x)->next = (yyvsp[(1) - (1)].x); }
    break;

  case 297:
/* Line 1787 of yacc.c  */
#line 1733 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyvsp[(2) - (2)].x)->next = (yyvsp[(1) - (2)].x)->next ; (yyvsp[(1) - (2)].x)->next = (yyvsp[(2) - (2)].x); }
    break;

  case 298:
/* Line 1787 of yacc.c  */
#line 1737 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(1) - (1)].x);
   }
    break;

  case 299:
/* Line 1787 of yacc.c  */
#line 1740 "cf-parse.y"
    {
     (yyval.x)=(yyvsp[(2) - (3)].x);
   }
    break;

  case 300:
/* Line 1787 of yacc.c  */
#line 1749 "cf-parse.y"
    { (yyval.v).type = T_IP; (yyval.v).val.px.ip = (yyvsp[(1) - (1)].a); }
    break;

  case 301:
/* Line 1787 of yacc.c  */
#line 1762 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 302:
/* Line 1787 of yacc.c  */
#line 1763 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 303:
/* Line 1787 of yacc.c  */
#line 1764 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 304:
/* Line 1787 of yacc.c  */
#line 1765 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 305:
/* Line 1787 of yacc.c  */
#line 1769 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = (yyvsp[(1) - (1)].i); }
    break;

  case 306:
/* Line 1787 of yacc.c  */
#line 1770 "cf-parse.y"
    { (yyval.v).type = T_INT; (yyval.v).val.i = f_eval_int((yyvsp[(2) - (3)].x)); }
    break;

  case 307:
/* Line 1787 of yacc.c  */
#line 1771 "cf-parse.y"
    { (yyval.v).type = T_QUAD; (yyval.v).val.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 308:
/* Line 1787 of yacc.c  */
#line 1772 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 309:
/* Line 1787 of yacc.c  */
#line 1773 "cf-parse.y"
    { (yyval.v).type = pair_a((yyvsp[(1) - (1)].i)); (yyval.v).val.i = pair_b((yyvsp[(1) - (1)].i)); }
    break;

  case 310:
/* Line 1787 of yacc.c  */
#line 1777 "cf-parse.y"
    { (yyval.i) = f_eval_int((yyvsp[(1) - (1)].x)); check_u16((yyval.i)); }
    break;

  case 311:
/* Line 1787 of yacc.c  */
#line 1780 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (1)].i), (yyvsp[(1) - (1)].i)); }
    break;

  case 312:
/* Line 1787 of yacc.c  */
#line 1781 "cf-parse.y"
    { (yyval.i32) = pair((yyvsp[(1) - (3)].i), (yyvsp[(3) - (3)].i)); }
    break;

  case 313:
/* Line 1787 of yacc.c  */
#line 1782 "cf-parse.y"
    { (yyval.i32) = 0xFFFF; }
    break;

  case 314:
/* Line 1787 of yacc.c  */
#line 1786 "cf-parse.y"
    {
     (yyval.e) = f_new_pair_set(pair_a((yyvsp[(2) - (5)].i32)), pair_b((yyvsp[(2) - (5)].i32)), pair_a((yyvsp[(4) - (5)].i32)), pair_b((yyvsp[(4) - (5)].i32)));
   }
    break;

  case 315:
/* Line 1787 of yacc.c  */
#line 1789 "cf-parse.y"
    {
     /* Hack: $2 and $4 should be pair_expr, but that would cause shift/reduce conflict */
     if ((pair_a((yyvsp[(2) - (11)].i32)) != pair_b((yyvsp[(2) - (11)].i32))) || (pair_a((yyvsp[(4) - (11)].i32)) != pair_b((yyvsp[(4) - (11)].i32))))
       cf_error("syntax error");
     (yyval.e) = f_new_pair_item(pair_b((yyvsp[(2) - (11)].i32)), (yyvsp[(8) - (11)].i), pair_b((yyvsp[(4) - (11)].i32)), (yyvsp[(10) - (11)].i)); 
   }
    break;

  case 316:
/* Line 1787 of yacc.c  */
#line 1798 "cf-parse.y"
    { (yyval.i32) = f_eval_int((yyvsp[(1) - (1)].x)); }
    break;

  case 317:
/* Line 1787 of yacc.c  */
#line 1801 "cf-parse.y"
    { (yyval.i) = EC_RT; }
    break;

  case 318:
/* Line 1787 of yacc.c  */
#line 1802 "cf-parse.y"
    { (yyval.i) = EC_RO; }
    break;

  case 319:
/* Line 1787 of yacc.c  */
#line 1803 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 320:
/* Line 1787 of yacc.c  */
#line 1804 "cf-parse.y"
    { (yyval.i) = EC_GENERIC; }
    break;

  case 321:
/* Line 1787 of yacc.c  */
#line 1808 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), (yyvsp[(6) - (7)].i32), (yyvsp[(6) - (7)].i32)); }
    break;

  case 322:
/* Line 1787 of yacc.c  */
#line 1809 "cf-parse.y"
    { (yyval.e) = f_new_ec_item((yyvsp[(2) - (9)].i), 0, (yyvsp[(4) - (9)].i32), (yyvsp[(6) - (9)].i32), (yyvsp[(8) - (9)].i32)); }
    break;

  case 323:
/* Line 1787 of yacc.c  */
#line 1810 "cf-parse.y"
    {  (yyval.e) = f_new_ec_item((yyvsp[(2) - (7)].i), 0, (yyvsp[(4) - (7)].i32), 0, EC_ALL); }
    break;

  case 326:
/* Line 1787 of yacc.c  */
#line 1816 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 327:
/* Line 1787 of yacc.c  */
#line 1817 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 330:
/* Line 1787 of yacc.c  */
#line 1823 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (1)].v), (yyvsp[(1) - (1)].v)); }
    break;

  case 331:
/* Line 1787 of yacc.c  */
#line 1824 "cf-parse.y"
    { (yyval.e) = f_new_item((yyvsp[(1) - (3)].v), (yyvsp[(3) - (3)].v)); }
    break;

  case 333:
/* Line 1787 of yacc.c  */
#line 1829 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 335:
/* Line 1787 of yacc.c  */
#line 1834 "cf-parse.y"
    { (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), (yyvsp[(3) - (3)].e)); }
    break;

  case 336:
/* Line 1787 of yacc.c  */
#line 1838 "cf-parse.y"
    {
     if (((yyvsp[(3) - (3)].i) < 0) || ((yyvsp[(3) - (3)].i) > MAX_PREFIX_LENGTH) || !ip_is_prefix((yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i))) cf_error("Invalid network prefix: %I/%d.", (yyvsp[(1) - (3)].a), (yyvsp[(3) - (3)].i));
     (yyval.v).type = T_PREFIX; (yyval.v).val.px.ip = (yyvsp[(1) - (3)].a); (yyval.v).val.px.len = (yyvsp[(3) - (3)].i);
   }
    break;

  case 337:
/* Line 1787 of yacc.c  */
#line 1845 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (1)].v); }
    break;

  case 338:
/* Line 1787 of yacc.c  */
#line 1846 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_PLUS; }
    break;

  case 339:
/* Line 1787 of yacc.c  */
#line 1847 "cf-parse.y"
    { (yyval.v) = (yyvsp[(1) - (2)].v); (yyval.v).val.px.len |= LEN_MINUS; }
    break;

  case 340:
/* Line 1787 of yacc.c  */
#line 1848 "cf-parse.y"
    { 
     if (! ((0 <= (yyvsp[(3) - (6)].i)) && ((yyvsp[(3) - (6)].i) <= (yyvsp[(5) - (6)].i)) && ((yyvsp[(5) - (6)].i) <= MAX_PREFIX_LENGTH))) cf_error("Invalid prefix pattern range: {%d, %d}.", (yyvsp[(3) - (6)].i), (yyvsp[(5) - (6)].i));
     (yyval.v) = (yyvsp[(1) - (6)].v); (yyval.v).val.px.len |= LEN_RANGE | ((yyvsp[(3) - (6)].i) << 16) | ((yyvsp[(5) - (6)].i) << 8);
   }
    break;

  case 341:
/* Line 1787 of yacc.c  */
#line 1855 "cf-parse.y"
    { (yyval.trie) = f_new_trie(cfg_mem); trie_add_fprefix((yyval.trie), &((yyvsp[(1) - (1)].v).val.px)); }
    break;

  case 342:
/* Line 1787 of yacc.c  */
#line 1856 "cf-parse.y"
    { (yyval.trie) = (yyvsp[(1) - (3)].trie); trie_add_fprefix((yyval.trie), &((yyvsp[(3) - (3)].v).val.px)); }
    break;

  case 343:
/* Line 1787 of yacc.c  */
#line 1859 "cf-parse.y"
    { (yyval.e) = NULL; }
    break;

  case 344:
/* Line 1787 of yacc.c  */
#line 1860 "cf-parse.y"
    {
     /* Fill data fields */
     struct f_tree *t;
     for (t = (yyvsp[(2) - (4)].e); t; t = t->left)
       t->data = (yyvsp[(4) - (4)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (4)].e), (yyvsp[(2) - (4)].e));
   }
    break;

  case 345:
/* Line 1787 of yacc.c  */
#line 1867 "cf-parse.y"
    { 
     struct f_tree *t = f_new_tree();
     t->from.type = t->to.type = T_VOID;
     t->right = t;
     t->data = (yyvsp[(3) - (3)].x);
     (yyval.e) = f_merge_items((yyvsp[(1) - (3)].e), t);
 }
    break;

  case 346:
/* Line 1787 of yacc.c  */
#line 1879 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 347:
/* Line 1787 of yacc.c  */
#line 1880 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 348:
/* Line 1787 of yacc.c  */
#line 1884 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 349:
/* Line 1787 of yacc.c  */
#line 1885 "cf-parse.y"
    { (yyval.h) = (yyvsp[(2) - (3)].h); }
    break;

  case 350:
/* Line 1787 of yacc.c  */
#line 1889 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 351:
/* Line 1787 of yacc.c  */
#line 1890 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 352:
/* Line 1787 of yacc.c  */
#line 1891 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_QUESTION; (yyval.h)->val  = 0; }
    break;

  case 353:
/* Line 1787 of yacc.c  */
#line 1892 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN_EXPR; (yyval.h)->val = (uintptr_t) (yyvsp[(1) - (2)].x); }
    break;

  case 354:
/* Line 1787 of yacc.c  */
#line 1893 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 355:
/* Line 1787 of yacc.c  */
#line 1897 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASN;      (yyval.h)->val = (yyvsp[(1) - (2)].i); }
    break;

  case 356:
/* Line 1787 of yacc.c  */
#line 1898 "cf-parse.y"
    { (yyval.h) = cfg_alloc(sizeof(struct f_path_mask)); (yyval.h)->next = (yyvsp[(2) - (2)].h); (yyval.h)->kind = PM_ASTERISK; (yyval.h)->val  = 0; }
    break;

  case 357:
/* Line 1787 of yacc.c  */
#line 1899 "cf-parse.y"
    { (yyval.h) = NULL; }
    break;

  case 358:
/* Line 1787 of yacc.c  */
#line 1903 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_INT;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i); }
    break;

  case 359:
/* Line 1787 of yacc.c  */
#line 1904 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 1;  }
    break;

  case 360:
/* Line 1787 of yacc.c  */
#line 1905 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_BOOL; (yyval.x)->a2.i = 0;  }
    break;

  case 361:
/* Line 1787 of yacc.c  */
#line 1906 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_STRING; (yyval.x)->a2.p = (yyvsp[(1) - (1)].t); }
    break;

  case 362:
/* Line 1787 of yacc.c  */
#line 1907 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 363:
/* Line 1787 of yacc.c  */
#line 1908 "cf-parse.y"
    {NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; (yyval.x)->a1.p = val; *val = (yyvsp[(1) - (1)].v); }
    break;

  case 364:
/* Line 1787 of yacc.c  */
#line 1909 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_QUAD;  (yyval.x)->a2.i = (yyvsp[(1) - (1)].i32); }
    break;

  case 365:
/* Line 1787 of yacc.c  */
#line 1910 "cf-parse.y"
    { DBG( "We've got a set here..." ); (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_SET; (yyval.x)->a2.p = build_tree((yyvsp[(2) - (3)].e)); DBG( "ook\n" ); }
    break;

  case 366:
/* Line 1787 of yacc.c  */
#line 1911 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = T_PREFIX_SET;  (yyval.x)->a2.p = (yyvsp[(2) - (3)].trie); }
    break;

  case 367:
/* Line 1787 of yacc.c  */
#line 1912 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'c'; (yyval.x)->aux = (yyvsp[(1) - (1)].i) >> 16; (yyval.x)->a2.i = (yyvsp[(1) - (1)].i) & 0xffff; }
    break;

  case 368:
/* Line 1787 of yacc.c  */
#line 1913 "cf-parse.y"
    { NEW_F_VAL; (yyval.x) = f_new_inst(); (yyval.x)->code = 'C'; val->type = T_PATH_MASK; val->val.path_mask = (yyvsp[(1) - (1)].h); (yyval.x)->a1.p = val; }
    break;

  case 369:
/* Line 1787 of yacc.c  */
#line 1917 "cf-parse.y"
    { (yyval.x) = f_generate_dpair((yyvsp[(2) - (5)].x), (yyvsp[(4) - (5)].x)); }
    break;

  case 370:
/* Line 1787 of yacc.c  */
#line 1918 "cf-parse.y"
    { (yyval.x) = f_generate_ec((yyvsp[(2) - (7)].i), (yyvsp[(4) - (7)].x), (yyvsp[(6) - (7)].x)); }
    break;

  case 372:
/* Line 1787 of yacc.c  */
#line 1932 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 373:
/* Line 1787 of yacc.c  */
#line 1955 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();

     switch ((yyvsp[(1) - (1)].s)->class & 0xff00) {
       case SYM_CONSTANT: (yyval.x)->code = 'C'; break;
       case SYM_VARIABLE: (yyval.x)->code = 'V'; break;
       default: cf_error("%s: variable expected.", (yyvsp[(1) - (1)].s)->name);
     }

     (yyval.x)->a1.p = (yyvsp[(1) - (1)].s)->def;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].s)->name;
   }
    break;

  case 374:
/* Line 1787 of yacc.c  */
#line 1969 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_FROM;	(yyval.x)->a1.i = 1; }
    break;

  case 375:
/* Line 1787 of yacc.c  */
#line 1970 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_IP;         (yyval.x)->a2.i = SA_GW;	(yyval.x)->a1.i = 1; }
    break;

  case 376:
/* Line 1787 of yacc.c  */
#line 1971 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_PREFIX;     (yyval.x)->a2.i = SA_NET; }
    break;

  case 377:
/* Line 1787 of yacc.c  */
#line 1972 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_PROTO; }
    break;

  case 378:
/* Line 1787 of yacc.c  */
#line 1973 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTS;   (yyval.x)->a2.i = SA_SOURCE; }
    break;

  case 379:
/* Line 1787 of yacc.c  */
#line 1974 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_SCOPE; (yyval.x)->a2.i = SA_SCOPE;	(yyval.x)->a1.i = 1; }
    break;

  case 380:
/* Line 1787 of yacc.c  */
#line 1975 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTC;   (yyval.x)->a2.i = SA_CAST; }
    break;

  case 381:
/* Line 1787 of yacc.c  */
#line 1976 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_ENUM_RTD;   (yyval.x)->a2.i = SA_DEST;	(yyval.x)->a1.i = 1; }
    break;

  case 382:
/* Line 1787 of yacc.c  */
#line 1977 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_STRING;     (yyval.x)->a2.i = SA_IFNAME; }
    break;

  case 383:
/* Line 1787 of yacc.c  */
#line 1978 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->aux = T_INT;        (yyval.x)->a2.i = SA_IFINDEX; }
    break;

  case 384:
/* Line 1787 of yacc.c  */
#line 1982 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (3)].x); }
    break;

  case 385:
/* Line 1787 of yacc.c  */
#line 1983 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '+';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 386:
/* Line 1787 of yacc.c  */
#line 1984 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '-';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 387:
/* Line 1787 of yacc.c  */
#line 1985 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '*';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 388:
/* Line 1787 of yacc.c  */
#line 1986 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '/';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 389:
/* Line 1787 of yacc.c  */
#line 1987 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '&';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 390:
/* Line 1787 of yacc.c  */
#line 1988 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '|';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 391:
/* Line 1787 of yacc.c  */
#line 1989 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('=','='); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 392:
/* Line 1787 of yacc.c  */
#line 1990 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('!','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 393:
/* Line 1787 of yacc.c  */
#line 1991 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 394:
/* Line 1787 of yacc.c  */
#line 1992 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 395:
/* Line 1787 of yacc.c  */
#line 1993 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '<';        (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 396:
/* Line 1787 of yacc.c  */
#line 1994 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('<','=');     (yyval.x)->a1.p = (yyvsp[(3) - (3)].x); (yyval.x)->a2.p = (yyvsp[(1) - (3)].x); }
    break;

  case 397:
/* Line 1787 of yacc.c  */
#line 1995 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '~';        (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->a2.p = (yyvsp[(3) - (3)].x); }
    break;

  case 398:
/* Line 1787 of yacc.c  */
#line 1996 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = '!'; (yyval.x)->a1.p = (yyvsp[(2) - (2)].x); }
    break;

  case 399:
/* Line 1787 of yacc.c  */
#line 1997 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('d','e');  (yyval.x)->a1.p = (yyvsp[(3) - (4)].x); }
    break;

  case 400:
/* Line 1787 of yacc.c  */
#line 1999 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 401:
/* Line 1787 of yacc.c  */
#line 2000 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 402:
/* Line 1787 of yacc.c  */
#line 2001 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 403:
/* Line 1787 of yacc.c  */
#line 2003 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'P'; }
    break;

  case 404:
/* Line 1787 of yacc.c  */
#line 2005 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = 'a'; }
    break;

  case 405:
/* Line 1787 of yacc.c  */
#line 2007 "cf-parse.y"
    { (yyval.x) = (yyvsp[(2) - (2)].x); (yyval.x)->code = P('e','a'); }
    break;

  case 406:
/* Line 1787 of yacc.c  */
#line 2009 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('c','p'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); (yyval.x)->aux = T_IP; }
    break;

  case 407:
/* Line 1787 of yacc.c  */
#line 2010 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'L'; (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 408:
/* Line 1787 of yacc.c  */
#line 2011 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('i','M'); (yyval.x)->a1.p = (yyvsp[(1) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 409:
/* Line 1787 of yacc.c  */
#line 2012 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','f'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 410:
/* Line 1787 of yacc.c  */
#line 2013 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('a','l'); (yyval.x)->a1.p = (yyvsp[(1) - (3)].x); }
    break;

  case 411:
/* Line 1787 of yacc.c  */
#line 2023 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_PATH; }
    break;

  case 412:
/* Line 1787 of yacc.c  */
#line 2024 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_CLIST; }
    break;

  case 413:
/* Line 1787 of yacc.c  */
#line 2025 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'E'; (yyval.x)->aux = T_ECLIST; }
    break;

  case 414:
/* Line 1787 of yacc.c  */
#line 2026 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('A','p'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); }
    break;

  case 415:
/* Line 1787 of yacc.c  */
#line 2027 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'a'; }
    break;

  case 416:
/* Line 1787 of yacc.c  */
#line 2028 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'd'; }
    break;

  case 417:
/* Line 1787 of yacc.c  */
#line 2029 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('C','a'); (yyval.x)->a1.p = (yyvsp[(3) - (6)].x); (yyval.x)->a2.p = (yyvsp[(5) - (6)].x); (yyval.x)->aux = 'f'; }
    break;

  case 418:
/* Line 1787 of yacc.c  */
#line 2031 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (4)].s), NULL, NULL); }
    break;

  case 419:
/* Line 1787 of yacc.c  */
#line 2032 "cf-parse.y"
    { (yyval.x) = f_generate_roa_check((yyvsp[(3) - (8)].s), (yyvsp[(5) - (8)].x), (yyvsp[(7) - (8)].x)); }
    break;

  case 420:
/* Line 1787 of yacc.c  */
#line 2037 "cf-parse.y"
    {
     struct symbol *sym;
     struct f_inst *inst = (yyvsp[(3) - (4)].x);
     if ((yyvsp[(1) - (4)].s)->class != SYM_FUNCTION)
       cf_error("You can't call something which is not a function. Really.");
     DBG("You are calling function %s\n", (yyvsp[(1) - (4)].s)->name);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('c','a');
     (yyval.x)->a1.p = inst;
     (yyval.x)->a2.p = (yyvsp[(1) - (4)].s)->def;
     sym = (yyvsp[(1) - (4)].s)->aux2;
     while (sym || inst) {
       if (!sym || !inst)
	 cf_error("Wrong number of arguments for function %s.", (yyvsp[(1) - (4)].s)->name);
       DBG( "You should pass parameter called %s\n", sym->name);
       inst->a1.p = sym;
       sym = sym->aux2;
       inst = inst->next;
     }
   }
    break;

  case 421:
/* Line 1787 of yacc.c  */
#line 2060 "cf-parse.y"
    { (yyval.i) = F_QUITBIRD; }
    break;

  case 422:
/* Line 1787 of yacc.c  */
#line 2061 "cf-parse.y"
    { (yyval.i) = F_ACCEPT; }
    break;

  case 423:
/* Line 1787 of yacc.c  */
#line 2062 "cf-parse.y"
    { (yyval.i) = F_REJECT; }
    break;

  case 424:
/* Line 1787 of yacc.c  */
#line 2063 "cf-parse.y"
    { (yyval.i) = F_ERROR; }
    break;

  case 425:
/* Line 1787 of yacc.c  */
#line 2064 "cf-parse.y"
    { (yyval.i) = F_NOP; }
    break;

  case 426:
/* Line 1787 of yacc.c  */
#line 2065 "cf-parse.y"
    { (yyval.i) = F_NONL; }
    break;

  case 427:
/* Line 1787 of yacc.c  */
#line 2069 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = 'p'; (yyval.x)->a1.p = (yyvsp[(1) - (1)].x); (yyval.x)->a2.p = NULL; }
    break;

  case 428:
/* Line 1787 of yacc.c  */
#line 2072 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 429:
/* Line 1787 of yacc.c  */
#line 2073 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 430:
/* Line 1787 of yacc.c  */
#line 2074 "cf-parse.y"
    {
     if ((yyvsp[(1) - (3)].x)) {
       (yyvsp[(1) - (3)].x)->next = (yyvsp[(3) - (3)].x);
       (yyval.x) = (yyvsp[(1) - (3)].x);
     } else (yyval.x) = (yyvsp[(3) - (3)].x);
   }
    break;

  case 431:
/* Line 1787 of yacc.c  */
#line 2082 "cf-parse.y"
    { 
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (1)].x);
     (yyval.x)->next = NULL;
   }
    break;

  case 432:
/* Line 1787 of yacc.c  */
#line 2089 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = NULL;
     (yyval.x)->a2.p = (yyvsp[(1) - (3)].x);
     (yyval.x)->next = (yyvsp[(3) - (3)].x);
   }
    break;

  case 433:
/* Line 1787 of yacc.c  */
#line 2098 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 434:
/* Line 1787 of yacc.c  */
#line 2099 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (1)].x); }
    break;

  case 435:
/* Line 1787 of yacc.c  */
#line 2103 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = (yyvsp[(2) - (4)].x);
     (yyval.x)->a2.p = (yyvsp[(4) - (4)].x);
   }
    break;

  case 436:
/* Line 1787 of yacc.c  */
#line 2109 "cf-parse.y"
    {
     struct f_inst *i = f_new_inst();
     i->code = '?';
     i->a1.p = (yyvsp[(2) - (6)].x);
     i->a2.p = (yyvsp[(4) - (6)].x);
     (yyval.x) = f_new_inst();
     (yyval.x)->code = '?';
     (yyval.x)->a1.p = i;
     (yyval.x)->a2.p = (yyvsp[(6) - (6)].x);
   }
    break;

  case 437:
/* Line 1787 of yacc.c  */
#line 2119 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll set value\n" );
     if (((yyvsp[(1) - (4)].s)->class & ~T_MASK) != SYM_VARIABLE)
       cf_error( "You may set only variables." );
     (yyval.x)->code = 's';
     (yyval.x)->a1.p = (yyvsp[(1) - (4)].s);
     (yyval.x)->a2.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 438:
/* Line 1787 of yacc.c  */
#line 2128 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     DBG( "Ook, we'll return the value\n" );
     (yyval.x)->code = 'r';
     (yyval.x)->a1.p = (yyvsp[(2) - (3)].x);
   }
    break;

  case 439:
/* Line 1787 of yacc.c  */
#line 2134 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 440:
/* Line 1787 of yacc.c  */
#line 2139 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(2) - (5)].x);
     if (!(yyval.x)->a1.i)
       cf_error( "This static attribute is read-only.");
     (yyval.x)->code = P('a','S');
     (yyval.x)->a1.p = (yyvsp[(4) - (5)].x);
   }
    break;

  case 441:
/* Line 1787 of yacc.c  */
#line 2146 "cf-parse.y"
    {
     (yyval.x) = f_new_inst();
     (yyval.x)->code = P('P','S');
     (yyval.x)->a1.p = (yyvsp[(3) - (4)].x);
   }
    break;

  case 442:
/* Line 1787 of yacc.c  */
#line 2151 "cf-parse.y"
    {
     (yyval.x) = (yyvsp[(4) - (6)].x);
     (yyval.x)->aux = EAF_TYPE_UNDEF | EAF_TEMP;
     (yyval.x)->code = P('e','S');
     (yyval.x)->a1.p = NULL;
   }
    break;

  case 443:
/* Line 1787 of yacc.c  */
#line 2157 "cf-parse.y"
    { (yyval.x) = f_new_inst(); (yyval.x)->code = P('p',','); (yyval.x)->a1.p = (yyvsp[(2) - (3)].x); (yyval.x)->a2.i = (yyvsp[(1) - (3)].i); }
    break;

  case 444:
/* Line 1787 of yacc.c  */
#line 2158 "cf-parse.y"
    { (yyval.x) = (yyvsp[(1) - (2)].x); }
    break;

  case 445:
/* Line 1787 of yacc.c  */
#line 2159 "cf-parse.y"
    {
      (yyval.x) = f_new_inst();
      (yyval.x)->code = P('S','W');
      (yyval.x)->a1.p = (yyvsp[(2) - (5)].x);
      (yyval.x)->a2.p = build_tree( (yyvsp[(4) - (5)].e) );
   }
    break;

  case 446:
/* Line 1787 of yacc.c  */
#line 2167 "cf-parse.y"
    { (yyval.x) = f_generate_empty((yyvsp[(2) - (5)].x)); }
    break;

  case 447:
/* Line 1787 of yacc.c  */
#line 2168 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('A','p'), 'x', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 448:
/* Line 1787 of yacc.c  */
#line 2169 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'a', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 449:
/* Line 1787 of yacc.c  */
#line 2170 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'd', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 450:
/* Line 1787 of yacc.c  */
#line 2171 "cf-parse.y"
    { (yyval.x) = f_generate_complex( P('C','a'), 'f', (yyvsp[(2) - (8)].x), (yyvsp[(6) - (8)].x) ); }
    break;

  case 451:
/* Line 1787 of yacc.c  */
#line 2178 "cf-parse.y"
    {
  this_proto = proto_config_new(&proto_bfd, sizeof(struct bfd_config), (yyvsp[(1) - (2)].i));
  init_list(&BFD_CFG->patt_list);
  init_list(&BFD_CFG->neigh_list);

  if (bfd_cf)
    cf_error("Only one BFD instance allowed");
  bfd_cf = BFD_CFG;
}
    break;

  case 459:
/* Line 1787 of yacc.c  */
#line 2205 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct bfd_iface_config));
  init_list(&this_ipatt->ipn_list);

  BFD_IFACE->min_rx_int = BFD_DEFAULT_MIN_RX_INT;
  BFD_IFACE->min_tx_int = BFD_DEFAULT_MIN_TX_INT;
  BFD_IFACE->idle_tx_int = BFD_DEFAULT_IDLE_TX_INT;
  BFD_IFACE->multiplier = BFD_DEFAULT_MULTIPLIER;
}
    break;

  case 460:
/* Line 1787 of yacc.c  */
#line 2216 "cf-parse.y"
    { BFD_IFACE->min_rx_int = BFD_IFACE->min_tx_int = (yyvsp[(2) - (2)].i32); }
    break;

  case 461:
/* Line 1787 of yacc.c  */
#line 2217 "cf-parse.y"
    { BFD_IFACE->min_rx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 462:
/* Line 1787 of yacc.c  */
#line 2218 "cf-parse.y"
    { BFD_IFACE->min_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 463:
/* Line 1787 of yacc.c  */
#line 2219 "cf-parse.y"
    { BFD_IFACE->idle_tx_int = (yyvsp[(4) - (4)].i32); }
    break;

  case 464:
/* Line 1787 of yacc.c  */
#line 2220 "cf-parse.y"
    { BFD_IFACE->multiplier = (yyvsp[(2) - (2)].i); }
    break;

  case 465:
/* Line 1787 of yacc.c  */
#line 2221 "cf-parse.y"
    { BFD_IFACE->passive = (yyvsp[(2) - (2)].i); }
    break;

  case 470:
/* Line 1787 of yacc.c  */
#line 2235 "cf-parse.y"
    { add_tail(&BFD_CFG->patt_list, NODE this_ipatt); }
    break;

  case 471:
/* Line 1787 of yacc.c  */
#line 2238 "cf-parse.y"
    { BFD_CFG->multihop = BFD_IFACE; }
    break;

  case 472:
/* Line 1787 of yacc.c  */
#line 2242 "cf-parse.y"
    { (yyval.iface) = NULL; }
    break;

  case 473:
/* Line 1787 of yacc.c  */
#line 2243 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].s)->name); }
    break;

  case 474:
/* Line 1787 of yacc.c  */
#line 2244 "cf-parse.y"
    { (yyval.iface) = if_get_by_name((yyvsp[(2) - (2)].t)); }
    break;

  case 475:
/* Line 1787 of yacc.c  */
#line 2248 "cf-parse.y"
    { (yyval.a) = IPA_NONE; }
    break;

  case 476:
/* Line 1787 of yacc.c  */
#line 2249 "cf-parse.y"
    { (yyval.a) = (yyvsp[(2) - (2)].a); }
    break;

  case 477:
/* Line 1787 of yacc.c  */
#line 2253 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 478:
/* Line 1787 of yacc.c  */
#line 2254 "cf-parse.y"
    { (yyval.i) = (yyvsp[(2) - (2)].i); }
    break;

  case 479:
/* Line 1787 of yacc.c  */
#line 2258 "cf-parse.y"
    {
  this_bfd_neighbor = cfg_allocz(sizeof(struct bfd_neighbor));
  add_tail(&BFD_CFG->neigh_list, NODE this_bfd_neighbor);

  BFD_NEIGHBOR->addr = (yyvsp[(1) - (4)].a);
  BFD_NEIGHBOR->local = (yyvsp[(3) - (4)].a);
  BFD_NEIGHBOR->iface = (yyvsp[(2) - (4)].iface);
  BFD_NEIGHBOR->multihop = (yyvsp[(4) - (4)].i);

  if ((yyvsp[(4) - (4)].i) && (yyvsp[(2) - (4)].iface))
    cf_error("Neighbor cannot set both interface and multihop");

  if ((yyvsp[(4) - (4)].i) && ipa_zero((yyvsp[(3) - (4)].a)))
    cf_error("Multihop neighbor requires specified local address");
}
    break;

  case 480:
/* Line 1787 of yacc.c  */
#line 2277 "cf-parse.y"
    { bfd_show_sessions(proto_get_named((yyvsp[(4) - (5)].s), &proto_bfd)); }
    break;

  case 481:
/* Line 1787 of yacc.c  */
#line 2282 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_bgp, sizeof(struct bgp_config), (yyvsp[(1) - (2)].i));
     BGP_CFG->multihop = -1;	/* undefined */
     BGP_CFG->hold_time = 240;
     BGP_CFG->connect_retry_time = 120;
     BGP_CFG->initial_hold_time = 240;
     BGP_CFG->compare_path_lengths = 1;
     BGP_CFG->igp_metric = 1;
     BGP_CFG->start_delay_time = 5;
     BGP_CFG->error_amnesia_time = 300;
     BGP_CFG->error_delay_time_min = 60;
     BGP_CFG->error_delay_time_max = 300;
     BGP_CFG->enable_refresh = 1;
     BGP_CFG->enable_as4 = 1;
     BGP_CFG->capabilities = 2;
     BGP_CFG->advertise_ipv4 = 1;
     BGP_CFG->interpret_communities = 1;
     BGP_CFG->default_local_pref = 100;
     BGP_CFG->gr_mode = BGP_GR_AWARE;
     BGP_CFG->gr_time = 120;
 }
    break;

  case 484:
/* Line 1787 of yacc.c  */
#line 2308 "cf-parse.y"
    { BGP_CFG->local_as = (yyvsp[(4) - (5)].i); }
    break;

  case 485:
/* Line 1787 of yacc.c  */
#line 2309 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(3) - (6)].a); BGP_CFG->local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 486:
/* Line 1787 of yacc.c  */
#line 2310 "cf-parse.y"
    {
     if (ipa_nonzero(BGP_CFG->remote_ip))
       cf_error("Only one neighbor per BGP instance is allowed");
     if (!ipa_has_link_scope((yyvsp[(3) - (7)].a)) != !(yyvsp[(4) - (7)].iface))
       cf_error("Link-local address and interface scope must be used together");

     BGP_CFG->remote_ip = (yyvsp[(3) - (7)].a);
     BGP_CFG->iface = (yyvsp[(4) - (7)].iface);
     BGP_CFG->remote_as = (yyvsp[(6) - (7)].i);
   }
    break;

  case 487:
/* Line 1787 of yacc.c  */
#line 2320 "cf-parse.y"
    { BGP_CFG->rr_cluster_id = (yyvsp[(5) - (6)].i32); }
    break;

  case 488:
/* Line 1787 of yacc.c  */
#line 2321 "cf-parse.y"
    { BGP_CFG->rr_client = 1; }
    break;

  case 489:
/* Line 1787 of yacc.c  */
#line 2322 "cf-parse.y"
    { BGP_CFG->rs_client = 1; }
    break;

  case 490:
/* Line 1787 of yacc.c  */
#line 2323 "cf-parse.y"
    { BGP_CFG->hold_time = (yyvsp[(4) - (5)].i); }
    break;

  case 491:
/* Line 1787 of yacc.c  */
#line 2324 "cf-parse.y"
    { BGP_CFG->initial_hold_time = (yyvsp[(5) - (6)].i); }
    break;

  case 492:
/* Line 1787 of yacc.c  */
#line 2325 "cf-parse.y"
    { BGP_CFG->connect_retry_time = (yyvsp[(5) - (6)].i); }
    break;

  case 493:
/* Line 1787 of yacc.c  */
#line 2326 "cf-parse.y"
    { BGP_CFG->keepalive_time = (yyvsp[(4) - (5)].i); }
    break;

  case 494:
/* Line 1787 of yacc.c  */
#line 2327 "cf-parse.y"
    { BGP_CFG->multihop = 0; }
    break;

  case 495:
/* Line 1787 of yacc.c  */
#line 2328 "cf-parse.y"
    { BGP_CFG->multihop = 64; }
    break;

  case 496:
/* Line 1787 of yacc.c  */
#line 2329 "cf-parse.y"
    { BGP_CFG->multihop = (yyvsp[(3) - (4)].i); if (((yyvsp[(3) - (4)].i)<1) || ((yyvsp[(3) - (4)].i)>255)) cf_error("Multihop must be in range 1-255"); }
    break;

  case 497:
/* Line 1787 of yacc.c  */
#line 2330 "cf-parse.y"
    { BGP_CFG->next_hop_self = 1; BGP_CFG->next_hop_keep = 0; }
    break;

  case 498:
/* Line 1787 of yacc.c  */
#line 2331 "cf-parse.y"
    { BGP_CFG->next_hop_keep = 1; BGP_CFG->next_hop_self = 0; }
    break;

  case 499:
/* Line 1787 of yacc.c  */
#line 2332 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_SELF; }
    break;

  case 500:
/* Line 1787 of yacc.c  */
#line 2333 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_DROP; }
    break;

  case 501:
/* Line 1787 of yacc.c  */
#line 2334 "cf-parse.y"
    { BGP_CFG->missing_lladdr = MLL_IGNORE; }
    break;

  case 502:
/* Line 1787 of yacc.c  */
#line 2335 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_DIRECT; }
    break;

  case 503:
/* Line 1787 of yacc.c  */
#line 2336 "cf-parse.y"
    { BGP_CFG->gw_mode = GW_RECURSIVE; }
    break;

  case 504:
/* Line 1787 of yacc.c  */
#line 2337 "cf-parse.y"
    { BGP_CFG->compare_path_lengths = (yyvsp[(4) - (5)].i); }
    break;

  case 505:
/* Line 1787 of yacc.c  */
#line 2338 "cf-parse.y"
    { BGP_CFG->med_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 506:
/* Line 1787 of yacc.c  */
#line 2339 "cf-parse.y"
    { BGP_CFG->igp_metric = (yyvsp[(4) - (5)].i); }
    break;

  case 507:
/* Line 1787 of yacc.c  */
#line 2340 "cf-parse.y"
    { BGP_CFG->prefer_older = (yyvsp[(4) - (5)].i); }
    break;

  case 508:
/* Line 1787 of yacc.c  */
#line 2341 "cf-parse.y"
    { BGP_CFG->deterministic_med = (yyvsp[(4) - (5)].i); }
    break;

  case 509:
/* Line 1787 of yacc.c  */
#line 2342 "cf-parse.y"
    { BGP_CFG->default_med = (yyvsp[(4) - (5)].i); }
    break;

  case 510:
/* Line 1787 of yacc.c  */
#line 2343 "cf-parse.y"
    { BGP_CFG->default_local_pref = (yyvsp[(4) - (5)].i); }
    break;

  case 511:
/* Line 1787 of yacc.c  */
#line 2344 "cf-parse.y"
    { BGP_CFG->source_addr = (yyvsp[(4) - (5)].a); }
    break;

  case 512:
/* Line 1787 of yacc.c  */
#line 2345 "cf-parse.y"
    { BGP_CFG->start_delay_time = (yyvsp[(5) - (6)].i); }
    break;

  case 513:
/* Line 1787 of yacc.c  */
#line 2346 "cf-parse.y"
    { BGP_CFG->error_amnesia_time = (yyvsp[(5) - (6)].i); }
    break;

  case 514:
/* Line 1787 of yacc.c  */
#line 2347 "cf-parse.y"
    { BGP_CFG->error_delay_time_min = (yyvsp[(5) - (8)].i); BGP_CFG->error_delay_time_max = (yyvsp[(7) - (8)].i); }
    break;

  case 515:
/* Line 1787 of yacc.c  */
#line 2348 "cf-parse.y"
    { BGP_CFG->disable_after_error = (yyvsp[(5) - (6)].i); }
    break;

  case 516:
/* Line 1787 of yacc.c  */
#line 2349 "cf-parse.y"
    { BGP_CFG->enable_refresh = (yyvsp[(5) - (6)].i); }
    break;

  case 517:
/* Line 1787 of yacc.c  */
#line 2350 "cf-parse.y"
    { BGP_CFG->enable_as4 = (yyvsp[(4) - (5)].i); }
    break;

  case 518:
/* Line 1787 of yacc.c  */
#line 2351 "cf-parse.y"
    { BGP_CFG->capabilities = (yyvsp[(3) - (4)].i); }
    break;

  case 519:
/* Line 1787 of yacc.c  */
#line 2352 "cf-parse.y"
    { BGP_CFG->advertise_ipv4 = (yyvsp[(4) - (5)].i); }
    break;

  case 520:
/* Line 1787 of yacc.c  */
#line 2353 "cf-parse.y"
    { BGP_CFG->password = (yyvsp[(3) - (4)].t); }
    break;

  case 521:
/* Line 1787 of yacc.c  */
#line 2354 "cf-parse.y"
    {
     this_proto->in_limit = cfg_allocz(sizeof(struct proto_limit));
     this_proto->in_limit->limit = (yyvsp[(4) - (5)].i);
     this_proto->in_limit->action = PLA_RESTART;
   }
    break;

  case 522:
/* Line 1787 of yacc.c  */
#line 2359 "cf-parse.y"
    { BGP_CFG->passive = (yyvsp[(3) - (4)].i); }
    break;

  case 523:
/* Line 1787 of yacc.c  */
#line 2360 "cf-parse.y"
    { BGP_CFG->interpret_communities = (yyvsp[(4) - (5)].i); }
    break;

  case 524:
/* Line 1787 of yacc.c  */
#line 2361 "cf-parse.y"
    { BGP_CFG->secondary = (yyvsp[(3) - (4)].i); }
    break;

  case 525:
/* Line 1787 of yacc.c  */
#line 2362 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_RX; }
    break;

  case 526:
/* Line 1787 of yacc.c  */
#line 2363 "cf-parse.y"
    { BGP_CFG->add_path = ADD_PATH_TX; }
    break;

  case 527:
/* Line 1787 of yacc.c  */
#line 2364 "cf-parse.y"
    { BGP_CFG->add_path = (yyvsp[(4) - (5)].i) ? ADD_PATH_FULL : 0; }
    break;

  case 528:
/* Line 1787 of yacc.c  */
#line 2365 "cf-parse.y"
    { BGP_CFG->allow_local_as = -1; }
    break;

  case 529:
/* Line 1787 of yacc.c  */
#line 2366 "cf-parse.y"
    { BGP_CFG->allow_local_as = (yyvsp[(5) - (6)].i); }
    break;

  case 530:
/* Line 1787 of yacc.c  */
#line 2367 "cf-parse.y"
    { BGP_CFG->gr_mode = (yyvsp[(4) - (5)].i); }
    break;

  case 531:
/* Line 1787 of yacc.c  */
#line 2368 "cf-parse.y"
    { BGP_CFG->gr_mode = BGP_GR_AWARE; }
    break;

  case 532:
/* Line 1787 of yacc.c  */
#line 2369 "cf-parse.y"
    { BGP_CFG->gr_time = (yyvsp[(5) - (6)].i); }
    break;

  case 533:
/* Line 1787 of yacc.c  */
#line 2370 "cf-parse.y"
    { BGP_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 534:
/* Line 1787 of yacc.c  */
#line 2371 "cf-parse.y"
    { BGP_CFG->ttl_security = (yyvsp[(4) - (5)].i); }
    break;

  case 535:
/* Line 1787 of yacc.c  */
#line 2372 "cf-parse.y"
    { BGP_CFG->bfd = (yyvsp[(3) - (4)].i); cf_check_bfd((yyvsp[(3) - (4)].i)); }
    break;

  case 536:
/* Line 1787 of yacc.c  */
#line 2383 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_ospf, sizeof(struct ospf_config), (yyvsp[(1) - (2)].i));
     init_list(&OSPF_CFG->area_list);
     init_list(&OSPF_CFG->vlink_list);
     OSPF_CFG->rfc1583 = DEFAULT_RFC1583;
     OSPF_CFG->tick = DEFAULT_OSPFTICK;
  }
    break;

  case 540:
/* Line 1787 of yacc.c  */
#line 2399 "cf-parse.y"
    { OSPF_CFG->rfc1583 = (yyvsp[(2) - (2)].i); }
    break;

  case 541:
/* Line 1787 of yacc.c  */
#line 2400 "cf-parse.y"
    { OSPF_CFG->stub_router = (yyvsp[(3) - (3)].i); }
    break;

  case 542:
/* Line 1787 of yacc.c  */
#line 2401 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (2)].i) ? DEFAULT_ECMP_LIMIT : 0; }
    break;

  case 543:
/* Line 1787 of yacc.c  */
#line 2402 "cf-parse.y"
    { OSPF_CFG->ecmp = (yyvsp[(2) - (4)].i) ? (yyvsp[(4) - (4)].i) : 0; if ((yyvsp[(4) - (4)].i) < 0) cf_error("ECMP limit cannot be negative"); }
    break;

  case 544:
/* Line 1787 of yacc.c  */
#line 2403 "cf-parse.y"
    { OSPF_CFG->tick = (yyvsp[(2) - (2)].i); if((yyvsp[(2) - (2)].i)<=0) cf_error("Tick must be greater than zero"); }
    break;

  case 546:
/* Line 1787 of yacc.c  */
#line 2407 "cf-parse.y"
    {
  this_area = cfg_allocz(sizeof(struct ospf_area_config));
  add_tail(&OSPF_CFG->area_list, NODE this_area);
  this_area->areaid = (yyvsp[(2) - (2)].i32);
  this_area->default_cost = DEFAULT_STUB_COST;
  this_area->type = OPT_E;
  this_area->transint = DEFAULT_TRANSINT;

  init_list(&this_area->patt_list);
  init_list(&this_area->net_list);
  init_list(&this_area->enet_list);
  init_list(&this_area->stubnet_list);
 }
    break;

  case 547:
/* Line 1787 of yacc.c  */
#line 2422 "cf-parse.y"
    { ospf_area_finish(); }
    break;

  case 550:
/* Line 1787 of yacc.c  */
#line 2431 "cf-parse.y"
    { this_area->type = (yyvsp[(2) - (2)].i) ? 0 : OPT_E; /* We should remove the option */ }
    break;

  case 551:
/* Line 1787 of yacc.c  */
#line 2432 "cf-parse.y"
    { this_area->type = OPT_N; }
    break;

  case 552:
/* Line 1787 of yacc.c  */
#line 2433 "cf-parse.y"
    { this_area->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 553:
/* Line 1787 of yacc.c  */
#line 2434 "cf-parse.y"
    { this_area->default_nssa = (yyvsp[(3) - (3)].i); }
    break;

  case 554:
/* Line 1787 of yacc.c  */
#line 2435 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i); check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 555:
/* Line 1787 of yacc.c  */
#line 2436 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i) | LSA_EXT_EBIT; check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 556:
/* Line 1787 of yacc.c  */
#line 2437 "cf-parse.y"
    { this_area->default_cost = (yyvsp[(3) - (3)].i);  check_defcost((yyvsp[(3) - (3)].i)); }
    break;

  case 557:
/* Line 1787 of yacc.c  */
#line 2438 "cf-parse.y"
    { this_area->translator = (yyvsp[(2) - (2)].i); }
    break;

  case 558:
/* Line 1787 of yacc.c  */
#line 2439 "cf-parse.y"
    { this_area->transint = (yyvsp[(3) - (3)].i); }
    break;

  case 559:
/* Line 1787 of yacc.c  */
#line 2440 "cf-parse.y"
    { this_nets = &this_area->net_list; }
    break;

  case 561:
/* Line 1787 of yacc.c  */
#line 2441 "cf-parse.y"
    { this_nets = &this_area->enet_list; }
    break;

  case 568:
/* Line 1787 of yacc.c  */
#line 2453 "cf-parse.y"
    {
     this_stubnet = cfg_allocz(sizeof(struct ospf_stubnet_config));
     add_tail(&this_area->stubnet_list, NODE this_stubnet);
     this_stubnet->px = (yyvsp[(1) - (1)].px);
     this_stubnet->cost = COST_D;
   }
    break;

  case 571:
/* Line 1787 of yacc.c  */
#line 2467 "cf-parse.y"
    { this_stubnet->hidden = (yyvsp[(2) - (2)].i); }
    break;

  case 572:
/* Line 1787 of yacc.c  */
#line 2468 "cf-parse.y"
    { this_stubnet->summary = (yyvsp[(2) - (2)].i); }
    break;

  case 573:
/* Line 1787 of yacc.c  */
#line 2469 "cf-parse.y"
    { this_stubnet->cost = (yyvsp[(2) - (2)].i); }
    break;

  case 574:
/* Line 1787 of yacc.c  */
#line 2473 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 575:
/* Line 1787 of yacc.c  */
#line 2474 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 579:
/* Line 1787 of yacc.c  */
#line 2483 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 580:
/* Line 1787 of yacc.c  */
#line 2484 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 581:
/* Line 1787 of yacc.c  */
#line 2485 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 582:
/* Line 1787 of yacc.c  */
#line 2486 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 583:
/* Line 1787 of yacc.c  */
#line 2487 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 584:
/* Line 1787 of yacc.c  */
#line 2488 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 585:
/* Line 1787 of yacc.c  */
#line 2489 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 586:
/* Line 1787 of yacc.c  */
#line 2490 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 587:
/* Line 1787 of yacc.c  */
#line 2491 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 589:
/* Line 1787 of yacc.c  */
#line 2496 "cf-parse.y"
    {
  if (this_area->areaid == 0) cf_error("Virtual link cannot be in backbone");
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&OSPF_CFG->vlink_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->voa = this_area->areaid;
  OSPF_PATT->vid = (yyvsp[(3) - (3)].i32);
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_VLINK;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  reset_passwords();
 }
    break;

  case 590:
/* Line 1787 of yacc.c  */
#line 2517 "cf-parse.y"
    { OSPF_PATT->cost = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Cost must be in range 1-65535"); }
    break;

  case 591:
/* Line 1787 of yacc.c  */
#line 2518 "cf-parse.y"
    { OSPF_PATT->helloint = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<=0) || ((yyvsp[(2) - (2)].i)>65535)) cf_error("Hello interval must be in range 1-65535"); }
    break;

  case 592:
/* Line 1787 of yacc.c  */
#line 2519 "cf-parse.y"
    { OSPF_PATT->pollint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Poll int must be greater than zero"); }
    break;

  case 593:
/* Line 1787 of yacc.c  */
#line 2520 "cf-parse.y"
    { OSPF_PATT->rxmtint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=0) cf_error("Retransmit int must be greater than zero"); }
    break;

  case 594:
/* Line 1787 of yacc.c  */
#line 2521 "cf-parse.y"
    { OSPF_PATT->waitint = (yyvsp[(2) - (2)].i) ; }
    break;

  case 595:
/* Line 1787 of yacc.c  */
#line 2522 "cf-parse.y"
    { OSPF_PATT->deadint = (yyvsp[(2) - (2)].i) ; if ((yyvsp[(2) - (2)].i)<=1) cf_error("Dead interval must be greater than one"); }
    break;

  case 596:
/* Line 1787 of yacc.c  */
#line 2523 "cf-parse.y"
    { OSPF_PATT->deadc = (yyvsp[(3) - (3)].i) ; if ((yyvsp[(3) - (3)].i)<=1) cf_error("Dead count must be greater than one"); }
    break;

  case 597:
/* Line 1787 of yacc.c  */
#line 2524 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 598:
/* Line 1787 of yacc.c  */
#line 2525 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_BCAST ; }
    break;

  case 599:
/* Line 1787 of yacc.c  */
#line 2526 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 600:
/* Line 1787 of yacc.c  */
#line 2527 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_NBMA ; }
    break;

  case 601:
/* Line 1787 of yacc.c  */
#line 2528 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 602:
/* Line 1787 of yacc.c  */
#line 2529 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTP ; }
    break;

  case 603:
/* Line 1787 of yacc.c  */
#line 2530 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 604:
/* Line 1787 of yacc.c  */
#line 2531 "cf-parse.y"
    { OSPF_PATT->type = OSPF_IT_PTMP ; }
    break;

  case 605:
/* Line 1787 of yacc.c  */
#line 2532 "cf-parse.y"
    { OSPF_PATT->real_bcast = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real broadcast option requires OSPFv2"); }
    break;

  case 606:
/* Line 1787 of yacc.c  */
#line 2533 "cf-parse.y"
    { OSPF_PATT->ptp_netmask = (yyvsp[(3) - (3)].i); if (OSPF_VERSION != 2) cf_error("Real netmask option requires OSPFv2"); }
    break;

  case 607:
/* Line 1787 of yacc.c  */
#line 2534 "cf-parse.y"
    { OSPF_PATT->inftransdelay = (yyvsp[(3) - (3)].i) ; if (((yyvsp[(3) - (3)].i)<=0) || ((yyvsp[(3) - (3)].i)>65535)) cf_error("Transmit delay must be in range 1-65535"); }
    break;

  case 608:
/* Line 1787 of yacc.c  */
#line 2535 "cf-parse.y"
    { OSPF_PATT->priority = (yyvsp[(2) - (2)].i) ; if (((yyvsp[(2) - (2)].i)<0) || ((yyvsp[(2) - (2)].i)>255)) cf_error("Priority must be in range 0-255"); }
    break;

  case 609:
/* Line 1787 of yacc.c  */
#line 2536 "cf-parse.y"
    { OSPF_PATT->strictnbma = (yyvsp[(3) - (3)].i) ; }
    break;

  case 610:
/* Line 1787 of yacc.c  */
#line 2537 "cf-parse.y"
    { OSPF_PATT->stub = (yyvsp[(2) - (2)].i) ; }
    break;

  case 611:
/* Line 1787 of yacc.c  */
#line 2538 "cf-parse.y"
    { OSPF_PATT->check_link = (yyvsp[(3) - (3)].i); }
    break;

  case 612:
/* Line 1787 of yacc.c  */
#line 2539 "cf-parse.y"
    { OSPF_PATT->ecmp_weight = (yyvsp[(3) - (3)].i) - 1; if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("ECMP weight must be in range 1-256"); }
    break;

  case 614:
/* Line 1787 of yacc.c  */
#line 2541 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_NONE ; }
    break;

  case 615:
/* Line 1787 of yacc.c  */
#line 2542 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_SIMPLE ; }
    break;

  case 616:
/* Line 1787 of yacc.c  */
#line 2543 "cf-parse.y"
    { OSPF_PATT->autype = OSPF_AUTH_CRYPT ; }
    break;

  case 617:
/* Line 1787 of yacc.c  */
#line 2544 "cf-parse.y"
    { OSPF_PATT->rx_buffer = 0; }
    break;

  case 618:
/* Line 1787 of yacc.c  */
#line 2545 "cf-parse.y"
    { OSPF_PATT->rx_buffer = OSPF_MAX_PKT_SIZE; }
    break;

  case 619:
/* Line 1787 of yacc.c  */
#line 2546 "cf-parse.y"
    { OSPF_PATT->rx_buffer = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("Buffer size must be in range 256-65535"); }
    break;

  case 620:
/* Line 1787 of yacc.c  */
#line 2547 "cf-parse.y"
    { OSPF_PATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 621:
/* Line 1787 of yacc.c  */
#line 2548 "cf-parse.y"
    { OSPF_PATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 622:
/* Line 1787 of yacc.c  */
#line 2549 "cf-parse.y"
    { OSPF_PATT->tx_length = (yyvsp[(3) - (3)].i); if (((yyvsp[(3) - (3)].i) < OSPF_MIN_PKT_SIZE) || ((yyvsp[(3) - (3)].i) > OSPF_MAX_PKT_SIZE)) cf_error("TX length must be in range 256-65535"); }
    break;

  case 623:
/* Line 1787 of yacc.c  */
#line 2550 "cf-parse.y"
    { OSPF_PATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 624:
/* Line 1787 of yacc.c  */
#line 2551 "cf-parse.y"
    { OSPF_PATT->ttl_security = 2; }
    break;

  case 625:
/* Line 1787 of yacc.c  */
#line 2552 "cf-parse.y"
    { OSPF_PATT->bfd = (yyvsp[(2) - (2)].i); cf_check_bfd((yyvsp[(2) - (2)].i)); }
    break;

  case 626:
/* Line 1787 of yacc.c  */
#line 2553 "cf-parse.y"
    { OSPF_PATT->bsd_secondary = (yyvsp[(2) - (2)].i); }
    break;

  case 631:
/* Line 1787 of yacc.c  */
#line 2565 "cf-parse.y"
    {
   this_pref = cfg_allocz(sizeof(struct area_net_config));
   add_tail(this_nets, NODE this_pref);
   this_pref->px.addr = (yyvsp[(1) - (1)].px).addr;
   this_pref->px.len = (yyvsp[(1) - (1)].px).len;
 }
    break;

  case 633:
/* Line 1787 of yacc.c  */
#line 2575 "cf-parse.y"
    { this_pref->hidden = 1; }
    break;

  case 634:
/* Line 1787 of yacc.c  */
#line 2576 "cf-parse.y"
    { this_pref->tag = (yyvsp[(2) - (2)].i); }
    break;

  case 637:
/* Line 1787 of yacc.c  */
#line 2585 "cf-parse.y"
    { (yyval.i) = 0; }
    break;

  case 638:
/* Line 1787 of yacc.c  */
#line 2586 "cf-parse.y"
    { (yyval.i) = 1; }
    break;

  case 639:
/* Line 1787 of yacc.c  */
#line 2590 "cf-parse.y"
    {
   this_nbma = cfg_allocz(sizeof(struct nbma_node));
   add_tail(&OSPF_PATT->nbma_list, NODE this_nbma);
   this_nbma->ip=(yyvsp[(1) - (3)].a);
   this_nbma->eligible=(yyvsp[(2) - (3)].i);
 }
    break;

  case 640:
/* Line 1787 of yacc.c  */
#line 2599 "cf-parse.y"
    {
  this_ipatt = cfg_allocz(sizeof(struct ospf_iface_patt));
  add_tail(&this_area->patt_list, NODE this_ipatt);
  init_list(&this_ipatt->ipn_list);
  OSPF_PATT->cost = COST_D;
  OSPF_PATT->helloint = HELLOINT_D;
  OSPF_PATT->pollint = POLLINT_D;
  OSPF_PATT->rxmtint = RXMTINT_D;
  OSPF_PATT->inftransdelay = INFTRANSDELAY_D;
  OSPF_PATT->priority = PRIORITY_D;
  OSPF_PATT->waitint = WAIT_DMH*HELLOINT_D;
  OSPF_PATT->deadc = DEADC_D;
  OSPF_PATT->deadint = 0;
  OSPF_PATT->type = OSPF_IT_UNDEF;
  init_list(&OSPF_PATT->nbma_list);
  OSPF_PATT->autype = OSPF_AUTH_NONE;
  OSPF_PATT->ptp_netmask = 2; /* not specified */
  OSPF_PATT->tx_tos = IP_PREC_INTERNET_CONTROL;
  OSPF_PATT->tx_priority = sk_priority_control;
  reset_passwords();
 }
    break;

  case 642:
/* Line 1787 of yacc.c  */
#line 2624 "cf-parse.y"
    { set_instance_id((yyvsp[(2) - (2)].i)); }
    break;

  case 643:
/* Line 1787 of yacc.c  */
#line 2628 "cf-parse.y"
    { if (OSPF_VERSION == 3) iface_patt_check(); }
    break;

  case 649:
/* Line 1787 of yacc.c  */
#line 2642 "cf-parse.y"
    { ospf_iface_finish(); }
    break;

  case 651:
/* Line 1787 of yacc.c  */
#line 2647 "cf-parse.y"
    { (yyval.t) = NULL; }
    break;

  case 652:
/* Line 1787 of yacc.c  */
#line 2653 "cf-parse.y"
    { ospf_sh(proto_get_named((yyvsp[(3) - (4)].s), &proto_ospf)); }
    break;

  case 653:
/* Line 1787 of yacc.c  */
#line 2656 "cf-parse.y"
    { ospf_sh_neigh(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 654:
/* Line 1787 of yacc.c  */
#line 2659 "cf-parse.y"
    { ospf_sh_iface(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), (yyvsp[(5) - (6)].t)); }
    break;

  case 655:
/* Line 1787 of yacc.c  */
#line 2664 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 0, 1); }
    break;

  case 656:
/* Line 1787 of yacc.c  */
#line 2667 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 0, 0); }
    break;

  case 657:
/* Line 1787 of yacc.c  */
#line 2672 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(4) - (6)].s), &proto_ospf), 1, 1); }
    break;

  case 658:
/* Line 1787 of yacc.c  */
#line 2675 "cf-parse.y"
    { ospf_sh_state(proto_get_named((yyvsp[(5) - (7)].s), &proto_ospf), 1, 0); }
    break;

  case 659:
/* Line 1787 of yacc.c  */
#line 2679 "cf-parse.y"
    { ospf_sh_lsadb((yyvsp[(4) - (5)].ld)); }
    break;

  case 660:
/* Line 1787 of yacc.c  */
#line 2682 "cf-parse.y"
    {
     (yyval.ld) = cfg_allocz(sizeof(struct lsadb_show_data));
   }
    break;

  case 661:
/* Line 1787 of yacc.c  */
#line 2685 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = LSA_SCOPE_AS; }
    break;

  case 662:
/* Line 1787 of yacc.c  */
#line 2686 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->scope = LSA_SCOPE_AREA; (yyval.ld)->area = (yyvsp[(3) - (3)].i32); }
    break;

  case 663:
/* Line 1787 of yacc.c  */
#line 2687 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->scope = 1; /* hack, 0 is no filter */ }
    break;

  case 664:
/* Line 1787 of yacc.c  */
#line 2688 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->type = (yyvsp[(3) - (3)].i); }
    break;

  case 665:
/* Line 1787 of yacc.c  */
#line 2689 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->lsid = (yyvsp[(3) - (3)].i32); }
    break;

  case 666:
/* Line 1787 of yacc.c  */
#line 2690 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->router = SH_ROUTER_SELF; }
    break;

  case 667:
/* Line 1787 of yacc.c  */
#line 2691 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (3)].ld); (yyval.ld)->router = (yyvsp[(3) - (3)].i32); }
    break;

  case 668:
/* Line 1787 of yacc.c  */
#line 2692 "cf-parse.y"
    { (yyval.ld) = (yyvsp[(1) - (2)].ld); (yyval.ld)->name = (yyvsp[(2) - (2)].s); }
    break;

  case 669:
/* Line 1787 of yacc.c  */
#line 2698 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_pipe, sizeof(struct pipe_config), (yyvsp[(1) - (2)].i));
     PIPE_CFG->mode = PIPE_TRANSPARENT;
  }
    break;

  case 672:
/* Line 1787 of yacc.c  */
#line 2707 "cf-parse.y"
    {
     if ((yyvsp[(4) - (5)].s)->class != SYM_TABLE)
       cf_error("Routing table name expected");
     PIPE_CFG->peer = (yyvsp[(4) - (5)].s)->def;
   }
    break;

  case 673:
/* Line 1787 of yacc.c  */
#line 2712 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_OPAQUE; }
    break;

  case 674:
/* Line 1787 of yacc.c  */
#line 2713 "cf-parse.y"
    { PIPE_CFG->mode = PIPE_TRANSPARENT; }
    break;

  case 675:
/* Line 1787 of yacc.c  */
#line 2719 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_rip, sizeof(struct rip_proto_config), (yyvsp[(1) - (2)].i));
     rip_init_config(RIP_CFG);
   }
    break;

  case 678:
/* Line 1787 of yacc.c  */
#line 2728 "cf-parse.y"
    { RIP_CFG->infinity = (yyvsp[(3) - (4)].i); }
    break;

  case 679:
/* Line 1787 of yacc.c  */
#line 2729 "cf-parse.y"
    { RIP_CFG->port = (yyvsp[(3) - (4)].i); }
    break;

  case 680:
/* Line 1787 of yacc.c  */
#line 2730 "cf-parse.y"
    { RIP_CFG->period = (yyvsp[(3) - (4)].i); }
    break;

  case 681:
/* Line 1787 of yacc.c  */
#line 2731 "cf-parse.y"
    { RIP_CFG->garbage_time = (yyvsp[(4) - (5)].i); }
    break;

  case 682:
/* Line 1787 of yacc.c  */
#line 2732 "cf-parse.y"
    { RIP_CFG->timeout_time = (yyvsp[(4) - (5)].i); }
    break;

  case 683:
/* Line 1787 of yacc.c  */
#line 2733 "cf-parse.y"
    {RIP_CFG->authtype = (yyvsp[(3) - (4)].i); }
    break;

  case 685:
/* Line 1787 of yacc.c  */
#line 2735 "cf-parse.y"
    { RIP_CFG->honor = HO_ALWAYS; }
    break;

  case 686:
/* Line 1787 of yacc.c  */
#line 2736 "cf-parse.y"
    { RIP_CFG->honor = HO_NEIGHBOR; }
    break;

  case 687:
/* Line 1787 of yacc.c  */
#line 2737 "cf-parse.y"
    { RIP_CFG->honor = HO_NEVER; }
    break;

  case 689:
/* Line 1787 of yacc.c  */
#line 2742 "cf-parse.y"
    { (yyval.i)=AT_PLAINTEXT; }
    break;

  case 690:
/* Line 1787 of yacc.c  */
#line 2743 "cf-parse.y"
    { (yyval.i)=AT_MD5; }
    break;

  case 691:
/* Line 1787 of yacc.c  */
#line 2744 "cf-parse.y"
    { (yyval.i)=AT_NONE; }
    break;

  case 692:
/* Line 1787 of yacc.c  */
#line 2749 "cf-parse.y"
    { (yyval.i)=IM_BROADCAST; }
    break;

  case 693:
/* Line 1787 of yacc.c  */
#line 2750 "cf-parse.y"
    { (yyval.i)=0; }
    break;

  case 694:
/* Line 1787 of yacc.c  */
#line 2751 "cf-parse.y"
    { (yyval.i)=IM_QUIET; }
    break;

  case 695:
/* Line 1787 of yacc.c  */
#line 2752 "cf-parse.y"
    { (yyval.i)=IM_NOLISTEN; }
    break;

  case 696:
/* Line 1787 of yacc.c  */
#line 2753 "cf-parse.y"
    { (yyval.i)=IM_VERSION1 | IM_BROADCAST; }
    break;

  case 698:
/* Line 1787 of yacc.c  */
#line 2757 "cf-parse.y"
    { RIP_IPATT->metric = (yyvsp[(2) - (2)].i); }
    break;

  case 699:
/* Line 1787 of yacc.c  */
#line 2758 "cf-parse.y"
    { RIP_IPATT->mode |= (yyvsp[(2) - (2)].i); }
    break;

  case 700:
/* Line 1787 of yacc.c  */
#line 2759 "cf-parse.y"
    { RIP_IPATT->tx_tos = (yyvsp[(2) - (2)].i); }
    break;

  case 701:
/* Line 1787 of yacc.c  */
#line 2760 "cf-parse.y"
    { RIP_IPATT->tx_priority = (yyvsp[(3) - (3)].i); }
    break;

  case 702:
/* Line 1787 of yacc.c  */
#line 2761 "cf-parse.y"
    { RIP_IPATT->ttl_security = (yyvsp[(3) - (3)].i); }
    break;

  case 703:
/* Line 1787 of yacc.c  */
#line 2762 "cf-parse.y"
    { RIP_IPATT->ttl_security = 2; }
    break;

  case 708:
/* Line 1787 of yacc.c  */
#line 2776 "cf-parse.y"
    {
     this_ipatt = cfg_allocz(sizeof(struct rip_patt));
     add_tail(&RIP_CFG->iface_list, NODE this_ipatt);
     init_list(&this_ipatt->ipn_list);
     RIP_IPATT->metric = 1;
     RIP_IPATT->tx_tos = IP_PREC_INTERNET_CONTROL;
     RIP_IPATT->tx_priority = sk_priority_control;
     RIP_IPATT->ttl_security = RIP_DEFAULT_TTL_SECURITY;
   }
    break;

  case 710:
/* Line 1787 of yacc.c  */
#line 2795 "cf-parse.y"
    {
     this_proto = proto_config_new(&proto_static, sizeof(struct static_config), (yyvsp[(1) - (2)].i));
     static_init_config((struct static_config *) this_proto);
  }
    break;

  case 713:
/* Line 1787 of yacc.c  */
#line 2804 "cf-parse.y"
    { STATIC_CFG->check_link = (yyvsp[(4) - (5)].i); }
    break;

  case 714:
/* Line 1787 of yacc.c  */
#line 2805 "cf-parse.y"
    { STATIC_CFG->igp_table = (yyvsp[(4) - (5)].r); }
    break;

  case 716:
/* Line 1787 of yacc.c  */
#line 2809 "cf-parse.y"
    {
     this_srt = cfg_allocz(sizeof(struct static_route));
     add_tail(&STATIC_CFG->other_routes, &this_srt->n);
     this_srt->net = (yyvsp[(2) - (2)].px).addr;
     this_srt->masklen = (yyvsp[(2) - (2)].px).len;
  }
    break;

  case 717:
/* Line 1787 of yacc.c  */
#line 2818 "cf-parse.y"
    {
     last_srt_nh = this_srt_nh;
     this_srt_nh = cfg_allocz(sizeof(struct static_route));
     this_srt_nh->dest = RTD_NONE;
     this_srt_nh->via = (yyvsp[(2) - (3)].a);
     this_srt_nh->via_if = (yyvsp[(3) - (3)].iface);
     this_srt_nh->if_name = (void *) this_srt; /* really */
   }
    break;

  case 718:
/* Line 1787 of yacc.c  */
#line 2826 "cf-parse.y"
    {
     this_srt_nh->masklen = (yyvsp[(3) - (3)].i) - 1; /* really */
     if (((yyvsp[(3) - (3)].i)<1) || ((yyvsp[(3) - (3)].i)>256)) cf_error("Weight must be in range 1-256"); 
   }
    break;

  case 719:
/* Line 1787 of yacc.c  */
#line 2833 "cf-parse.y"
    { this_srt->mp_next = this_srt_nh; }
    break;

  case 720:
/* Line 1787 of yacc.c  */
#line 2834 "cf-parse.y"
    { last_srt_nh->mp_next = this_srt_nh; }
    break;

  case 721:
/* Line 1787 of yacc.c  */
#line 2838 "cf-parse.y"
    {
      this_srt->dest = RTD_ROUTER;
      this_srt->via = (yyvsp[(3) - (4)].a);
      this_srt->via_if = (yyvsp[(4) - (4)].iface);
   }
    break;

  case 722:
/* Line 1787 of yacc.c  */
#line 2843 "cf-parse.y"
    {
      this_srt->dest = RTD_DEVICE;
      this_srt->if_name = (yyvsp[(3) - (3)].t);
      rem_node(&this_srt->n);
      add_tail(&STATIC_CFG->iface_routes, &this_srt->n);
   }
    break;

  case 723:
/* Line 1787 of yacc.c  */
#line 2849 "cf-parse.y"
    {
      this_srt->dest = RTD_MULTIPATH;
   }
    break;

  case 724:
/* Line 1787 of yacc.c  */
#line 2852 "cf-parse.y"
    {
      this_srt->dest = RTDX_RECURSIVE;
      this_srt->via = (yyvsp[(3) - (3)].a);
   }
    break;

  case 725:
/* Line 1787 of yacc.c  */
#line 2857 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 726:
/* Line 1787 of yacc.c  */
#line 2858 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 727:
/* Line 1787 of yacc.c  */
#line 2859 "cf-parse.y"
    { this_srt->dest = RTD_BLACKHOLE; }
    break;

  case 728:
/* Line 1787 of yacc.c  */
#line 2860 "cf-parse.y"
    { this_srt->dest = RTD_UNREACHABLE; }
    break;

  case 729:
/* Line 1787 of yacc.c  */
#line 2861 "cf-parse.y"
    { this_srt->dest = RTD_PROHIBIT; }
    break;

  case 730:
/* Line 1787 of yacc.c  */
#line 2865 "cf-parse.y"
    { static_show(proto_get_named((yyvsp[(3) - (4)].s), &proto_static)); }
    break;

  case 796:
/* Line 1787 of yacc.c  */
#line 2873 "cf-parse.y"
    { bgp_check_config(BGP_CFG); }
    break;

  case 797:
/* Line 1787 of yacc.c  */
#line 2873 "cf-parse.y"
    { ospf_proto_finish(); }
    break;

  case 799:
/* Line 1787 of yacc.c  */
#line 2873 "cf-parse.y"
    { RIP_CFG->passwords = get_passwords(); }
    break;

  case 808:
/* Line 1787 of yacc.c  */
#line 2876 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_SOURCE); }
    break;

  case 809:
/* Line 1787 of yacc.c  */
#line 2876 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_KRT_METRIC); }
    break;

  case 810:
/* Line 1787 of yacc.c  */
#line 2876 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_KRT_PREFSRC); }
    break;

  case 811:
/* Line 1787 of yacc.c  */
#line 2876 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_KRT_REALM); }
    break;

  case 812:
/* Line 1787 of yacc.c  */
#line 2877 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_GEN_IGP_METRIC); }
    break;

  case 813:
/* Line 1787 of yacc.c  */
#line 2877 "cf-parse.y"
    { (yyval.x) = NULL; }
    break;

  case 814:
/* Line 1787 of yacc.c  */
#line 2878 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_ENUM_BGP_ORIGIN, EA_CODE(EAP_BGP, BA_ORIGIN)); }
    break;

  case 815:
/* Line 1787 of yacc.c  */
#line 2879 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_AS_PATH, T_PATH, EA_CODE(EAP_BGP, BA_AS_PATH)); }
    break;

  case 816:
/* Line 1787 of yacc.c  */
#line 2880 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_IP_ADDRESS, T_IP, EA_CODE(EAP_BGP, BA_NEXT_HOP)); }
    break;

  case 817:
/* Line 1787 of yacc.c  */
#line 2881 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_MULTI_EXIT_DISC)); }
    break;

  case 818:
/* Line 1787 of yacc.c  */
#line 2882 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_LOCAL_PREF)); }
    break;

  case 819:
/* Line 1787 of yacc.c  */
#line 2883 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_OPAQUE, T_ENUM_EMPTY, EA_CODE(EAP_BGP, BA_ATOMIC_AGGR)); }
    break;

  case 820:
/* Line 1787 of yacc.c  */
#line 2884 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT, T_INT, EA_CODE(EAP_BGP, BA_AGGREGATOR)); }
    break;

  case 821:
/* Line 1787 of yacc.c  */
#line 2885 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_COMMUNITY)); }
    break;

  case 822:
/* Line 1787 of yacc.c  */
#line 2886 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID, T_QUAD, EA_CODE(EAP_BGP, BA_ORIGINATOR_ID)); }
    break;

  case 823:
/* Line 1787 of yacc.c  */
#line 2887 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT_SET, T_CLIST, EA_CODE(EAP_BGP, BA_CLUSTER_LIST)); }
    break;

  case 824:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_EC_SET, T_ECLIST, EA_CODE(EAP_BGP, BA_EXT_COMMUNITY)); }
    break;

  case 825:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC1); }
    break;

  case 826:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_METRIC2); }
    break;

  case 827:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_OSPF_TAG); }
    break;

  case 828:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_ROUTER_ID | EAF_TEMP, T_QUAD, EA_OSPF_ROUTER_ID); }
    break;

  case 829:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_METRIC); }
    break;

  case 830:
/* Line 1787 of yacc.c  */
#line 2888 "cf-parse.y"
    { (yyval.x) = f_new_dynamic_attr(EAF_TYPE_INT | EAF_TEMP, T_INT, EA_RIP_TAG); }
    break;


/* Line 1787 of yacc.c  */
#line 8606 "cf-parse.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2050 of yacc.c  */
#line 2890 "cf-parse.y"

/* C Code from ../../conf/confbase.Y */

/* C Code from ../../sysdep/unix/config.Y */

/* C Code from ../../sysdep/unix/krt.Y */

/* C Code from ../../sysdep/linux/netlink.Y */

/* C Code from ../../nest/config.Y */

/* C Code from ../../proto/bfd/config.Y */

/* C Code from ../../proto/bgp/config.Y */

/* C Code from ../../proto/ospf/config.Y */

/* C Code from ../../proto/pipe/config.Y */

/* C Code from ../../proto/rip/config.Y */

/* C Code from ../../proto/static/config.Y */

